#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "config.h"
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "error.h"
#include "o_hash.h"
/*
 * Write statistics about objects on file.
 */

extern void add_message();

static int svalue_size(v)
    struct svalue *v;
{
    int i, total;

    switch(v->type) {
    case T_OBJECT:
    case T_INT:
	case T_FLOAT:
		return 0;
    case T_STRING:
	return strlen(v->u.string) + 4; /* Includes some malloc overhead. */
    case T_POINTER:
	for (i=0, total = 0; i < v->u.vec->size; i++) {
	    total += svalue_size(&v->u.vec->item[i]) + sizeof (struct svalue);
	}
	return total;
    default:
	fatal("Illegal type: %d\n", v->type);
    }
}

static int data_size(ob)
    struct object *ob;
{
    struct svalue *v;
    int total = 0, i;

    for (i = 0; i < ob->num_variables; i++)
	total += svalue_size(&ob->variables[i]) + sizeof (struct svalue);
    return total;
}

void dumpstat() {
    FILE *f;
    struct object *ob;
    int i;
    struct o_table_entry *tmp;

    f = fopen("info/OBJ_DUMP", "w");

    if(!f && errno == EMFILE) fatal("Max files open.\n");

    if (!f) return;
    add_message("Dumping to info/OBJ_DUMP ...");
   for(i=0;i<cf.otable;i++)
     for(tmp=o_table[i];tmp;tmp=tmp->next)  
	  {     ob=tmp->ob;
		(void)fprintf(f, "%-40s %5d %s %s\n", ob->name,
		data_size(ob) + sizeof (struct object),
		ob->links[1] ? "HB" : "  ",
		ob->ref_ob[0] ? ob->ref_ob[0]->name : "--");
    }
    add_message("done.\n");
    (void)fclose(f);
}
