	/* next error will still return 1 by default */
%{

/*  Edit the lexical.c by hand  adding the following code if you wish to 
    avoid a lex error that will crash the game. (I have no idea if this is
    needed for users of flex)

    Put this just before the two input()'s in yylook.

			if(strlen(yytext)>YYLMAX || yychar_count>=YYLMAX)
  			 {
			     yyerror("Line to long.  Max Length: %d.",YYLMAX);
			     yychar_count=0;
			     return(0);
  			 }

    Put this just after an input()

			if(yych==10 || yych<1) yychar_count=0;
			   else yychar_count++;

    Put this just after each unput()

		        yychar_count--;

    And when you test for EOF or set yytext[0]=0; do

			yychar_count=0;

    I also recomend changing YYLMAX from 200 to 256.

    If you don't or you choose a diffent number you should change the ed.c
    to reflect this number.
*/

#ifndef M_XENIX
#include <stdlib.h>
#endif
#include <math.h>
#include "lint.h"
#include "config.h"
#include "y.tab.h"
#include "string.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "error.h"
#include "lan_fun.h"
#include "lex.h"
#include "realms.h"

extern void yyerror();
int lookup_resword();

int yylook();

int yywrap() { return 1; }

#ifdef YYLMAX
# undef YYLMAX
# define YYLMAX 256
#endif

/*
 * Flex doesn't handle negative characters, but this change will at least
 * not crash the game.
 */
#ifdef YY_FATAL_ERROR
#undef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) \
	{ \
	fputs( msg, stderr ); \
	putc( '\n', stderr ); \
	(void)fclose(yyin); \
	error(extract_realm(current_file),msg); \
	}
#endif

#define RESBIT 0x4000

extern struct object_status *ob_status[];
extern int current_line;

int total_lines;	/* Used to compute average compiled lines/s */
char *current_file;
extern char *argument_name;
int number(), ident(), string();
static int lookupword();
static int islocal();

extern char **local_names;
extern unsigned char current_number_of_locals;

extern char *string_copy();

void pre_processor_info();
%}
%%
":" { return ':'; }
"?" { return '?'; }
";"	{ return ';'; }
"("	{ return '('; }
")"	{ return ')'; }
","	{ return ','; }
"{"	{ return '{'; }
"}"	{ return '}'; }
"++"	{ return F_INC; }
"--"	{ return F_DEC; }
"~"	{ return '~'; }
"&"	{ return '&'; }
"&="	{ return F_AND_EQ; }
"|"	{ return '|'; }
"|="	{ return F_OR_EQ; }
"^"	{ return '^'; }
"^="	{ return F_XOR_EQ; }
"<<"	{ return F_LSH; }
"<<="	{ return F_LSH_EQ; }
">>"	{ return F_RSH; }
">>="	{ return F_RSH_EQ; }
"!"	{ return F_NOT; }
"&&"	{ return F_LAND; }
"||"	{ return F_LOR; }
"->"	{ return F_ARROW; }
"="	{ return '='; }
"-"	{ return '-'; }
"-="	{ return F_SUB_EQ; }
"+"	{ return '+'; }
"+="	{ return F_ADD_EQ; }
"*"	{ return '*'; }
"*="	{ return F_MULT_EQ; }
"%"	{ return '%'; }
"%="	{ return F_MOD_EQ; }
"/"	{ return '/'; }
"/="	{ return F_DIV_EQ; }
"<"	{ return '<'; }
">"	{ return '>'; }
">="	{ return F_GE; }
"<="	{ return F_LE; }
"=="	{ return F_EQ; }
"!="	{ return F_NE; }
".."	{ return F_DOT_DOT; }
"::"	{ return F_COLON_COLON; }
[_a-zA-Z][-_a-zA-Z0-9/]*[:][:] { yylval.string = string_copy(yytext);
    			        return F_OBJECT_NAME; }
^#.*$	{ pre_processor_info(yytext); }
"["	{ return '['; }
"]"	{ return ']'; }
'.' { yylval.lnode=(struct lnode *)alloc_lnode_number(f_int,yytext[1],0.0); return F_INT; }
\\0[0-7]+ { return number(yytext,2); }
'\\.' { 
	      char esc[2];

	      esc[1]=0;

              switch(yytext[2])
		{
		case 'n': 
			esc[0]='\n';
			break;
		case 't':
			esc[0]='\t';
			break;
		case 'b':
			esc[0]='\b';
			break;
		case 'f':
			esc[0]='\f';
			break;
		case 'r':
			esc[0]='\r';
			break;
	         default:
			esc[0]=yytext[2];
		}


              yylval.lnode=(struct lnode *)alloc_lnode_number(f_int,esc[0],0.0); 

              return F_INT;
            }
[0-9]+ { return number(yytext,0); }
0"x"[0-9A-Fa-f]+ { return number(yytext,1); }
[0-9]+"."[0-9]+ { return number(yytext,0); }
[0-9]+"."[0-9]+(e|E)("+"|"-")[0-9]+  { return number(yytext,0); }
[_a-zA-Z][_a-zA-Z0-9]* { 
          int r;

          r = lookup_resword(yytext);
          if (r >= 0) return r;

	  return ident(yytext);
        }
\"([^"\n]|\\\")*\"    { return string(yytext); }
[\t ]	{ break;}
\/\/.*\n     { current_line++;
	  if (current_line & L_MASK) {
	      yyerror("Too many lines.");
	  }
	  total_lines++;
	}
"\n"	{ current_line++;
	  if (current_line & L_MASK) {
	      yyerror("Too many lines.");
	  }
	  total_lines++;
	}
.	{ yyerror("Illegal character '%c'", yytext[0]); }
%%

char *xalloc();

extern YYSTYPE yylval;

static int islocal(str)
    char *str;
{
    int i;

    for (i=current_number_of_locals-1; i>=0; i--) {
	if (strcmp(local_names[i], str) == 0)
            return i;
    }
    return -1;
}

int ident(str)
    char *str;
{
    int i;
   
    i = islocal(str);
    if (i >= 0) {
        yylval.lnode = (struct lnode *)alloc_lnode_number(f_local_name, i,0.00000);
        return F_LOCAL_NAME;
    }
    if (argument_name && strcmp(str, argument_name) == 0)
	return F_ARGUMENT;

    yylval.string = string_copy(str);

    return F_IDENTIFIER;
}

int string(str)
    char *str;
{
    char *p;

    p = xalloc(strlen(str) - 1);
    yylval.string = p;
    for (str++; str[1] != '\0'; str++, p++) {
	if (str[0] == '\\' && str[1] == 'n') {
	    *p = '\n';
	    str++;
	} else if (str[0] == '\\' && str[1] == 't') {
	    *p = '\t';
	    str++;
	} else if(str[0]=='\\' && str[1]=='b') {
		*p= '\b';
		str++;
	} else if(str[0]=='\\' && str[1]=='f') {
		*p='\f';
		str++;
	} else if(str[0]=='\\' && str[1]=='r') {
		*p='\r';
		str++;
	} else if (str[0] == '\\' && str[1] == '"') {	/* LA */
	    *p = '"';					/* LA */
	    str++;					/* LA */
	    if (!str[1]) {
		yyerror("Unterminated string");
		break;
	    }
	} else if (str[0] == '\\') {
	    *p = str[1];
	    str++;
	} else
	    *p = *str;
    }
    *p = '\0';
    return F_STRING;
}

int number(str,flag)
    char *str;
    char flag;
{
    double i;

    if(flag)
     {
	int hex_oct=0;

        if(flag==1) (void)sscanf(str,"0x%x",&hex_oct);
	  else { str+=2; (void)sscanf(str,"%o",&hex_oct); }
        yylval.lnode=(struct lnode *)alloc_lnode_number(f_int,hex_oct,0.0);
        return F_INT;
     }

    i = atof(str);
	if(!strchr(str,'.'))
	 {
    	if (!i) 
		  {
        	yylval.lnode = (struct lnode *)alloc_lnode_single(f_const0);
			return F_CONST0;
          }
		else if (i == 1.0) 
		  {
			yylval.lnode = (struct lnode *)alloc_lnode_single(f_const1);
			return F_CONST1;
          }
        if(i>=(double)MIN_INT && i<=(double)MAX_INT) 
  	  {
#if defined(M_XENIX) && !defined(M_UNIX)
		int atoi PROT((char *));
#endif
	    	yylval.lnode=(struct lnode *)alloc_lnode_number(f_int,atoi(str),0.0);
		return F_INT;
          }
     }
    yylval.lnode =(struct lnode *)alloc_lnode_number(f_float,0,i);
    return F_FLOAT;
}

void start_new_file(f)
    FILE *f;
{
    extern int num_parse_error;
    extern struct lnode_def *current_functions;
    extern int num_arg;
    extern struct lnode *prog;
    extern unsigned short variable_count;
    extern char *inherit_file;
    extern unsigned char var_flags;
    extern unsigned short object_flags;
    extern struct inherit_list *new_inherit_list;
    extern struct lnode_funcall *funcall_list;
    extern int syntax_error;
    int i;
#ifdef lex
    extern int yyprevious;	/* KLUDGE! */

    NLSTATE;
    yysptr = yysbuf;
#endif

#ifdef flex
	yy_init =1;
#endif
    yyin = f;
    for(i=0;i<cf.max_local;i++)
	local_names[i]=0;

	syntax_error=0;
	var_flags=0;
	total_lines=0;
        funcall_list=0;
	object_flags=1;
	prog_status=0;
	num_parse_error=0;
	current_functions=0;
	num_arg=0;
	current_line=0;
	argument_name=0;
	current_number_of_locals=0;
	prog=0;
	variable_count=0;
	argument_name=0;
	current_file=0;
	inherit_file=0;
	new_inherit_list=0;
}

void pre_processor_info(str)
    char *str;
{
    int line;
    int i;
    char file[100];
    extern struct object *find_object2 PROT((char *,int));
    extern char *check_file_name PROT((char *,int,int));

    if (sscanf(str, "# %d \"%s\"", &line, file) != 2) return;

    current_line = line - 1;

    i=strlen(file)-1;

    if(file[i]=='"') file[i]=0;

    if(file[0]=='/')
      {
	if(mcp.ob)
  	  {
		VALUE *ret,v;
		jmp_buf erc;
		struct jmp_globals jmp;

    		if(strncmp(file,cf.mud_lib,strlen(cf.mud_lib))) 
     	          {
			yyerror("Illegal to include file: %s\n",file);
			return;
	  	  }

		v.type=T_STRING;
		v.u.string= &file[strlen(cf.mud_lib)];

	        set_jump_state(erc,&jmp);
		if(!setjmp(error_recovery_context)) 
		    ret=apply(mcp.fun_p[2],0,mcp.ob,&v,0);
	   	   else {ret= &const0,clear_jump_state(&jmp);}

         	reset_jump_state(erc);
		if(strchk(ret,1))
		  {
			 yyerror("Invalid include file: %s\n",v.u.string);
			 return;
		  }

		if(!check_file_name(ret->u.string,0,0))
   	  	  {
		    char realm_include[100];
		    REALMS *realm;
		    extern REALMS *extract_realm PROT((char *));

	            realm=extract_realm(current_file);
		    if(realm) (void)sprintf(realm_include,"/%s/include/",realm->realm_dir);	
 		    if(strncmp(ret->u.string,"/include/",9) && (realm &&
		       strncmp(ret->u.string,realm_include,strlen(realm_include))))
		      {
			yyerror("Invalid include file: %s\n",ret->u.string+1);
		    	return;
		      }
	           }

		 (void)strcpy(file,ret->u.string+1);
	      }
       }

    free(current_file);
    current_file = string_copy(file);
}

static struct keyword predefs[] = {
{ "abs",		F_ABS,			f_abs, },
{ "add_action",		F_ADD_ACTION,		f_add_action, },
{ "add_realm",		F_ADD_REALM,		f_add_realm, },
{ "add_sort",		F_ADD_SORT,		f_add_sort, },
{ "add_worth",		F_ADD_WORTH,		f_add_worth, },
{ "all_inventory",	F_ALL_INVENTORY,	f_all_inventory, },
{ "allocate",		F_ALLOCATE,		f_allocate, },
{ "atof",		F_ATOF,			f_atof, },
{ "atoi",		F_ATOI,			f_atoi, },
{ "block_shouts",	F_BLOCK_SHOUTS,		f_block_shouts, },
{ "bsearch_array",	F_BSEARCH_ARRAY,	f_bsearch_array, },
{ "call_other",		F_CALL_OTHER,		f_call_other, },
{ "call_out",		F_CALL_OUT,		f_call_out, },
{ "capitalize",		F_CAPITALIZE,		f_capitalize, },
{ "cast",		F_CAST,			f_cast, },
{ "cat",		F_CAT,			f_cat, },
{ "clear_bit",		F_CLEAR_BIT,		f_clear_bit, },
{ "ceil",		F_CEIL,			f_ceil, },
{ "clone_object",	F_CLONE_OBJECT,		f_clone_object, },
{ "command",		F_COMMAND,		f_command, },
{ "cp",			F_CP,			f_cp, },
{ "creator",		F_CREATOR,		f_creator, },
{ "crypt",		F_CRYPT,		f_crypt, },
{ "ctime",		F_CTIME,		f_ctime, },
{ "del_element",	F_DEL_ELEMENT,		f_del_element, },
{ "destruct",		F_DESTRUCT,		f_destruct, },
{ "ed",			F_ED,			f_ed, },
{ "enable_commands",	F_ENABLE_COMMANDS,	f_enable_commands, },
{ "environment",	F_ENVIRONMENT,		f_environment, },
{ "exp",		F_EXP,			f_exp, },
{ "explode",		F_EXPLODE,		f_explode, },
{ "extract",		F_EXTRACT,		f_extract, },
{ "fabs",		F_FABS,			f_fabs, },
{ "file_name",		F_FILE_NAME,		f_file_name, },
{ "file_size",		F_FILE_SIZE,		f_file_size, },
{ "find_link",		F_FIND_LINK,		f_find_link, },
{ "find_living",	F_FIND_LIVING,		f_find_living, },
{ "find_object",	F_FIND_OBJECT,		f_find_object, },
{ "find_player",	F_FIND_PLAYER,		f_find_player, },
{ "first_inventory",	F_FIRST_INVENTORY,	f_first_inventory, },
{ "floor",		F_FLOOR,		f_floor, },
{ "fmod",		F_FMOD,			f_fmod, },
{ "grep",		F_GREP,			f_grep, },
{ "hash",		F_HASH,			f_hash, },
{ "implode",		F_IMPLODE,		f_implode, },
{ "input",		F_INPUT_TO,		f_input_to, },
{ "itoc",		F_ITOC,			f_itoc, },
{ "last_inventory",	F_LAST_INVENTORY,	f_last_inventory, },
{ "living",		F_LIVING,		f_living, },
{ "localcmd",		F_LOCALCMD,		f_localcmd, },
{ "log_file",		F_LOG_FILE,		f_log_file, },
{ "log_object",		F_LOG_OBJECT,		f_log_object, },
{ "lower_case",		F_LOWER_CASE,		f_lower_case, },
{ "ls",			F_LS,			f_ls, },
{ "mkdir",		F_MKDIR,		f_mkdir, },
{ "move_object",	F_MOVE_OBJECT,		f_move_object, },
{ "mv",			F_MV,			f_mv, },
{ "new_player",		F_NEW_PLAYER,		f_new_player, },
{ "next_inventory",	F_NEXT_INVENTORY,	f_next_inventory, },
{ "notify_fail",	F_NOTIFY_FAIL,		f_notify_fail, },
{ "ntoa",		F_NTOA,			f_ntoa, },
{ "numberp",		F_NUMBERP,		f_numberp, },
{ "objectp",		F_OBJECTP,		f_objectp, },
{ "pointerp",		F_POINTERP,		f_pointerp, },
{ "pow",		F_POW,			f_pow, },
{ "present",		F_PRESENT,		f_present, },
{ "previous_inventory",	F_PREVIOUS_INVENTORY,	f_previous_inventory, },
{ "previous_object",	F_PREVIOUS_OBJECT,	f_previous_object, },
{ "query_call_out",	F_QUERY_CALL_OUT,	f_query_call_out, },
{ "query_ed",		F_QUERY_ED,		f_query_ed, },
{ "query_host_name",	F_QUERY_HOST_NAME,	f_query_host_name, },
{ "query_idle",		F_QUERY_IDLE,		f_query_idle, },
{ "query_ip_number",	F_QUERY_IP_NUMBER,	f_query_ip_number, },
{ "query_light",	F_QUERY_LIGHT,		f_query_light, },
{ "query_load_average",	F_QUERY_LOAD_AVERAGE,	f_query_load_average, },
{ "query_port_number",	F_QUERY_PORT_NUMBER,	f_query_port_number, },
{ "query_prompt",	F_QUERY_PROMPT,		f_query_prompt, },
{ "query_realm",	F_QUERY_REALM,		f_query_realm, },
{ "query_snoop",	F_QUERY_SNOOP,		f_query_snoop, },
{ "query_verb",		F_QUERY_VERB,		f_query_verb, },
{ "random",		F_RANDOM,		f_random, },
{ "read_file",		F_READ_FILE,		f_read_file, },
{ "realm_list",		F_REALM_LIST,		f_realm_list, },
{ "remove_all_verbs",	F_REMOVE_ALL_VERBS,	f_remove_all_verbs, },
{ "remove_call_out",	F_REMOVE_CALL_OUT,	f_remove_call_out, },
{ "remove_verb",	F_REMOVE_VERB,		f_remove_verb, },
{ "restore_inventory",	F_RESTORE_INVENTORY,	f_restore_inventory, },
{ "restore_object",	F_RESTORE_OBJECT,	f_restore_object, },
{ "rm",			F_RM,			f_rm, },
{ "rmdir",		F_RMDIR,		f_rmdir, },
{ "save_inventory",	F_SAVE_INVENTORY,	f_save_inventory, },
{ "save_object",	F_SAVE_OBJECT,		f_save_object, },
{ "say",		F_SAY,			f_say, },
{ "search_array",	F_SEARCH_ARRAY,		f_search_array, },
{ "set_bit",		F_SET_BIT,		f_set_bit, },
{ "set_heart_beat",	F_SET_HEART_BEAT,	f_set_heart_beat, },
{ "set_light",		F_SET_LIGHT,		f_set_light, },
{ "set_living_name",	F_SET_LIVING_NAME,	f_set_living_name, },
{ "set_prompt",		F_SET_PROMPT,		f_set_prompt, },
{ "set_realm",		F_SET_REALM,		f_set_realm, },
{ "shout",		F_SHOUT,		f_shout, },
{ "shutdown",		F_SHUTDOWN,		f_shutdown, },
{ "shutting_down",	F_SHUTTING_DOWN,	f_shutting_down, },
{ "sizeof",		F_SIZEOF,		f_sizeof, },
{ "slice_array",	F_SLICE_ARRAY,		f_slice_array, },
{ "snoop",		F_SNOOP,		f_snoop, },
{ "sort_array",		F_SORT_ARRAY,		f_sort_array, },
{ "sprintf",		F_SPRINTF,		f_sprintf, },
{ "sqrt",		F_SQRT,			f_sqrt, },
{ "sscanf",		F_SSCANF,		f_sscanf, },
{ "strchr",		F_STRCHR,		f_strchr, },
{ "stringp",		F_STRINGP,		f_stringp, },
{ "strlen",		F_STRLEN,		f_strlen, },
{ "strncmp",		F_STRNCMP,		f_strncmp, },
{ "strrchr",		F_STRRCHR,		f_strrchr, },
{ "strstr",		F_STRSTR,		f_strstr, },
{ "swap",		F_SWAP,			f_swap, },
{ "system",		F_SYSTEM,		f_system, },
{ "tail",		F_TAIL,			f_tail, },
{ "tell_object",	F_TELL_OBJECT,		f_tell_object, },
{ "tell_room",		F_TELL_ROOM,		f_tell_room, },
{ "test_bit",		F_TEST_BIT,		f_test_bit, },
{ "test_player",	F_TEST_PLAYER,		f_test_player, },
{ "this_object",	F_THIS_OBJECT,		f_this_object, },
{ "this_player",	F_THIS_PLAYER,		f_this_player, },
{ "time",		F_TIME,			f_time, },
{ "type",		F_TYPE,			f_type, },
{ "upper_case",		F_UPPER_CASE,		f_upper_case, },
{ "used_object",	F_USED_OBJECT,		f_used_object, },
{ "users",		F_USERS,		f_users, },
{ "verb_matching",	F_VERB_MATCHING,	f_verb_matching, },
{ "version",		F_VERSION,		f_version, },
{ "wizlist",		F_WIZLIST,		f_wizlist, },
{ "write",		F_WRITE,		f_write, },
{ "write_file",		F_WRITE_FILE,		f_write_file, },
};
#define NELEM(a) (sizeof (a) / sizeof (a)[0])

static struct keyword reswords[] = {
{ "break",	F_BREAK,	0, },
{ "case",	F_CASE,		0, },
{ "continue",	F_CONTINUE,	0, },
{ "default",	F_DEFAULT,	0, },
{ "do",		F_DO,		0, },
{ "else",	F_ELSE,		0, },
{ "float",	F_FLOAT_DECL,	0, },
{ "for",	F_FOR,		0, },
{ "force_reset",F_RESET,	0, },
{ "global",	F_GLOBAL,	0, },
{ "if",		F_IF,		0, },
{ "inherit",	F_INHERIT,	0, },
{ "int",	F_INT_DECL,	0, },
{ "mixed",	F_MIXED,	0, },
{ "no_clone",	F_NO_CLONE,	0, },
{ "no_ext_save",F_NO_EXT_SAVE,	0, },
{ "nomask",	F_NO_MASK,	0, },
{ "object",	F_OBJECT,	0, },
{ "pointer",	F_POINTER,	0, },
{ "private",	F_PRIVATE,	0, },
{ "return",	F_RETURN,	0, },
{ "static",	F_STATIC,	0, },
{ "string",	F_STRING_DECL,	0, },
{ "switch",	F_SWITCH,	0, },
{ "void",	F_VOID,		0, },
{ "while",	F_WHILE,	0, },
};

int lookup_resword(s)
char *s;
{
    int h=NELEM(reswords);
    int i, l, r;

    l = 0;
    while(1) {
      i = (l+h)/2;
      r = strcmp(s, reswords[i].word);
      if (r == 0)
          return reswords[i].token;
      else if (l == i)
          return -1;
      else if (r < 0)
          h = i;
      else
          l = i;
    }
}



struct value *(*lookup_predef(s))()
    char *s;
{
    int h=NELEM(predefs);
    int i, l, r;

    l = 0;
    while(1) {
      i = (l+h)/2;
      r = strcmp(s, predefs[i].word);
      if (r == 0)
          return predefs[i].fun;
      else if (l == i)
          return 0;
      else if (r < 0)
          h = i;
      else
          l = i;
    }
}
