#include <stdio.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include "config.h"
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "realms.h"
#include "lang.h"
#include "wiz_list.h"
#include "error.h"
#include "init.h"

struct value const0, const1;

extern char *malloc PROT((int));

extern unsigned mem_used();

extern struct lnode *prog;

extern load_config PROT(( char * ));

double consts[5];

long start_time;

extern char in_fatal;

extern void abort();
extern void fatal();

int *port_arrays;

int main(argc, argv)
    int argc;
    char **argv;
{
    extern long current_time;
    int i;
    extern int atoi PROT((char *));
    extern int chdir PROT((char *));
    extern void compute_lnode_size();
    extern void backend();

    current_time=start_time=time(0l);

    if (argc >= 2) load_config(argv[1]);
	else load_config("config.uri");

    call_inits();

    port_arrays=(int *)xalloc(sizeof (int) * cf.port_numbers);

    (void)chdir(cf.mud_lib);

    for (i=0; i < sizeof consts / sizeof consts[0]; i++)
	consts[i] = exp(- i / 900.0);
#if 0
    init_constant_lnodes();
#endif
    compute_lnode_size();
    load_realm_file();
    load_wiz_file();
    const0.type = T_INT;
    const0.u.n_int = 0;
    const1.type = T_INT;
    const1.u.n_int = 1;
    backend();
    return 0;
}

char *string_copy(str)
    char *str;
{
    char *p;

    if(str)
      {
         p = xalloc(strlen(str)+1);
         (void)strcpy(p, str);
      }
    else 
      {
         p=xalloc(2);
         (void)strcpy(p,"\0");
      }
    return p;
}

char new_error=0;
/*VARARGS1*/
void debug_message(realm, a, b, c, d, e, f, g, h, i, j)
    struct realms *realm;
    char *a;
    int b, c, d, e, f, g, h, i, j;
{
    char deb[100];

   if(in_fatal) return;

   if(!realm) realm=sys_realm;

#if 0
   if(new_error) (void)fprintf(stdout,"\n");
   (void)fprintf(stdout,a,b,c,d,e,f,g,h,i,j);
   fflush(stdout);
#endif

    if(realm->fp==NULL) 
      {
        if(realm==sys_realm) (void)strcpy(deb,cf.log);
	   else (void)sprintf(deb,"%s/%s",realm->realm_dir,cf.log);

        realm->fp = fopen(deb, "w");
        if (realm->fp == NULL) 
	  {
	    perror(deb);
	    (void)abort();
	  }
      }
    if(new_error) (void)fprintf(realm->fp,"\n");
    (void)fprintf(realm->fp, a, b, c, d, e, f, g, h, i, j);
    (void)fflush(realm->fp);

    new_error=0;
}

#ifdef malloc
#undef malloc
#endif

char slow_shut_down_to_do = 0;
char using_max_mem = 0;

char *xalloc(size)
    int size;
{
    char *p;

    if(size==0) fatal("Tried to allocate 0 bytes.\n");
    if(size< 0) fatal("Tried to allocate negative bytes.\n");

    if (cf.max_mem && mem_used()>=cf.max_mem && !using_max_mem)
     {
	VALUE *arg=0;
 	OBJECT *ob=0;

	extern void shutdowngame();
	extern void shout_string();

	using_max_mem=1;

	shout_string("Allocated Memory has been used up.\n",1);
	debug_message(sys_realm,"Allocated Memory has been used up.\n");

	ob=find_object2("closed/shut",1);

        if(ob) arg=apply(0,"shut",ob,make_number(5,0.0,0),0);

        if(!ob || numchk(arg,T_INT) || !arg->u.n_int)
         {
	  shout_string("Unable to do a delayed shutdown.  Shutingdown NOW!!\n",1);
	  debug_message(sys_realm,"Unable to do delayed shutdown.\n");
   	  shutdowngame(0);
	 }
     }

    p = (char *) malloc(size);
    if (!p)
      {
	debug_message(sys_realm,"Out of MEMORY.\n");
	exit(2);
      }
    return p;
}
