inherit "r1/obj/player";
#include "doc_path.h"
#include "wizard.h"

#define MCP "r1/closed/mcp"

private;
no_ext_save;

#define MAX_SCAR	10
#define CHUNK 22

int no_room_names;
int is_blocked;    		/* Used by Wiz_block */

string access_list;		/* What extra directories can be modified */
string msghome;			/* Wizard home message. */
string msgclone;
string msgdest;
static string invis_name;	/* Wizards invisable name. */
int news_file;

static finnish3()
{
    if(!msgclone) msgclone="clones an item.";
    if(!msghome)  msghome="goes home.";
    if(!msgdest) msgdest="destructs an item.";

    wiz_commands();
    if(file_size("/r1/news/WIZNEWS")!=news_file)
         write("\nThere has been a news update.  Type 'wiznews' to read it.\n\n");

    if (is_invis && wiz_level < SENIORE) vis();
    if(is_invis) 
	  {
		 is_invis=0;
		 invis();
	  }
    if(block_tells && !is_invis) write("\nTELLS FROM LOWER LEVEL USERS ARE BLOCKED!\n");
    if(block_sh)
     {
       block_shouts(1); 
       write("\nALL SHOUTS ARE BLOCKED!\n");
     }
    if(use_light) write("\nYOU CAN SEE IN THE DARK!\n");
    if(is_blocked) write("\nYOU ARE BLOCKING THE WIZCHANNEL!\n");
    if(no_room_names) write("\nYOU DO NOT SEE ROOM NAMES!\n");
    if(!current_path) current_path = "r1/w/" + user_name;

    r1/obj/player::finnish3();
}

/* Enable other objects to query our hit point. */

short() 
{
    string to_return;

    if(is_invis) 
	  {
        if(this_player()->query_wiz_level()<wiz_level) return;
          else to_return = "("+capitalize(name)+")";
      }
	 else if (ghost) to_return = "The ghost of " + cap_name;
    	  else to_return = cap_name + " " + title + " (" + alignment + ")";
    if(query_ip_number(this_object()) && query_idle(this_object())/60)
      to_return += " {"+(query_idle(this_object())/60)+"}";
    if(to_return) 
        if(query_ed(this_object())) to_return = "[ "+to_return+" ]";
    if(query_verb() != "who" && query_verb() != "swho" && attacker &&
      present(attacker))
        to_return += " *Fighting "+attacker->query_name()+"*";
    return to_return;
}

long() 
{
    string cap_pronoun;
    string long_ds;

    if(is_invis && this_player()->query_wiz_level()<wiz_level) return;
    cap_pronoun = capitalize(query_gender_string(1));
    long_ds=short() + ".\n";
    if (ghost) return "";
    long_ds+=show_scar();
    if (hit_points[0] < hit_points[1]/10)
		long_ds+=cap_pronoun + " is in very bad shape.\n";
      else if (hit_points[0] < hit_points[1]/5) 
			  long_ds+=cap_pronoun + " is in bad shape.\n";
    	else if (hit_points[0] < hit_points[1]/2) 
		  	    long_ds+=cap_pronoun + " is not in a good shape.\n";
    	  else if (hit_points[0] < 3*hit_points[1]/4) 
				  long_ds+=cap_pronoun + " is slightly hurt.\n";
    		else long_ds+=cap_pronoun + " is in good shape.\n";
    if(descript) long_ds+=descript+"\n";

    return long_ds;
}

/* Identify ourself. */

id(str, lvl)
{
    if(wiz_level < JUNOR || (wiz_level>=JUNOR && !is_invis))
	  if(str == name || str == "the ghost of " + name) return 1;
		else return 0;

    /*
	   This is for invisable wizards.
	 */

    if (lvl && is_invis && lvl < wiz_level) return 0;
	if(!this_player()) return 0;
    if(this_player()->query_wiz_level() >= ADMIN &&
	   (name=="str" || name=="ghost of "+name)) return 1;
    if (is_invis)
	 if(this_player()->query_wiz_level()<wiz_level) return 0;
	  else if(str==name || str=="ghost of "+name) return 1;
}


static in_room(str)
{
    object room;
    object old_room;
    string cmd;
    if (!str) return 0;
    if (sscanf(str, "%s %s", room, cmd) != 2) 
	  {
		write("Usage: in ROOM CMD\n");
		return 1; 
	  }
    room = valid_read(room);
    if (!room) 
	  {
		write("Invalid file name.\n");
		return 1; 
	  }
    old_room = environment();
    move_object(me, room);
    command(cmd);
    if(old_room) move_object(me, old_room);
	  else write("Error: return room is missing.\n");
    return 1;
}

emote(str)
{
    string first, last, out, tmp, temp;

    if (!str || !(str=valid_input(str)))
      {
       write("emote what?\n");
       return 1;
      }

	/* important stuff \/ */

    if(this_player()->query_wiz_level()<JUNOR) tmp = ":";
      else tmp = "";   

    if(sscanf(str,"%s^%s",first,last) == 2)      
      {
        if(first[strlen(first)-1]!=' ') first+=" ";

        if(last[0] != ' ') last=" "+last;

        out = tmp+first+cap_name+last;
      }
    else if(sscanf(str,"%s^",first) == 1) 
      {
        if(first[strlen(first)-1] != ' ') first+=" ";

       	out = tmp+first+cap_name+".";
      }
    else out = tmp+cap_name+" "+str;

    if(!strchr("?.!",out[strlen(out)-1])) out+=".";

    write("You emote: "+out+"\n");
    say(out+"\n");

    return 1;
}

static list_files(path)
{
int path_stat;

    if(!path) path="*";
    path=rectify_path(path);
	if(!path) return 1;
    write(path+"\n");
    if(path!= "/") path = path + "/.";
	  else path+=".";
    ls(path);
    return 1;
}
 
tail_file(path)
{
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot tail a directory.\n");
       return 1;
     }
    if (!tail(path)) return 0;
    return 1;
}
 
cat_file(path)
{
    if(this_player()!=this_object()) return 0;
    if (!path) return 0;
    path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot cat a directory.\n");
       return 1;
     }
    cat(path);
    return 1;
}
 
list_peoples() {
    object list;
    int i, a, p;
 
    list = users();
    for(i=0,p=0;i<sizeof(list);i++)
       if(list[i] && ((!list[i]->short() && list[i]->query_wiz_level()<ADMIN) ||
          list[i]->short())) p++;
    write("There are now " + p + " players");
    for (i=0, a=0; i < sizeof(list); i++)
	if (list[i] && ((query_idle(list[i]) >= 5 * 60) &&
            ((!list[i]->short() && list[i]->query_wiz_level()<ADMIN) ||
            list[i]->short())))
	    a++;
    if (a)
	write(" (" + (p - a) + " active)");
    write(". " + query_load_average() + "\n");
    for(i=0; i<sizeof(list); i++) {
	string nm;
	string env;
	int lv;
	string ag,idle;

        if(!list[i] || (!list[i]->query_real_name() && !list[i]->query_name()))
			continue;
        if(list[i]->short() || ( !list[i]->short() &&
           list[i]->query_wiz_level()<ADMIN)) 
		  {
			nm = list[i]->query_real_name();
        	if(!nm) nm = list[i]->query_name();
        	if(!nm) continue;
		    nm=capitalize(nm);
        	if(query_ed(list[i])) nm = "["+nm+"]";
			if (list[i]->query_invis()) nm = "(" + nm + ")";
			lv=list[i]->query_wiz_level()?list[i]->query_wiz_level():
			list[i]->query_level();
			if (query_idle(list[i]) >= 5 * 60) idle='I';
			  else idle=32;
			if (environment(list[i])) env=file_name(environment(list[i]));
			 else env="";
			sprintf(nm,"%-20s %-11s %4d %c %s\n",query_host_name(list[i]),nm,lv,idle,env);
			write(nm);
      }
    }
    return 1;
}
 
static edit(file)
{
    if (!file) 
	  {
		ed();
		return 1;
      }
    if(file!="-r") file = rectify_path(file);
	if(!file) return;
    if (!ed(file)) write("You do not have access to that file.\n");
    return 1;
}
 
static heal(name)
{
    object ob;
 
    if (!stringp(name)) return 0;
    ob = find_living(lower_case(name));
    if (!ob) {
	write("No such person is playing now.\n");
	return 1;
    }
    call_other(ob, "heal_self", 100000);
    tell_object(ob, "You are healed by " + cap_name + ".\n");
    write("Ok.\n");
    return 1;
}
 
static stat(name)
{
    object ob;
 
    if (!name)
	return 0;
    ob = present(lower_case(name), environment());
    if (!ob || !living(ob))
	ob = find_living(name);
    if (!ob) {
	write("No such person is playing now.\n");
	return 1;
    }
    call_other(ob, "show_stats", 0);
    return 1;
}
 
static make_wizard(str)
{
  object old_player,new_wiz;
  int wiz_num;
  int wiz_name;
  int wiz_level;
  string tmp;

  if(!str)
    {
      write("Bad format to 'sponsor'\n");
      return 1;
    }

  if(sscanf((str=lower_case(str)),"%s %d",tmp,wiz_level)==2)
    {
        new_wiz=find_player(tmp);
       
        if(!new_wiz)
          {
            write("That person is not here right now.\n");
            return 1;
          }

        if(!wiz(new_wiz))
          {
             write("That person must first be a wizard before you can change there wizard level.\n");
             return 1;
           }

        if(!new_wiz->set_wiz_level(wiz_level))
	   {
	      write("You were unable to change that wizards level.\n");
	      return 1;
           }

        command("soul off",new_wiz);
        command("soul on",new_wiz);

        tell_object(new_wiz,"Your wizard level has been changed by "+cap_name+ 
                            " to "+wiz_level+".\n"+
                            "type 'man wizardcmds' to see what changes have\n"+
                            "been made to your available wizard functions.\n");

        new_wiz->save();

        log_file("SPONSOR",capitalize(name)+" sponsored "+capitalize(tmp)+" to level "+wiz_level+" @ "+ctime(time())+".\n");

        write("You have changed "+capitalize(tmp)+" level to "+wiz_level+".\n");
        return 1;
     }

  old_player=find_player(str);

  if(!old_player)
   {
     write("That person is not here right now.\n");
     return 1;
   }

  if(wiz(old_player))
   {
     write("That person is already a wizard!\n");
     return 1;
   }

  old_player->save();

  tell_object(old_player,"You feel odd as the world fades before you...\n");
  
  new_player("r1/obj/obj_dev/wizard",old_player,({(wiz_name=old_player->query_user_name()),(wiz_num=old_player->query_player_num())}));

  move_object(old_player,"r1/room/void");
  destruct(old_player);

  new_wiz=find_player(str);

  if(!new_wiz)
   {
      write("Error, new wizard has disappeared.\n");
      return 1;
   }

  new_wiz->set_wiz_level(51);

  command("soul off",new_wiz);
  command("soul on",new_wiz);

  new_wiz->save();

  tell_object(new_wiz,"Welcome to your new race oh most powerfull one!\n"+
                      "As a wizard of the mighty realm we suggest you\n"+
		      "first try the command 'man wizard' to help you get\n"+
                      "started.  Also, the command 'home' will take you to\n"+
                      "your newly created workroom inside your home directory.\n"+
                      "This directory is where you can store the programs you\n"+
                      "write, and other such files as you need.\n\n"+
                      "Your home directory is '/r1/w/"+wiz_name+"'.\n\n"+
                      "If you have any questions feel free to ask any wizard\n"+
                      "around, though you might first start by asking your\n"+
                      "sponsor "+cap_name+" as it is "+query_gender_string(1)+
                      " that made you a wizard.\n");

  new_wiz=clone_object("r1/closed/update_link");

  restore_object("r1/p/"+itoc(wiz_name[0])+"/"+wiz_name,new_wiz);

  new_wiz->set_wizard(wiz_num,51);

  save_object("r1/p/"+itoc(wiz_name[0])+"/"+wiz_name,new_wiz);

  destruct(new_wiz);

  mkdir("/r1/w/"+wiz_name);
  mkdir("/r1/w/"+wiz_name+"/obj");
  mkdir("/r1/w/"+wiz_name+"/include");

  cp("/open/Workroom.c","/r1/w/"+wiz_name+"/workroom.c");
  cp("/r1/room/void.c","/r1/w/"+wiz_name+"/void.c");

  log_file("SPONSOR",capitalize(name)+" sponsored the new wizard "+capitalize(str)+" @ "+ctime(time())+".\n");

  write("You have successfully sponsord "+capitalize(str)+".\n");
  return 1;
}

static trans(str)
{
    object ob;
    string out;
 
    if (!str)
	return 0;
    ob = find_living(str);
    if (!ob) {
	write("No such living thing.\n");
	return 1;
    }
    tell_object(ob, "You are magically transfered somewhere.\n");
    MCP->move_player(ob,"X",file_name(environment()),0);
    return 1;
}
 
static zap(str)
{
    object ob;
    if (!str)
	ob = attacker;
    else
	ob = present(lower_case(str), environment(this_player()));
    if (!ob || !living(ob)) {
	write("At whom ?\n");
	return 1;
    }
    if(ob->query_wiz_level()>=wiz_level)
      {
        write("You can only zap those lesser than yourself.\n");
        return 1;
      }
	say("A bolt of lightning drops from the sky and kills "+ob->query_name()+".\n");
	if(!test_player(ob)) write("You kill the "+ob->query_name()+" with a bolt of lightning.\n");
		 else write("You kill "+ob->query_name()+" with a bolt of lightning.\n");
    ob->death();
    return 1;
}
 
static earmuffs(str)
{
  if(str=="on")
   {
     block_sh=1;
     block_shouts(1);
     write("Earmuffs are on.\n");
   }
  else
   {
      block_sh=0;
      block_shouts(0);
      write("Earmuffs are off.\n");
   }
 return 1;
}

static block_tell(str)
{
  if(str=="on")
   {
     block_tells=1;
     write("Tells blocked from lower level users.\n");
   }
  else
   {
     block_tells=0;
     write("All tells enabled.\n");
   }
  return 1;
}


static set_use_light(str)
{
  if(str=="on")
   {
     use_light=1;
     write("You can now see without light.\n");
     return 1;
   }
  if(str=="off")
   {
     use_light=0;
     write("Your vision is now dependent on light.\n");
     return 1;
   }
}
  
static wiz_commands() 
{
    add_action("soul_cmd","soul",2);
    add_action("man","man",2);
    add_action("wiznews","wiznews",2);
    add_action("set_title","title",2);
    add_action("teleport","goto");
    add_action("list_peoples","people");
    add_action("wiz_panic","HELP");
    add_action("clone","clone",2);
    add_action("makedir","mkdir",2);
    add_action("removedir","rmdir",2);
    add_action("pwd","pwd",2);
    add_action("more","more",2);
    add_action("chunk_set", "chunk", 2);
    add_action("home","home",2);
    add_action("remove_file","rm",2);
    add_action("mv_file","mv",2);
    add_action("cp_file","cp",2);
    add_action("cat_file","cat",2);
    add_action("tail_file","tail",2);
    add_action("edit","ed",2);
    add_action("destruct_local_object","dest",2);
    add_action("local_commands","localcmd",2);
    add_action("wiz_score_list","wizlist");
    add_action("wiz_tell","wiz",2);
    add_action("stat","stat");
    add_action("update_object","update",2);
    add_action("reset_object","reset",2);
    add_action("load","load",2);
    add_action("setmmin","setmmin",2);
    add_action("setmmout","setmmout",2);
    add_action("setmin","setmin",2);
    add_action("setmout","setmout",2);
    add_action("setclone","setclone",2);
    add_action("setdest","setdest",2);
    add_action("review","review",2);
    add_action("cd","cd",2);
    add_action("list_files","ls",2);
    add_action("list_files","lf",2);
    add_action("read_log","log",2);
    add_action("purge_log","purge",2);
    
   if(wiz_level<WIZARD) return;

    add_action("my_level", "level", 2);
    add_action("earmuffs","earmuffs",2);
    add_action("sethome","sethome",2);
    add_action("set_use_light","light",2);
    add_action("set_room_names","path",2);
    add_action("goto_castle","castle");

   if(wiz_level<JUNOR) return;
    add_action("invis","invis",2);
    add_action("vis","vis",2);
    add_action("grep_file","grep",2);

   if(wiz_level<SENIORE) return;

    add_action("block_tell","blocktell",2);
    add_action("echo","echo",2);
    add_action("in_room","in",2);
    add_action("set_block","wizblock");
    add_action("trans","trans",2);
 
  if(wiz_level<ELDER) return;

    add_action("echo_all","echoall",2);
    add_action("echo_to","echoto",2);
    add_action("zap","zap",2);
    add_action("heal","heal",2);

  if(wiz_level<ADMIN) return;

    add_action("prison_player",({"prison","prison2"}),2);
    add_action("force","force",2);
    add_action("snoop_on","snoop",2);

   if(wiz_level<SPONSOR) return;

    add_action("make_wizard","sponsor",2);
}

static echo_all(str) 
{
    if (!str)
	  {
       write("Echoall what?\n");
       return 1;
      }
    shout(str + "\n");
    write("You echo: " + str + "\n");
    return 1;
}

static echo(str) 
{
    if (!str) 
	  {
       write ("Echo what?\n");
       return 1;
      }
    say (str + "\n");
    write ("You echo: " + str + "\n");
    return 1;
}

static echo_to(str)
{
    object ob;
    string who;
    string msg;

    if (!str || sscanf(str, "%s %s", who, msg) != 2)
	  {
		write("Echoto what ?\n");
		return 1;
      }
    ob = find_living(lower_case(who));
    if (!ob)
	  {
		write("No living thing found with that name.\n");
		return 1;
      }
    tell_object(ob, msg + "\n");
    write("You echo: " + msg + "\n");
    return 1;
}

static teleport(dest) 
{
    object ob;

    if (!dest) 
	  {
		write("Goto where ?\n");
		return 1;
      }
    ob = find_living(dest);
    if(ob && !ob->short()) ob=0;
    if (ob)
     {
	ob = environment(ob);
        if(ob && file_name(ob)!="r1/room/control/start")
	  MCP->move_player(this_object(),"X",file_name(ob),0);
      }
    else
      {
		if(dest[0]!='/') dest=rectify_path(dest);
		if(!dest) return 1;
        dest = valid_read(dest);
        if(dest=="r1/room/control/start") dest=0;
        if(file_size("/"+dest+".c")<1) dest=0;
        if (!dest) write("Invalid living name or file name.\n");
          else MCP->move_player(this_object(),"X",dest,0);
      }
   return 1;
}
 
static force(str)
{
    string who, what;
    object ob;
    if (!str) return 0;
    if (sscanf(str, "%s to %s", who, what) == 2 ||
		sscanf(str, "%s %s", who, what) == 2) 
      {
		ob = find_living(who);
		if (!ob) write("No such living object.\n");
     	  else if(ob->query_wiz_level()>=wiz_level)
	  	    {
			  write("You try to force "+str+" but fail.\n");
        	  tell_object(ob,cap_name+" tried to force you to: "+what+", and failed.\n");
	  	    }
    	  else
      	   {
	     	  tell_object(ob, cap_name + " forces you to: " + what + "\n");
	     	  command(what,ob);
	     	  write("Ok.\n");
           }
	  }
	return 1;
}
 
static clone(str) 
{
    object ob;
    int syss;
    string it1, it2;

    if (!str) {
	write("Clone what object ?\n");
	return 1;
    }
    str=rectify_path(str);
	if(!str) return 1;
    str = valid_read(str);
    if(str && file_size("/"+str+".c")<1) str=0; 
    if (!str) {
	write("Invalid file.\n");
	return 1;
    }
    if(!find_object(str)) {sys(str);syss = 1;}
    ob = clone_object(str);
    if(syss) sys(str, 1);
 
if(!(sscanf(msgclone, "%s^%s",it1, it2) == 2) &&
      !(sscanf(msgclone, "%s^", it1) == 1))
         say(cap_name + " " + msgclone + "\n");
    else
     say(cap_name + " " + it1 + " " + ob->short() + " " + it2 + "\n");

    if(ob->query_can_pick_up())
      {
        add_weight(ob->query_weight());
        move_object(ob,this_object());
      }
     else move_object(ob, environment());
    write("Ok.\n");
    return 1;
}
 
static destruct_local_object(str)
{
    object ob;
 
    string it1, it2;

    if (!str)
	  {
		write("Destruct what ?\n");
		return 1;
      }
    str=lower_case(str);
    ob = present(str, this_player());
    if (!ob) ob = present(str, environment(this_player()));
    if (!ob) 
	  {
		write("No " + str + " here.\n");
		return 1;
      }
    if(test_player(ob) && wiz_level <ADMIN)
     {
       write("You are not allowed to destruct players!\n");
       return 1;
     }

    if (ob->short())
      if(!(sscanf(msgdest, "%s ^ %s", it1, it2) == 2))
         say(cap_name + " " + msgdest + "\n");
    else
       say(cap_name + " " + it1 + " " + str + " " + it2 + "\n");
    destruct(ob);
    write("Ok.\n");
    return 1;
}
 
static load(str)
{
    object env;
    if (!str) {
	write("Load what ?\n");
	return 1;
    }
    if(str[0]!='/') str=rectify_path(str);
	if(!str) return 1;
    str = valid_read(str);
    if (!str) {
	write("Invalid file name.\n");
	return 1;
    }
    env = environment();
    /* We just call a non existing function in the object, and that way
     * force it to be loaded.
     */
    if(file_size("/"+str+".c")<1)
     {
        write("No such file to load.\n");
        return 1;
     }
    sys(str);
    call_other(str, "???");
    sys(str, 1);
    write("Ok.\n");
    return 1;
}
 
static snoop_on(str)
{
    object ob;
    int ob_level;
 
    if (!str) {
	snoop();
	return 1;
    }
    ob = find_player(str);
    if (!ob) {
	write("No such player.\n");
	return 1;
    }
    if(ob->query_wiz_level()>=wiz_level) {
	write("You fail.\n");
	return 1;
    }
    snoop(ob);
    return 1;
}
 
static invis(str) 
{
  string invis_name_tmp;

	if(str && my_invis_name(str)) return 1;
	else if(str) return;
	if (is_invis) {
	tell_object(this_object(), "You are already invisible.\n");
	return 1;
    }
    is_invis = 1;
    if(wiz_level>=SENIORE) block_tells=1;
    if(wiz_level>=ADMIN) {
    invis_name_tmp = name + INVIS_NAME;
    set_living_name(invis_name_tmp); }
    tell_object(this_object(), "You are now invisible.\n");
    if(wiz_level>=SENIORE) tell_object(this_object(), "Tells from lower level players & wizards are now blocked.\n");
    say(cap_name + " " + mmsgout + "\n", this_object());
    if(!invis_name) invis_name = "Someone";
    cap_name=capitalize(lower_case((invis_name)));
    return 1;
}
 
static vis()
{
    if (!is_invis) {
	tell_object(this_object(), "You are not invisible.\n");
	return 1;
    }
    is_invis = 0;
    if(wiz_level>=SENIORE) block_tells=0;
	cap_name=capitalize(name);
    if(wiz_level>=ADMIN) set_living_name(name);
    if(wiz_level>=SENIORE) tell_object(this_object(), "Your tells are enabled.\n");
    tell_object(this_object(), "You are now visible.\n");
    say(cap_name + " " + mmsgin + "\n", this_object());
    return 1;
}
 
static home(str) 
{
    if(!str || str == "") str = user_name;
	if(!file_size("/r1/w/"+user_name+"/workroom.c")) return;
    if(!is_invis) say(cap_name+" "+msghome+"\n");
    move_object(this_object(),"r1/w/"+str+"/workroom");
    if(!is_invis) say(cap_name+" "+mmsgin+"\n");
    if(brief) glance();
    else look();
    return 1;
}

static wiz_score_list(arg) 
{
    if (arg) wizlist(arg);
    else wizlist();
    return 1; 
}
 
static remove_file(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    rm(file);
	return 1;
}
 
static mv_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
	file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    mv(file,file2); return 1; 
}
 
static cp_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
    file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    cp(file,file2);
	return 1; 
}
 
static local_commands(str) {
	object ob1, ob2;
	if(!str) return !localcmd();
	else if(ob1 = strchr(str, ' '))
		if(!(ob2 = local_find_object(++ob1)))
			return !write("Invalid from_object.\n");
		else str[strlen(str) - strlen(ob1)-1] = 0;
	if(!(ob1 = local_find_object(str)))
		return !write("Invalid for_object.\n");
	if(!ob2) localcmd(ob1);
	else localcmd(ob1, ob2);
	return 1;
}
local_find_object(str) {
	object ob;
	if(str == "me") ob = this_player();
	else if(str == "here") ob = environment(this_player());
	if(!ob) ob = find_object(str);
	if(!ob) ob = present(str, this_player());
	if(!ob) ob = find_player(str);
	if(!ob) ob = find_living(str);
	return ob;
}
 
illegal_patch(what) 
{
    write("You are struck by a mental bolt from the interior of the game.\n");
    log_file("ILLEGAL", ctime(time()) + ":\n");
    log_file("ILLEGAL",
	     call_other(this_player(), "query_real_name") + " " +
	     what + "\n");
    return 0;
}

static cd(str) 
{
    str=rectify_path(str);
	if(!str) return 1;

    if(str=="/") current_path="";
	 else if(valid_read(str)) 
		{
		   int size;

		   size=file_size(str);
		   if(size==-1) write("No such file or directory.\n");
    		       else if(file_size(str)!=-2) write("No such directory.\n");
	  		 else 
		           {
				  current_path=str;
				  ++current_path;
			   }
		}
    write("/" + current_path + "\n");
    return 1;
}
 
static grep_file(str)
{
  if(!str) return 0;
  grep(str);
  write("grep output will be appended to the file /r1/log/"+user_name+".grep\n");
  write("\n	* please allow a few moments for the program to finnish running.\n");
  return 1;
}

static read_log(str)
{
string file;
 
   if(!stringp(str)) return more("/r1/log/"+user_name);
   if(str[0]=='.') str=user_name+str;
   file=valid_read("/r1/log/"+str);
   if(!file)
     {
        write("No such file.\n");
        return 1;
     }
   return more("/"+file);
} 
 
static purge_log(str)
{
   if(stringp(str))
	 {
		if(str[0]=='.') str=user_name+str;
	    return remove_file("/r1/log/"+str);
	 }
    else return remove_file("/r1/log/"+user_name);
}
 
#if 0
more(path) {
int lines;
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot more a directory.\n");
       if(log_flag)
        {
          log_flag=0;
          finnish2();
        }
       return 1;
     }
    more_file = path;
    more_line = 1;
    if(!(lines=cat(more_file, more_line, chunk))) {
	write("No such file\n");
        if(log_flag)
	 {
           log_flag=0;
	   finnish2();
         }
	return 1;
    }
    input(this_object(),"even_more");
    write("More: line " + (lines) + " (q/u/r/<return>) ");
    return 1;
}
 
static even_more(str) 
{
int lines;

    if (str == "q") 
      {
	write("Ok.\n");
	if(log_flag)
	 {
	   log_flag=0;
	   finnish2();
	 }
	return;
       }
     else if (str == "u") 
            {
	      more_line -= chunk;
	      if (more_line < 1) more_line = 1;
            }
          else if(str=="r") {}
    else more_line+=chunk;
    if(!(lines=cat(more_file, more_line, chunk))) {
	more_file = 0;
        if(log_flag)
         {
            log_flag=0;
            finnish2();
         }
        else write("EOF\n");
	return;
    }
    write("More: line " + (more_line + lines) + " (q/u/r/<return>)");
    input(this_object(),"even_more");
}
#endif
 
static pwd() 
{
    write("/" + current_path + "\n");
    return 1;
}
 
static makedir(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    if (mkdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
static removedir(file) 
{
    if (!file) return 0;
	file=rectify_path(file);
	if(!file) return 1;
    if (rmdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
query_path() {
     if(wiz_level<PROBATE) return "";
    return current_path;
}
 
check_access_list(file) 
{
int pos;

    /* access_list maintains an array. this array hold the name
       of the file/dir that access is granted to.
       the next element after the file/dir name is the access type.
       1 - read only  2 - read/write.

       Access to a file does not need access to it's directory.
       Access to a dir gives the same access to the files in it.
     */

    if (!pointerp(access_list)) return 0;

    if((pos=search_array(access_list))!=-1) return access_list[pos+1];

    return 0;
}

static update_object(str) 
{
object ob;
string temp;
object inv;
int i,s,no_inv;
string void;
 
    if(file_size("/r1/w/"+user_name+"/void.c")<1) void="r1/room/void";
      else void="r1/w/"+user_name+"/void";

    if (!str) str="/"+file_name(environment(this_player()));

    if(str[0]!='/') str=rectify_path(str);

    if(!str) return 1;

    if(wiz_level<ADMIN) str = valid_write(str);
	else str= valid_read(str);

    if (!str) return 1;

    ob = find_object(str);

    if(!ob)
      {
	load(str);
        return 1;
      }

    inv=all_inventory(ob);

    if(!inv) no_inv=1;
      else for(s=sizeof(inv);i<s;i++) 
	      if(objectp(inv[i])) move_object(inv[i],void);

    destruct(ob);
    write(str + " destructed.\n");

    write("Now attempting to load "+str+"\n");

    call_other(str,"???");

    ob=find_object(str);

    write("Loading of "+str+" was successful.\n");

    if(!no_inv) 
      {
       inv=all_inventory(void);
       for(s=sizeof(inv),i=0;i<s;i++) 
        {
          string item_name;
      
          item_name=inv[i]->query_id(0);

          if(!item_name) item_name=inv[i]->query_name();
          if(!item_name) item_name=inv[i]->query_real_name();

          if(!item_name || present(item_name,ob)) destruct(inv[i]);
            else move_object(inv[i],ob);

        }

      write("Restroration of "+str+" contents complete.\n");
      call_other(void,"reset",1);
    }

  return 1;
}
 
static reset_object(str)
{
object ob;
string temp;
  if(str)
   {
     ob=present(str,this_player());
     if(!ob) ob=present(str,environment(this_player()));
     if(!ob) find_living(str);
   }
  if(!ob)
   {
     if(!str) str=file_name(environment(this_player()));
     else if(str[0]!='/')     str=rectify_path(str);
	 if(!str) return 1;
     ob=find_object(str);
     if(!ob)
      {
        write("Object '"+str+"' not found.\n");
        return 1;
      }
    }
  ob->reset(1);
  write(file_name(ob)+" has been reset.\n");
  return 1;
}

reset(arg)
{
   ::reset(arg);
   return 1;
}
 
goto_castle(str)
{
object castle;
 
     if(!str) str=name;
     str=lower_case(str);
     castle=environment("r1/w/"+str+"/castle");
     if(!castle)
      {
        write("Unable to find "+capitalize(str)+"'s castle.\n");
        return 1;
      }
     MCP->move_player(this_player(),"X",file_name(castle),0);
     return 1;
}
 
static set_room_names(str)
{
 
  if(str=="off")
   {
     write("You no longer see the room names.\n");
     no_room_names=1;
     return 1;
   }
  write("You see room names.\n");
  no_room_names=0;
  return 1;
}

man(man_str)
{
  int size,c,count,f_size,entry;
  string file_name;
  pointer docs;

  if(!stringp(man_str))
     {
       write("Bad format to man()\n");
       write("man <topic> [entry]\n");
       return 1;
     }

  if(man_str=="wizardcmds")
    {
       if(wiz_level>=PROBATE) cat("/r1/doc/wizardhelp/PROBATE");
       if(wiz_level>=WIZARD) cat("/r1/doc/wizardhelp/WIZARD");
       if(wiz_level>=JUNOR) cat("/r1/doc/wizardhelp/JUNOR");
       if(wiz_level>=SENIORE) cat("/r1/doc/wizardhelp/SENIORE");
       if(wiz_level>=ELDER) cat("/r1/doc/wizardhelp/ELDER");
       if(wiz_level>=ADMIN) cat("/r1/doc/wizardhelp/ADMIN");

       return 1;
    }

  if(sscanf(man_str,"%s %d",file_name,entry)==2)
     {
       man_str=file_name;
       if(entry>0) entry--;
	  else entry=0;
     }

  for(docs=MUD_DOCS+REALM_DOCS,size=sizeof(docs);c<size;c++)
    {
	file_name=docs[c]+man_str;

       if((f_size=file_size(file_name))>=0)
	 if(count==entry) break;
		else count++;
     }

  if(f_size>=0)
     {
       write("\n"+file_name+" ("+f_size+" bytes)\n");
       more(file_name);
       return 1;
     }

  write("No entry found.\n");
  return 1;
}

wiz_panic() {
    more("/r1/doc/wizardhelp/NEW_WIZ");
    return 1;
}

wiznews()
{
    more("/r1/news/WIZNEWS");
    news_file=file_size("/r1/news/WIZNEWS");
    return 1;
}

 
static prison_player(str) 
{
 string prison;
 object player;
  if(query_verb()=="prison") prison="r1/w/man-ing/prison/prison";
    else prison="r1/room/prison";
  player=find_player(lower_case(str));
  if(!player)
     write("sorry no player by that name can be found at this time.\n");
  else if(player->query_level()>=levels[0])
      write("You are unable to imprison that person.\n");
  else {
   move_object(player,prison);
   command("look",player);
   write("You hve imprisoned "+str+".\n"); 
  }
 return 1; 
}

sys(str, flag) 
{
    if(!str || file_size("/"+str+".c") < 15000) return;
    if(!flag) shout("System delay, please hold....");
    else shout("done.\n");
}

set_wiz_level(num) 
{
    if(!query_ip_number(this_player()) || wiz() < SPONSOR || wiz_level >= wiz())
	 return;

    if(num>ELDER) return;

    return (wiz_level = num);
}

chunk_set(num) {
	num = atoi(num);
	if(num > 100 || num < 1) return;
	chunk = num;
	write("CHUNK set to "+num+".\n");
	return 1;
}

static my_level(str) 
{
     string tmp;
     int num;
     if(!str)
     {    write("Improper format: format is (class/level)\n");
          return 1;
     }
	if(wiz_level < PROBATE || !query_ip_number(this_player()) ||
		(this_player() != this_object())) return;

     if(!(sscanf(str, "%s/%d", tmp, num) == 2))
     {    write("Improper format: format is (class/level)\n");
          return 1;
     }
	if(!numberp(num)) num=atoi(num);

	if(num < 1 || num > 413) return;
	r1/obj/living::set_level(tmp,num);set_str(num);
        set_con(num);set_int(num);set_dex(num);

	write("Level and stats set to "+num+".\n");
	return 1;
}

#if 0
my_name(str)
{
	if(!query_ip_number(this_player()) || 
	  (this_player() != this_object() && this_player()->query_wiz_level() < ADMIN))
		return;
	str = valid_input(str);
	if(!str || str == "") {
		write("Name returned to normal.\n");
		temp_name = 0;
		cap_name = capitalize(lower_case(name));
        set_living_name(name);
		return 1;
	}
        str = lower_case(str);
	temp_name = str;
	cap_name = capitalize(temp_name);
        set_living_name(temp_name);
	write("Name changed to "+str+".\n");
	return 1;
}
#endif

my_invis_name(str) 
{
	if(!query_ip_number(this_player()) ||
		(this_player() != this_object() &&
		this_player()->query_wiz_level() < ADMIN)) return;
	str = valid_input(str);
	if(!str || str == "") 
	  {
		write("Invis name returned to normal.\n");
		invis_name = "Someone";
                if(is_invis) cap_name = invis_name;
		return 1;
	  }
	invis_name = str;
    if(is_invis) cap_name = capitalize(lower_case(invis_name));
	write("Invis name changed to "+str+".\n");
	return 1;
}

static set_block(str) 
{
    if(str != "on" && str != "off") 
	  {
		write("Wizblock On or Off?\n");
		return 1; 
	  }
    if(str == "on") 
	  {
		write("Wizblock On.\n");
		is_blocked = 1; 
	  }
    if(str == "off") 
	  {
		write("Wizblock Off.\n");
		is_blocked = 0; 
	  }
   return 1; 
}


static wiz_tell(str) 
{
	object ob;
	int i;

  ob = users();
  if(!str) 
	{
		write("Wiztell what?\n");
		return 1;
	 }
  if(this_player()->query_blocked() == 1) 
	{
		write("You're blocked.\n");
		return 1; 
	}
   str = valid_input(str);
   for(i=0;i<sizeof(ob);i++) 
	{
	  if(!ob[i]) continue;
      if(ob[i]==this_object()) continue;
      if(ob[i]->query_wiz_level() >= PROBATE && ob[i]->query_blocked() == 0) 
		{
            tell_object(ob[i], capitalize(this_player()->query_real_name()) + " <wiz channel> : ");
	   		tell_object(ob[i], str);
	   		tell_object(ob[i], "\n");
	   		if(ob[i]->query_blocked() == 1) 
	        write(capitalize(ob[i]->query_real_name()) + " was blocked.\n"); 
		}
	}
  write("Sent.\n");
  return 1; 
}


soul_cmd(on_off)
{

  if(!stringp(on_off) || !strstr("onoff",(on_off=lower_case(on_off))))
    {
       write("Invalid format to 'soul'\nsoul on/off\n");
       return 1;
    }

   remove_all_verbs(this_object(),this_object());
   
   switch(on_off)
     {
        case "on":
		add_soul_commands();
	default:
		add_standard_commands();
		wiz_commands();
    }

  write("Ok.\n");
  return 1;
}

review() 
{
    write("min   : "+cap_name+" "+msgin+" from the <dir>.\n"+
	  "mout  : "+cap_name+" "+msgout+" <dir>.\n"+
	  "mmin  : "+cap_name+" "+mmsgin+"\n"+
	  "mmout : "+cap_name+" "+mmsgout+"\n"+
          "clone : "+cap_name+" "+msgclone+"\n"+
          "dest  : "+cap_name+" "+msgdest+"\n"+
	  "home  : "+cap_name+" "+msghome+"\n"+
	  "align : ("+alignment+")\n"+
	  "title : "+cap_name+" "+title+"\n");
    return 1; 
}

sethome(m) {msghome = m;write("Ok.\n"); return 1;}
setdest(m) {msgdest = m;write("Ok.\n"); return 1;}
setclone(m) {msgclone = m;write("Ok.\n"); return 1;}
query_msghome() { return msghome;}
query_msgdest() { return msgdest;}
query_msgclone() { return msgclone;}
query_blocked() {return is_blocked; }
query_wiz_level() {return wiz_level;}
query_no_room_names() { return no_room_names; }
