#include "wizard.h"
#define MCP "closed/mcp"
#define MAX_LIST 50
#define BAD_CHAR "!@#$%^&*()_+=|\\~`{[}]\";:/?.>,<1234567890"

#define DIR_WORDS_SHORT ({"l","r","u","d","i","o","e","w","s","n","nw",\
			  "ne","sw","se"})

#define DIR_WORDS ({"left","right","up","down","in","out","east","west",\
		    "south","north","northwest","northeast",\
		    "southwest","southeast"})

private;

valid_write(str,p_ob) 
{
    string who,temp,temp2;
    int num;
    object tp_ob;

    if(!stringp(str)) return 0;

    if(p_ob && !creator(p_ob)) return extract(str,1);

    tp_ob=this_player();

    if(tp_ob && !p_ob)
      if(sscanf(str,"/r1/p/%s/%s.%d.s%s",temp2,who,num,temp)==4)
        {
		  if(who!=tp_ob->query_user_name() ||
		     temp2[0]!=who[0]) return 0;
	      return extract(str,1);
	}

	if(p_ob) who=creator(p_ob);
	  else if(creator(tp_ob)) who=creator(tp_ob);
		 else if(test_player(tp_ob)) who=tp_ob->query_user_name();

	if(who && !strncmp(str,"/r1/w/"+who,strlen(who)+6))
	  return extract(str,1);

    if(tp_ob && !creator(tp_ob) && 
      (!strncmp(file_name(tp_ob),"r1/closed/",10) || 
      !test_player(tp_ob) || tp_ob->query_wiz_level() >= ADMIN)) 
	  return extract(str,1);
		
    if((!strncmp(str,"/open",5) ||
		!strncmp(str,"/r1/log",7) ||
		!strncmp(str,"/r1/open",8)) &&
		(strrchr(str,'/')[1]<'A' || strrchr(str,'/')[1]>'Z') &&
		!strstr(str,"closed") && !strstr(str,"_dev"))
		    return extract(str,1);

    return 0;
}
 
valid_read(str,p_ob) 
{
    int num;
    string who,temp;
    object tp_ob;

    if(!stringp(str)) return 0;

    temp=valid_write(str,p_ob);

    if(temp) return temp;

    if(p_ob && !creator(p_ob)) return extract(str,1);
    tp_ob=this_player();

    if(tp_ob)
      if(sscanf(str,"/r1/p/%s/%s.%d.s",temp,who,num)==3 || 
         sscanf(str,"r1/p/%s/%s.%d.s",temp,who,num)==3) 
        {
		  if(who!=tp_ob->query_user_name() ||
		     who[0]!=temp[0] ) return 0;
	      return extract(str,1);
	    }

	if(p_ob) who=creator(p_ob);
	  else if(creator(tp_ob)) who=creator(tp_ob);
		 else who=tp_ob->query_user_name();

	if(who && !strncmp(str,"/r1/w/"+who,strlen(who)+6))
	  return extract(str,1);

    if(tp_ob && !creator(tp_ob) && 
       (!strncmp(file_name(tp_ob),"r1/closed/",10) || 
	!test_player(tp_ob) || tp_ob->query_wiz_level() >= ADMIN) )
	  return extract(str,1);

    if(strstr(str,"closed") || strstr(str,"_dev") || !strncmp("/r1/w/",str,6))
	 return 0;
		
    return extract(str,1);
}

allow_snoop(ob)
{
  if(!objectp(ob)) return 0;
  if(this_player()->query_wiz_level()<ADMIN ||
     ob->query_wiz_level()>=this_player()->query_wiz_level()) return 0;
  return 1;
}

tell_room_name(ob,room)
{
    if (wiz(ob) && !ob->query_no_room_names())
	    tell_object(ob, "/" + file_name(room) + "\n");
}

look(str, mode, ob, ob2,extra_light) 
{
int i;
object o,inv;
string s;

    if(!ob) ob = environment(this_player());

    if(!ob2) ob2 = this_player();

    if(str=="at sky" || str=="at the sky")
      {
         if(!ob->id("sky")) 	
	    {
		write("You cannot see the sky from here.\n");
		return 1;
	    }
         write(ob->long("sky"));
         return 1;
      }
    if(!ob2->query_use_light() && extra_light<1)
     {
       tell_room_name(ob2,ob);
       tell_object(ob2,"It is too dark to see.\n");
       return 1;
     }
    if(!str) 
     {
	tell_room_name(ob2,ob);

        if(!mode && (extra_light >=2 || ob2->query_use_light() ||
           !ob->query_property("DN")))
               tell_object(ob2,ob->long());
                    else tell_object(ob2, ob->short()+".\n");

        o = all_inventory(ob);
        if(o)
            for(i=0;i<sizeof(o) && i<MAX_LIST;i++)
                if(o[i] != ob2 && o[i]->short())
                    tell_object(ob2, o[i]->short()+".\n");
     } 
   else if(sscanf(str, "at the %s", s) || sscanf(str,"at %s",s) ||
           sscanf(str, "in the %s",s) || sscanf(str, "in %s", s)) 
     {
        s = lower_case(s);

        if(ob==environment(ob2)) o=here(s,ob2);
          else o = here(s,ob);

        if(!o) tell_object(ob2, "No "+s+" here.\n");
          else if(o!=ob) tell_object(ob2,o->long());
		  else tell_object(ob2,o->long(s));

	if (!o || !o->query_visable_inventory()) return 1;

	inv = all_inventory(o);

	if (living(o) && inv)
	  {
	    	for(i=0;i<sizeof(inv);i++) 
		 {
			string extra_str;

			if(!inv[i]) continue;

			extra_str = inv[i]->extra_look();

			if (extra_str) tell_object(ob2,extra_str + ".\n");
	         }
	  }

       if(!inv) return 1;

       if (living(o)) 
	   tell_object(ob2,"\t" + o->query_name() + " is carrying:\n");
	       else tell_object(ob2,"\tthe " + o->query_name() + " contains:\n");

       for(i=0;i<sizeof(inv);i++) 
	{
	    string sh;

            if(!inv[i] || !inv[i]->short()) continue;

	    sh = inv[i]->short();

	    if (sh) tell_object(ob2,sh + ".\n");
	}

       return 1;
    }
  else if(!look_in_room(ob2,str,mode,extra_light-1))
	 tell_object(ob2, "Look AT something or what?\n");

  return 1;
}

look_in_room(ob, str,mode,extra_light)
{
  pointer dest_dir;
  object env,room;
  int i,s;

  if(!(env=environment(ob))) return 0;

  if(!(dest_dir=env->query_dest_dir())) return 0;

  for(s=sizeof(dest_dir);i<s;i++)
    {
       if(dest_dir[i][0] == str)
        {
	    if(!(room=find_object(dest_dir[i][1])))
		{
			call_other(dest_dir[i][1],"???");
			room=find_object(dest_dir[i][1]);
		}

	    return look(0,mode,room,ob,extra_light+find_light(room));
	}
     }
  if((str=find_short_alt(str)))
	 return look_in_room(ob,str,mode,extra_light);

  return 0;
}

find_short_alt(str)
{
  int el;

  if((el=search_array(DIR_WORDS_SHORT,str))==-1) return 0;

  return DIR_WORDS[el];
}
  
here(st, ob) 
{
    object tmp,env;

    if(!ob) ob = this_player();

    tmp = present(st, ob);

    if(!tmp && (env=environment(ob)))
     {
       tmp = present(st, env);
       if(!tmp && env->id(st)) tmp=env;
     }

    return tmp;
}

find_light(ob) {
    if(!ob) ob = this_player();

    if(environment(ob))  ob=environment(ob);

    return query_light(ob);
}

stime(n) { return MCP->stime(n); }

do_action_msg(a,action)
{
string check_for_a,msg;

    check_for_a=lower_case(a->query_name());
    msg=this_player()->query_name()+" "+action+" ";


    if(!strncmp(check_for_a,"the ",4)) 
	{
 	   check_for_a=strchr(check_for_a,' ');
	   check_for_a++;
	}

    if(strchr("aeiou",check_for_a[0]) ||
      (check_for_a[0]=='y' && !strchr("aeiou",check_for_a[1])) )
        if(!strncmp(check_for_a,"an ",3) || 
	   !strncmp(check_for_a,"a ",2)) {}
	else msg+="an ";
     else msg+="a ";

    msg+=check_for_a+".\n";

    say(msg);
    write("Ok.\n");
}

valid_name(name)
{
  int i,s;

  name=lower_case(name);
  
  if((s=strlen(name))<3 || s> 20) return 0;

  for(;i<s;i++)
     if(name[i]<32 || name[i]>126 || strchr(BAD_CHAR,name[i])) return 0;

  return name;
}

strip_lf(str)
{
  return MCP->strip_lf(str);
}

/*
 * This routine is called from objects that moves the player.
 * Special: direction "X" means teleport.
 * The argument is "how#where".
 * The second optional argument is an object to move the player to.
 * If the second argument exists, then the first argument is taken
 * as the movement message only.
 */

move_player( ob_to_move , dir , dest , op_msg )
{
    int is_light, i;
    string tmp;

        if(strncmp(dest,"r1/",3)) dest="r1/"+dest;

        if(!find_object(dest)) call_other(dest,"??");

	dest=find_object(dest);

	if(!dest)
	  {
	    tell_object(ob_to_move,"Could not locate destination.\n");
	    return;
          }

    if(dir == "X" && ob_to_move->query_wiz_level() < PROBATE &&
      (environment(ob_to_move)->query_property("NT") ||
       dest->query_property("NT"))) 
     {
	tell_object(this_object(),
                    "A force tugs at you, but can't seem to move you.\n");
	return;
     }

    if(environment(ob_to_move)) is_light=query_light(environment(ob_to_move));

    if(is_light < 0) is_light = 0;

    if(op_msg) tmp=op_msg;
      else if(dir=="X") tmp=ob_to_move->query_mmsgout();     
         else tmp=ob_to_move->query_msgout()+" "+dir +".";

    if(is_light && !ob_to_move->query_invis())
	tell_room(environment(ob_to_move),(ob_to_move->query_ghost()?"The ghost of ":"" ) +
	       ob_to_move->query_name() + " " + tmp + "\n",ob_to_move ) ;

    move_object(ob_to_move, dest);

    is_light = query_light(dest);

    if(is_light < 0) is_light = 0;

    if(op_msg) tmp=op_msg;
      else if(dir=="X") tmp=ob_to_move->query_mmsgin();     
         else tmp=ob_to_move->query_msgin()+" from the "+dir+".";

    if(is_light && !ob_to_move->query_invis())
	tell_room(environment(ob_to_move), ( ob_to_move->query_ghost()?"The ghost of ":"" ) +
	       ob_to_move->query_name() + " " + tmp + "\n",ob_to_move) ;

    if (!ob_to_move->query_use_light() && !is_light)
      {
        if(wiz(ob_to_move) && !ob_to_move->query_no_room_names() &&
	   environment(ob_to_move)==dest)
	      tell_object(ob_to_move, "/" + file_name(dest) + "\n");

	write("A dark room.\n");
	return;
      }

    if(environment(ob_to_move)==dest)
        look(0,ob_to_move->query_brief(),dest,ob_to_move,find_light(ob_to_move));
}

dest_all_inv(ob)
{
int i,s;
pointer arr;

   for(arr=all_inventory(ob),s=sizeof(arr);i<s;i++)
    {
        if(!objectp(arr[i])) continue;

	if(first_inventory(arr[i])) 
	  {
            dest_all_inv(arr[i]);
	    if(!objectp(arr[i])) continue;
	  }

        destruct(arr[i]);
    }
}
