#include "living.h"
#include "wizard.h"
#include "levels.h"
#include "log.h"
#include "generic.h"

#define MCP "r1/closed/mcp"

private;
no_ext_save;

#define MAX_SCAR	10
#define CHUNK 22
#define WIZ 1
#define ARCH 0

int talk;            	/* For talk echo */
int block_sh,block_tells;

int scar,chunk;
int intoxicated;			/* How many ticks to stay intoxicated. */
int is_blocked;    			/* Used by Wiz_block */
int stuffed;				/* How many ticks to stay stuffed */
int soaked;					/* How many ticks to stay soaked */
int headache, max_headache;

string title;				/* Player title. */
string descript;			/* Personal Description. */
string al_title;			/* Alignment title. */
string saved_where;     	/* room location */
string access_list;			/* What extra directories can be modified */
string msghome;				/* Wizard home message. */
string current_path;		/* Current directory */
string user_name;			/* the name of the user that owns this account. */

static string more_file;	/* Used by the more command */
static string invis_name;	/* Wizards invisable name. */

static int new_player;
static int more_line;
static int time_to_save;	/* Time to autosave. */
static int last_time;

static int log_flag,no_save,dest_on_save;

static object me;

/* link() is called when the players logges on. */

static link(arg) 
{
	last_time=time();
	no_save = 1;
	time_to_save = time()+ 900;
	me = this_object();
	enable_commands(1);
	call_out("time_out", 120);
    if(!arg || arg == "") {destruct(me);R0}
	arg=lower_case(arg);
	if(file_size("/r1/banish/"+arg)>=0) 
	  {
		write("That name is reserved.\n");
		destruct(me);
		R0
	  }
	if(arg != "guest" && !restore_object("r1/players/"+arg)) 
	 {
		write("New character.\n");
		credits = 500.00;
		user_name=arg;
		name=arg;
		talk=1;
		new_player = 1;
		playing_time=time();
	 }
        init_arrays();
	if(arg == "guest") 
	 {
		hit_points=({50,0});
		spell_points=({0,0});
		title = "the guest";
		name="guest";
		use_light = 1;
		set_neuter();
		user_name="guest";
	 }
	if(arg!=user_name)
	 {
		write("Error, This is not your account.\n");
		destruct(me);
		R0
	 }
	time_to_save = time()+900;
	dead = ghost;
	weight[1] = 0;
	o = find_player(name);
	set_living_name(name);
	cap_name=capitalize(name);
	if(new_player)
	  {
	    set_up_new_player();
	set_race("elf");
	set_class("fighter");
        set_level("fighter",1);
	talk=1;
        set_dex(1);
	set_str(1);
	set_con(1);
	set_int(1);
	set_wis(1);
	  set_hit_points(10);
	  }
	check_gender();
	
#ifdef LOG_ENTER
	log_file("ENTER", cap_name+", "+ctime(time())+".\n");
#endif
}

static set_up_new_player()
{
 object torch;
 int tm;

#ifdef LOG_NEWPLAYER
	log_file("NEWPLAYER", cap_name+" on:"+ctime(time())+".\n");
#endif
	if(user_name!="guest" && file_size("/r1/players/"+name+".s")==-1) 
		mkdir("/r1/players/"+name+".s");
	new_player = 0;
    torch=clone_object("r1/obj/torch");
    move_object(torch,this_object());
    tm="r1/room/room_dev/day_night"->query_time();
    if(tm<2 || tm>4)
	 {
		write("It is currently night time, you have been granted a lit torch.\n");
	    torch->light("torch");
	 }
	else write("It is currently day time, you have been granted an unlit torch.\n");
}

static check_gender() 
{
	remove_call_out("time_out");
	if(name == "guest") 
	  {
		finnish();
		R0
	  }
	if(gender == -1)
     {
		write("Are you, "+GENDER[0]);
		for(i=1;i<(sizeof(GENDER)-1);i++) write(", "+GENDER[i]);
		write(", "+GENDER[i]+": ");
		input(this_object(),"get_gender2");
     }
    else finnish();
}

static get_gender2(str) 
{
	if(stringp(str) && str!="") 
	   {str = lower_case(str);
		for(i=0;i<sizeof(GENDER);i++)
			if(!strncmp(GENDER[i],str,strlen(str)))
			  {
				write("Welcome, "+capitalize(GTYPE[i])+", be sure to use the 'help' command.\n");
				gender=i;
				title=find_title(1,i);
				break;
			  }
		if(gender!=-1)
		  {
			 finnish();
			 return;
		  }
       }
	check_gender();
}

static finnish() 
{
   int min;

   if(name != "guest" && o) 
	  {
		 write("You are already playing!\n");
		 write("Throw the other copy out?");
		 input(this_object(),"try_throw_out");
		 R0
	  }
	add_soul_commands();
	add_standard_commands();
	if(wiz_level >= APRENTICE) wiz_commands();
	move_object(me, "r1/room/start");
	log_flag = 1;
	more("/r1/news/NEWS");
}

static finnish2()
{
    if(wiz_level >=APRENTICE) cat("/r1/news/WIZNEWS");
    if (is_invis && wiz_level < SENIORE) vis();
    if(is_invis) 
	  {
		 is_invis=0;
		 invis();
	  }
    if(block_tells && !is_invis) write("TELLS FROM LOWER LEVEL USERS ARE BLOCKED!\n\n");
    if(block_sh)
     {
       block_shouts(1); 
       write("ALL SHOUTS ARE BLOCKED!\n\n");
     }
    if(use_light) write("YOU CAN SEE IN THE DARK!\n\n");
    if(is_blocked) write("YOU ARE BLOCKING THE WIZCHANNEL!\n\n");
    if(no_room_names) write("YOU DO NOT SEE ROOM NAMES!\n\n");
    if(!current_path && wiz_level) current_path = "r1/players/" + name;
    if(credits<0.00) credits=0.00;
	verb_matching(find_link(this_object())->query_verb_pref());
	set_heart_beat(1);
	move_object(clone_object("r1/obj/obj_dev/player_info"),this_object());
	restore_inv();
	write("Now entering game...");
	call_out("finnish3",1);
}

finnish3()
{
    write("\n");

    if(saved_where && saved_where!="r1/room/void") move_object(me, saved_where);
     else
      {
        move_object(me, "r1/room/church");
        saved_where="r1/room/church";
      }

    if(user_name!="guest") no_save=0;
    save_me(2);

    if(!is_invis) say(cap_name+" enters the game.\n");

    if(!brief) look();
      else glance();
}

static try_throw_out(str)
{
	object ob;
    pointer arr;
    int i;

    remove_call_out("time_out");
	str=lower_case(str);
    if (str[0] != 'y')
	  {
   		write("Welcome another time then !\n");
	    destruct(this_object());
		return;
	  }
    if(query_ip_number(o)) 
	  {
         write("I'm sorry but somone else is using this account.\n");
         destruct(this_object());
		 return;
	  }
    dest_on_save=1;
    save_me();
    dest_on_save=0;
    for(arr = all_inventory(o);i<sizeof(arr);i++)
	 {
		int w;

		if(!objectp(arr[i])) continue;
		w = arr[i]->query_weight();
	    if(!objectp(arr[i])) continue;
		if (add_weight(w))
	      {
	    	arr[i]->drop();
	    	if (objectp(arr[i])) move_object(arr[i], this_player());
	  	  }
     }
    ob = environment(o);
	o->quit();
    if (!restore_object("r1/players/" + name))
      if(o) destruct(o);
    o=0;
#ifdef LOG_ENTER
    log_file("ENTER", " (throw)\n");
#endif
	finnish(ob);
}

/* Called by command 'save' */

save_character() 
{
    save_me(1);
    write("Ok.\n");
    return 1;
}
 
reset(arg) 
{
    if (arg || me) return;
    if (creator(this_object())) 
	  {
		illegal_patch("Cloned player.c");
		no_save=1;
		destruct(this_object());
		return;
      }  
    chunk = CHUNK;
	invis_name = "Someone";
    init_arrays();
    name = "logon";
    cap_name = "Logon";
    msgin = "arrives"; msgout = "leaves";
    mmsgin = "arrives in a puff of smoke";
    mmsgout = "disappears in a puff of smoke";
    title = "the title less";
    al_title = "neutral";
    gender = -1; /* Illegal value, so it will be changed! */
}

/* Enable other objects to query our hit point. */

short() 
{
    string to_return;

    if(is_invis) 
	  {
        if(this_player()->query_wiz_level()<wiz_level) return;
          else to_return = "("+capitalize(name)+")";
      }
	 else if (ghost) to_return = "The ghost of " + cap_name;
    	  else to_return = cap_name + " " + title + " (" + al_title + ")";
    if(query_ip_number(this_object()) && query_idle(this_object())/60)
      to_return += " {"+(query_idle(this_object())/60)+"}";
    if(to_return) 
        if(query_ed(this_object())) to_return = "[ "+to_return+" ]";
    if(query_verb() != "who" && query_verb() != "swho" && attacker &&
      present(attacker))
        to_return += " *Fighting "+attacker->query_name()+"*";
    return to_return;
}

long() 
{
    string cap_pronoun;

    if(is_invis && this_player()->query_wiz_level()<wiz_level) return;
    cap_pronoun = capitalize(query_pronoun());
    write(short() + ".\n");
    if (ghost) return;
    show_scar();
    if (hit_points[0] < hit_points[1]/10)
		write(cap_pronoun + " is in very bad shape.\n");
      else if (hit_points[0] < hit_points[1]/5) 
			  write(cap_pronoun + " is in bad shape.\n");
    	else if (hit_points[0] < hit_points[1]/2) 
		  	    write(cap_pronoun + " is not in a good shape.\n");
    	  else if (hit_points[0] < 3*hit_points[1]/4) 
				  write(cap_pronoun + " is slightly hurt.\n");
    		else write(cap_pronoun + " is in good shape.\n");
    if(descript) write(descript+"\n");
}

score() 
{
    string tmp;

    if (ghost) 
	  {
		write("You are in an immaterial state with no scores.\n");
	    return 1;
      }
	if(!wiz_level) sprintf(tmp,"Level : %-3d  (%s)\n",levels[0],al_title);
	  else tmp="Level : "+wiz_level+" (wizard)\n";
	write(tmp);
	sprintf(tmp,"H.P.  : %-4d (%5s                 Str   : %-d\n",hit_points[0],
		    (hit_points[1]+")"),Str[0]);
	write(tmp);
	sprintf(tmp,"S.P.  : %-4d (%5s                 Dex   : %-d\n",spell_points[0],
		   (spell_points[1]+")"),Dex[0]);
	write(tmp);
    sprintf(tmp,"Exp   : %-10d                  Con   : %-d\n",exp[0],Con[0]);
    write(tmp);
	sprintf(tmp,"Credits: %-10.2f                  Int   : %-d\n",credits,Int[0]);
	write(tmp);
	sprintf(tmp,"                                    Wis   : %-d\n",Wis[0]);
	write(tmp);
    if (whimpy) write("\nWimpy mode  : "+whimpy+"0%  "+(whimpy_dir?("Cmd: "+whimpy_dir):"")+"\n");
     else write("\nBrave mode.\n");
    if (intoxicated || stuffed || soaked)
      {
  	    tmp = "You are ";
        if (intoxicated)
			{
	    	  tmp += "intoxicated";
	    	  if (stuffed && soaked) tmp += ", ";
	    	    else
	    		 {
				   if (stuffed || soaked) tmp += " and ";
					else tmp += ".\n";
	    		 }
			}
        if (stuffed)
		  {
	    	tmp += "satiated";
	    	if (soaked) tmp += " and ";
	    	  else tmp += ".\n";
		  }
		if (soaked) tmp += "not thirsty.\n";
	    write(tmp);
      }
    show_playing_time();
    return 1;
}

/* Identify ourself. */

id(str, lvl)
{
    if(wiz_level < JUNOR || (wiz_level>=JUNOR && !is_invis))
	  if(str == name || str == "ghost of " + name) return 1;
		else return 0;

    /*
	   This is for invisable wizards.
	 */

    if (lvl && is_invis && lvl < wiz_level) return 0;
	if(!this_player()) return 0;
    if(this_player()->query_wiz_level() >= ADMIN &&
	   (name=="str" || name=="ghost of "+name)) return 1;
    if (is_invis)
	 if(this_player()->query_wiz_level()<wiz_level) return 0;
	  else if(str==name || str=="ghost of "+name) return 1;
}


set_level(cls,lev)
{
int lev_diff;

    if(this_player() && this_player()!=this_object() &&
       this_player()->query_wiz_level() &&
	   this_player()->query_wiz_level()<ADMIN)
      {
        log_file("ADVANCE","The Wizard "+this_player()->query_real_name()+
             " tried to change "+name+" players level@"+ctime(time())+"\n");
        return illegal_patch("set_level");
      }
   if(name=="guest" || name=="logon" || !query_ip_number(this_object())) 
       return 0;

   if(wiz_level && wiz_level<ADMIN) return 0;

   if(this_player() != this_object()) 
      log_file("ADVANCE", this_player()->query_name()+"["+
      	       this_player()->query_level()+"] changed "+cap_name+"["+levels[0]+
      	       "] to Level "+lev+" at "+ctime(time())+"\n");
  	else log_file("ADVANCE",name+" changed there level to "+lev+" from "+levels[0]+
   			      "@"+ctime(time())+"\n");
   lev_diff=levels[0]-lev;

   r1/obj/living::set_level(cls,lev);

   hit_points[1]=(random(hit_points_die[0]*hit_points_die[1])+hit_points[0])*lev_diff;
}

set_title(t) { title = t?t:""; }

static earmuffs(str)
{
  if(str=="on")
   {
     block_sh=1;
     block_shouts(1);
     write("Earmuffs are on.\n");
   }
  else
   {
      block_sh=0;
      block_shouts(0);
      write("Earmuffs are off.\n");
   }
 return 1;
}

static block_tell(str)
{
  if(str=="on")
   {
     block_tells=1;
     write("Tells blocked from lower level users.\n");
   }
  else
   {
     block_tells=0;
     write("All tells enabled.\n");
   }
  return 1;
}


static set_use_light(str)
{
  if(str=="on")
   {
     use_light=1;
     write("You can now see without light.\n");
     return 1;
   }
  if(str=="off")
   {
     use_light=0;
     write("Your vision is now dependent on light.\n");
     return 1;
   }
}
  
static wiz_commands() 
{
    if(!this_player() || this_player() != this_object()) return;
    add_action("set_title","title",2);
    add_action("teleport","goto");
    add_action("list_peoples","people");
    add_action("set_alignment","setal",2);
    add_action("wiz_panic","HELP");
    if(wiz_level<PROBATE) return;
    add_action("clone","clone",2);
    add_action("makedir","mkdir",2);
    add_action("removedir","rmdir",2);
    add_action("pwd","pwd",2);
    add_action("more","more",2);
    add_action("chunk_set", "chunk", 2);
    add_action("home","home",2);
    add_action("remove_file","rm",2);
    add_action("mv_file","mv",2);
    add_action("cp_file","cp",2);
    add_action("cat_file","cat",2);
    add_action("tail_file","tail",2);
    add_action("edit","ed",2);
    add_action("destruct_local_object","dest",2);
    add_action("local_commands","localcmd",2);
    add_action("wiz_score_list","wizlist");
    add_action("wiz_tell","wiztell",2);
    add_action("stat","stat");
    add_action("update_object","update",2);
    add_action("reset_object","reset",2);
    add_action("load","load",2);
    add_action("setmmin","setmmin",2);
    add_action("setmmout","setmmout",2);
    add_action("setmin","setmin",2);
    add_action("setmout","setmout",2);
    add_action("review","review",2);
    add_action("cd","cd",2);
    add_action("list_files","ls",2);
    add_action("list_files","lf",2);
    add_action("read_log","log",2);
    add_action("purge_log","purge",2);
    
   if(wiz_level<WIZARD) return;
    add_action("my_level", "level", 2);
    add_action("earmuffs","earmuffs",2);
    add_action("sethome","sethome",2);
    add_action("set_use_light","light",2);
    add_action("set_room_names","path",2);
    add_action("goto_castle","castle");
   if(wiz_level<JUNOR) return;
    add_action("invis","invis",2);
    add_action("vis","vis",2);
	add_action("grep_file","grep",2);
   if(wiz_level<SENIORE) return;
    add_action("block_tell","blocktell",2);
    add_action("echo","echo",2);
    add_action("in_room","in",2);
    add_action("set_block","wizblock");
    add_action("trans","trans",2);
 
  if(wiz_level<ELDER) return;
    add_action("echo_all","echoall",2);
    add_action("echo_to","echoto",2);
    add_action("zap","zap",2);
    add_action("heal","heal",2);
  if(wiz_level<ADMIN) return;
	add_action("prison_player",({"prison","prison2"}),2);
    add_action("force","force",2);
    add_action("snoop_on","snoop",2);
}

static echo_all(str) 
{
    if (!str)
	  {
       write("Echoall what?\n");
       return 1;
      }
    shout(str + "\n");
    write("You echo: " + str + "\n");
    return 1;
}

static echo(str) 
{
    if (!str) 
	  {
       write ("Echo what?\n");
       return 1;
      }
    say (str + "\n");
    write ("You echo: " + str + "\n");
    return 1;
}

static echo_to(str)
{
    object ob;
    string who;
    string msg;

    if (!str || sscanf(str, "%s %s", who, msg) != 2)
	  {
		write("Echoto what ?\n");
		return 1;
      }
    ob = find_living(lower_case(who));
    if (!ob)
	  {
		write("No living thing found with that name.\n");
		return 1;
      }
    tell_object(ob, msg + "\n");
    write("You echo: " + msg + "\n");
    return 1;
}

static teleport(dest) 
{
    object ob;

    if (!dest) 
	  {
		write("Goto where ?\n");
		return 1;
      }
    ob = find_living(dest);
    if(ob && !ob->short()) ob=0;
    if (ob)
     {
	ob = environment(ob);
        if(ob && file_name(ob)!="r1/room/start")
	  move_player("X#"+file_name(ob));
      }
    else
      {
		if(dest[0]!='/') dest=rectify_path(dest);
		if(!dest) return 1;
        dest = valid_read(dest, WIZ);
        if(dest=="r1/room/start") dest=0;
        if(file_size("/"+dest+".c")<1) dest=0;
        if (!dest) write("Invalid living name or file name.\n");
          else move_player("X#" + dest);
      }
   return 1;
}
 
quit()
{
#ifdef LOG_QUIT
    log_file("QUIT", cap_name+", "+ctime(time())+".\n");
#endif
    if(find_object("r1/players/arkon/control/logger"))
        find_object("r1/players/arkon/control/logger")->log_p(this_object());
  if(name!="guest" && name!="logon")
   {
    dest_on_save=1;
/*    save_me(0);  done by destruct now :) */
    write("Saving "+cap_name+".\n");
   }
   else
    {
      object ob;
      drop_all();
      ob=first_inventory(this_object());
      while(ob)
       {
         destruct(ob);
         ob=first_inventory(this_object());
       }
     no_save=1;
    }
   if (!is_invis) say(cap_name + " left the game.\n");
   set_heart_beat(0);
   destruct(this_object());
   return 1;
}

communicate(str) 
{
    string verb;

    verb = query_verb();
    if (!str) str = "";
    str = valid_input(str);
    if (ghost)
	  {
		say(short() + " says: " + str + "\n");
		if(talk) write(short()+" says: "+str+"\n");
		  else write("Ok.\n");
		return 1; 
	  }
    say(cap_name + " says: " + str + "\n");
    if(talk) write(cap_name+" says: "+str+"\n");
      else write("Ok.\n");
    return 1;
}

static heart_beat() 
{
    if (name!="guest" && time() > time_to_save && wiz_level <PROBATE) 
      {
	if (!brief) write("Autosave.\n");
	save_me(1);
	time_to_save = time() + 900;
      }

    if(ghost) return;

    if (intoxicated && random(40) == 0) 
      {
	int n;

	n = random(7);
	if (n == 0) 
	  {
	    	say(cap_name + " hiccups.\n");
	    	write("You hiccup.\n");
	  }
	if (n == 1) 
	  {
	        say(cap_name + " seems to fall, but takes a step and recovers.\n");
	    	write("You stumble.\n");
	  }
	if (n == 3) 
	  {
	    	write("You feel drunk.\n");
	    	say(cap_name + " looks drunk.\n");
	  }
	if (n == 5) 
	  {
	    	say(cap_name + " burps.\n");
	    	write("You burp.\n");
	  }
      }

    if (hit_points[0] < hit_points[1] || spell_points[0] < spell_points[1] ||
        stuffed || soaked || intoxicated || headache)
      {
	time_to_heal -= 1;
	if (time_to_heal < 0) 
	  {
	     if (headache) 
	       {
		headache -= 1;
		if (!headache)
		   tell_object(me, "You no longer have a headache.\n");
		   hit(-3);
	       }

	      heal_self(1);
	      if (intoxicated || soaked || stuffed) heal_self(2);
	  }
        if (intoxicated) 
	  {
		intoxicated -= 1;
		if (!intoxicated)
		  {
	    		headache = max_headache;
	    		max_headache = 0;
	    		tell_object(me, "You suddenly without reason get a bad headache.\n");
	    		hit(3);
		  }
	   }
	 time_to_heal = INTERVAL_BETWEEN_HEALING;
      }
  if (stuffed) stuffed--;
  if (soaked) soaked--;
}

/*
 * Update our aligment.
 */

set_alignment(a) { al_title=a; return 1;}

add_alignment(a) 
{
    if (numberp(a)!=1)
	  {
		write("Bad type argument to add_alignment.\n");
		return;
      }
    alignment = alignment*9/10 + a;
    if (wiz_level > APRENTICE) return;
    if (alignment > 120) 
		al_title = "saintly";
    else if (alignment > 80 && alignment <121)
		al_title = "good";
    else if (alignment > 40 && alignment<81) 
		al_title = "nice";
    else if (alignment >=-40 && alignment <=40)
		al_title = "neutral";
    else if (alignment < -40 && alignment>-81)
		al_title = "bad";
    else if (alignment < -80 && alignment>-120)
		al_title = "evil";
    else al_title = "nasty";
}

set_al(a) 
{
    if (numberp(a)!=1) return;
    alignment = a;
}

static test_dark() 
{
    if (set_light(0) <= 0) 
	  {
		write("It is too dark.\n");
		return 1;
      }
    return 0;
}

put(str)
{
    int i;
    string item;
    string container;
    object item_o;
    object container_o;

    if (!str) return 0;
    if (!use_light && test_dark()) return 1;
    if (sscanf(str, "%s in %s", item, container) != 2) 
	  {
		write("put what ?\n");
		return 1;
      }
    container = lower_case(container);
    container_o = present(container, this_player());
    if (!container_o)
	  container_o = present(container, environment(this_player()));
    if (!container_o) 
	  {
		write("There are no " + container + "s here!\n");
		return 1;
      }
    if (!container_o->can_put_and_get()) 
	  {
		write("You can't do that.\n");
		return 1;
      }
    item = lower_case(item);
    item_o = present(item, this_player());
    if (!item_o) 
	  {
		write("You have no " + item + "!\n");
		return 1;
      }
    if (item_o == container_o) return 0;
    if (item_o->prevent_insert()) return 1;
    if (item_o->drop()) return 1;
    i = item_o->query_weight();
    if (container_o->add_weight(i)) 
	  {
  		/* Remove the weight from the previous container. */

	    environment(item_o)->add_weight(-i);
		move_object(item_o, container_o);
		say(cap_name + " puts the " + item + " in the " + container + ".\n");
		write("Ok.\n");
		return 1;
      }
    write("The "+lower_case(container)+" is too full to hold it.\n");
    return 1;
}

pick_up(str) 
{
    string item;
    string container;
    object item_o;
    object container_o;
    int w;

    if (!str) 
 	  {
		write("What ?\n");
		return 1;
      }
    if (ghost) 
	  {
		write("You fail.\n");
		return 1;
      }
    if (!use_light && test_dark()) return 1;
    if (str == "all") 
	  {
		get_all(environment());
		return 1;
      }
	if(sscanf(str,"all %s",item)==1 && sscanf(item,"%s from %s",item_o,container)!=2 && sscanf(item,"from %s",container)!=1)
	  {
		get_all(environment(),0,lower_case(item));
		return 1;
	  }
    if (sscanf(str, "%s from %s", item, container) != 2) 
	  {
		pick_item(str);
		return 1;
      }
    container_o = present(lower_case(container));
    if (!container_o) 
	  {
		write("There is no " + container + " here.\n");
		return 1;
      }
    if (!container_o->can_put_and_get()) 
	  {
		write("You can't do that!\n");
		return 1;
      }
    if(item=="all")
     {
       get_all(container_o,lower_case(container));
       return 1;
      }
	if(sscanf(item,"all %s",item_o)==1)
	 {
	  get_all(container_o,lower_case(container),lower_case(item_o));
	  return 1;
	 }
    item_o = present(item, container_o);
    if (!item_o)
	  {
		write("There is no " + item + " in the " + container + ".\n");
		return 1;
      }
    if (!item_o->get(item)) 
	  {
		write("You can not take the " + item + " from " + container + ".\n");
		return 1;
      }
    w = item_o->query_weight();
    if (!add_weight(w)) 
	  {
	    write("You can not carry more.\n");
		return 1;
      }
    container_o->add_weight(-w);
    move_object(item_o, me);
    write("Ok.\n");
    say(cap_name + " takes the " + item + " from " + container + ".\n");
    return 1;
}

pick_item(obj) 
{
    object ob;
    int i;

    obj = lower_case(obj);
    if (environment(this_player())->id(obj))
	  {
		write("You can't take that.\n");
		return 1;
      }
    ob = present(obj, environment(this_player()));
    if (!ob)
	  {
		write("That is not here.\n");
		return 1;
      }
    if (ghost) 
	  {
		write("You fail.\n");
		return 1;
      }
    if (environment(ob) == me) 
	  {
		write("You already have it!\n");
		return 1;
      }
    if (!ob->get()) 
	  {
		write("You can not take that!\n");
		return 1;
      }
    i =ob->query_weight();
    if (add_weight(i)) 
	  {
		move_object(ob, me);
		say(cap_name + " takes the " + obj + ".\n");
		write("Ok.\n");
		return 1;
      }
    write("You can't carry that much.\n");
    return 1;
}

drop_thing(obj) 
{
    string tmp;
    string tmp2;
    int i;

    if (!obj) 
	  {
		write("What ?\n");
		return 1;
      }
    if (obj == "all") 
	  {
		drop_all(1);
		return 1;
      }
	if(sscanf(obj,"all %s",tmp)==1)
	 {
		 drop_all(1,tmp);
		 return 1;
	 }
    if (sscanf(obj, "%s in %s", tmp, tmp2) == 2) 
	  {
		put(obj);
		return 1;
      }
    tmp = obj;
    obj = present(lower_case(obj), this_player());
    if (!obj)
	  {
		write("That is not here.\n");
		return 1;
      }
    if (drop_one_item(obj)) 
	  {
		write("Ok.\n");
		say(cap_name + " drops the " + tmp + ".\n");
      }
    return 1;
}

/*
 * Temporary move the player to another destination and execute
 * a command.
 */

static in_room(str)
{
    object room;
    object old_room;
    string cmd;
    if (!str) return 0;
    if (sscanf(str, "%s %s", room, cmd) != 2) 
	  {
		write("Usage: in ROOM CMD\n");
		return 1; 
	  }
    room = valid_read(room, WIZ);
    if (!room) 
	  {
		write("Invalid file name.\n");
		return 1; 
	  }
    old_room = environment();
    move_object(me, room);
    command(cmd);
    if(old_room) move_object(me, old_room);
	  else write("Error: return room is missing.\n");
    return 1;
}

shout_to_all(str) 
{
 string list;
 int i;

    if (spell_points[0] < 0) 
	  {
		 write("You are low on power.\n");
		 return 1;
      }
    str = valid_input(str);
    if (!str) 
	  {
		write("Shout what ?\n");
		return 1;
      }
    if (ghost) 
	  {
		write("You fail.\n");
		return 1;
      }
    if (wiz_level < APRENTICE) adj_spell_points(-20);
    shout(cap_name+" shouts: "+str+"\n");
    if(talk) write("You shout: "+str+"\n");
	  else write("Ok.\n");
    return 1;
}

emote(str)
{
    string first, last, out, tmp, temp;

    if(name=="guest") return 0;
    str = valid_input(str);
    if (!str)
	  {
       write("emote what?\n");
       return 1;
      }

	/* important stuff \/ */

    if(wiz_level<PROBATE)                     /* Player charaters use  */
	  {
        say(":"+cap_name+" "+str+"\n");       /* this routine, wizards */
        if(talk)                              /* skip over it and use  */
            write(":"+cap_name+" "+str+"\n"); /* the next routine.     */
        return 1;
      }

	/* Wizard routine \/ */

    if(this_player()->query_wiz_level()<JUNOR) 
		tmp = ":";								    /* Prevents new wizes */
      else tmp = "";                                /* from confusing     */
    if(sscanf(str,"%s^%s",first,last) == 2)         /* players in a       */
      {
	    if(first[strlen(first)-1]!=' ') first+=" "; /* harmful way.       */
        if(last[0] != ' ') last=" "+last;
        out = tmp+first+cap_name+last;
      }
	else if(sscanf(str,"%s^",first) == 1) 
	      {
        	if(first[strlen(first)-1] != ' ') first+=" ";
        	out = tmp+first+cap_name+".";
    	  }
		else out = tmp+cap_name+" "+str;
    write(out+"\n");
    say(out+"\n");
    return 1;
}

inventory() 
{
    string inv;
    int i;

    if (!use_light && test_dark()) return 1;
    inv = all_inventory(me);
    for(i=0;i<sizeof(inv);i++) 
	  {
		string str;

        if(!inv[i]) continue;
		str = inv[i]->short();
	 	if (str) write(capitalize(str) + ".\n");
      }
    return 1;
}
 
examine(str) { return look("at " + str); }

glance(str) { return look(str,1); }
 
look(str,mode) 
{
 return "r1/closed/mcp"->look(str,mode,0,0);
}

static rectify_path(path)
{
    return "closed/mcp"->rectify_path(path);
}

static list_files(path)
{
int path_stat;

    if(!path) path="*";
    path=rectify_path(path);
	if(!path) return 1;
    write(path+"\n");
    if(path!= "/") path = path + "/.";
	  else path+=".";
    ls(path);
    return 1;
}
 
tail_file(path)
{
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot tail a directory.\n");
       return 1;
     }
    if (!tail(path)) return 0;
    return 1;
}
 
cat_file(path)
{
    if(this_player()!=this_object()) return 0;
    if (!path) return 0;
    path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot cat a directory.\n");
       return 1;
     }
    cat(path);
    return 1;
}
 
 
tell(str)
{
    object ob;
    string who;
    string msg,it;
    if (ghost) {
	write("You fail.\n");
	return 1;
    }
    if (spell_points[0] < 0) {
	write("You are low on power.\n");
	return 1;
    }
    if (wiz_level < APRENTICE)
	adj_spell_points(-5);
    if (!str || sscanf(str, "%s %s", who, msg) != 2) {
	write("Tell what ?\n");
	return 1;
    }
    it = lower_case(who);
    ob = find_living(it);
    if (!ob) {
	write("No player with that name.\n");
	return 1;
    }
    if(ob->query_block_tells() && levels[0]<ob->query_level())
     {
       write("No player with that name.\n");
       return 1;
     }
    msg = valid_input(msg);
    if(is_invis && wiz_level>=ADMIN && ob->query_level()<levels[0])
       tell_object(ob, "You are told: "+msg+"\n");
         else tell_object(ob, cap_name + " tells you: " + msg + "\n");
        if(talk)
		write("You tell "+who+": "+msg+"\n");
	else
		write("Ok.\n");
    return 1;
}
 
whisper(str)
{
    object ob;
    string who,it;
    string msg;
    if (ghost) {
	write("You fail.\n");
	return 1;
    }
    if (!str || sscanf(str, "%s %s", who, msg) != 2) {
	write("Whisper what ?\n");
	return 1;
    }
    it = lower_case(who);
    ob = find_living(it);
    if (!ob || !present(it, environment(this_player()))) {
	write("No player with that name in this room.\n");
	return 1;
    }
    msg = valid_input(msg);
    tell_object(ob, cap_name + " whispers to you: " + msg + "\n");
        if(talk)
		write("You tell "+who+": "+msg+"\n");
	else
		write("Ok.\n");
    say(cap_name + " whispers something to " + who + ".\n", ob);
    return 1;
}
 
list_peoples() {
    object list;
    int i, a, p;
 
    list = users();
    for(i=0,p=0;i<sizeof(list);i++)
       if(list[i] && ((!list[i]->short() && list[i]->query_wiz_level()<ADMIN) ||
          list[i]->short())) p++;
    write("There are now " + p + " players");
    for (i=0, a=0; i < sizeof(list); i++)
	if (list[i] && ((query_idle(list[i]) >= 5 * 60) &&
            ((!list[i]->short() && list[i]->query_wiz_level()<ADMIN) ||
            list[i]->short())))
	    a++;
    if (a)
	write(" (" + (p - a) + " active)");
    write(". " + query_load_average() + "\n");
    for(i=0; i<sizeof(list); i++) {
	string nm;
	string env;
	int lv;
	string ag,idle;

        if(!list[i] || (!list[i]->query_real_name() && !list[i]->query_name()))
			continue;
        if(list[i]->short() || ( !list[i]->short() &&
           list[i]->query_wiz_level()<ADMIN)) 
		  {
			nm = list[i]->query_real_name();
        	if(!nm) nm = list[i]->query_name();
        	if(!nm) continue;
		    nm=capitalize(nm);
        	if(query_ed(list[i])) nm = "["+nm+"]";
			if (list[i]->query_invis()) nm = "(" + nm + ")";
			lv=list[i]->query_wiz_level()?list[i]->query_wiz_level():
			   list[i]->query_level();
			a = list[i]->query_age();
		 	  if (a / 43200 > 0) sprintf(ag,"%3d %c",a / 43200,'D');
				 else if (a / 1800 > 0) sprintf(ag,"%3d %c",a / 1800,'h');
					else sprintf(ag,"%3d %c",a / 30,'m');
			if (query_idle(list[i]) >= 5 * 60) idle='I';
			  else idle=32;
			if (environment(list[i])) env=file_name(environment(list[i]));
			 else env="";
			sprintf(nm,"%-15s %-11s %4d %s %c %s\n",query_ip_number(list[i]),nm,lv,ag,idle,env);
			write(nm);
      }
    }
    return 1;
}
 
static edit(file)
{
    if (!file) 
	  {
		ed();
		return 1;
      }
    if(file!="-r") file = rectify_path(file);
	if(!file) return;
    if (!ed(file)) write("You do not have access to that file.\n");
    return 1;
}
 
static heal(name)
{
    object ob;
 
    if (!stringp(name)) return 0;
    ob = find_living(lower_case(name));
    if (!ob) {
	write("No such person is playing now.\n");
	return 1;
    }
    call_other(ob, "heal_self", 100000);
    tell_object(ob, "You are healed by " + cap_name + ".\n");
    write("Ok.\n");
    return 1;
}
 
static stat(name)
{
    object ob;
 
    if (!name)
	return 0;
    ob = present(lower_case(name), environment());
    if (!ob || !living(ob))
	ob = find_living(name);
    if (!ob) {
	write("No such person is playing now.\n");
	return 1;
    }
    call_other(ob, "show_stats", 0);
    return 1;
}
 
/*
 * This routine is called from other routines to drop one specified object.
 * We return true if success.
 */
 
drop_one_item(ob)
{
    int w;
 
    if (call_other(ob, "drop", 0)) return 0;
    w = call_other(ob, "query_weight", 0);
    if(w) add_weight(-w);
    move_object(ob, environment(me));
    return 1;
}
 
drop_all(verbose,items)
{
    object inv;
    int i;

    if (!me || !living(me)) return;
    if(items && !present(items,me))
	  {
		 if(items[strlen(items)-1]=='s')
			{
			    items=extract(items,0,strlen(items)-2);
				if(!present(items,me))
				  {
				    write("You are not carrying that.\n");
					return 1;
				  }
			}
		 else
			{
				write("You are not carrying that.\n");
				return 1;
			}
		}
    inv = all_inventory(me);
    for(i=0;i<sizeof(inv);i++) {
	string out;
        if(!inv[i] || (items && !inv[i]->id(items))) continue;
	if (drop_one_item(inv[i]) && verbose) {
	    say(cap_name + " drops " + inv[i]->short()+".\n");
	    tell_object(me, "drop: " + inv[i]->short()+".\n");
	}
    }
}
 
/*
 * Check that a player name is valid. Only allow
 * lowercase letters.
 */

valid_name(str)
{
    int i, length;
    if (str == "logon") {
	write("Invalid name");
	return 0;
    }
    length = strlen(str);
    if (length > 11) {
	write("Your name must not be longer than 11 characters.\n");
	return 0;
    }
    if(length<2) 
      {
         write("Your name must be at least 3 characters in lenght.\n");
         return 0;
      }
    i=0;
    while(i<length) {
	if ((str[i] < 'a' || str[i] > 'z') && str[i]!='-') {
	    write("Invalid characters in name:" + str + "\n");
	    write("Character number was " + (i+1) + ".\n");
	    return 0;
	}
	i += 1;
    }
    return 1;
}
 
bug(str)
{
    if (!str) {
	write("Give an argument.\n");
	return 1;
    }
    log_file("BUGS", "\n");
    log_file("BUGS", cap_name + " (" +
	     file_name(environment(this_object())) + "):\n");
    log_file("BUGS", str + "\n");
    smart_report("Bug " + cap_name + "\n" + str);
    write("Ok.\n");
    return 1;
}
 
typo(str)
{
    if (!str) {
	write("Give an argument.\n");
	return 1;
    }
    log_file("TYPO", cap_name + " (" +
	     file_name(environment(this_object())) + "):\n");
    log_file("TYPO", str + "\n");
    smart_report("Typo " + cap_name + "\n" + str);
    write("Ok.\n");
    return 1;
}
 
idea(str)
{
    if (!str) {
	write("Give an argument.\n");
	return 1;
    }
    log_file("IDEA", cap_name + ":\n");
    log_file("IDEA", str + "\n");
    smart_report("Idea " + cap_name + "\n" + str);
    write("Ok.\n");
    return 1;
}
 
converse()
{
    write("Give '/s' to stop.\n");
    write("]");
    input(this_object(),"converse_more");
    return 1;
}
 
static converse_more(str)
{
    string cmd;
    if (str == "/s") {
	write("Ok.\n");
	return;
    }
    if (str && str[0] == '!') {
	sscanf(str, "!%s", cmd);
	command(cmd);
    } else if (str != "") {
        str = valid_input(str);
	say(cap_name + " says: " + str + "\n");
    }
    write("]");
    input(this_object(),"converse_more");
}
 
toggle_whimpy(str)
{
	if(!str && whimpy) whimpy = 0;
	else if(!str && !whimpy) whimpy = 5;
	else
		if(sscanf(str, "%d", whimpy) != 1) {
			if(sscanf(str, "%s", whimpy_dir) != 1) return;
			write("You set emergency command to '"+whimpy_dir+"'.\n");
			return 1;
		}
	else if(whimpy >5 || whimpy < 0) whimpy = 5;
    if (whimpy)
	write("Wimpy mode set to "+whimpy+"0%.\n");
    else
        write("Brave mode.\n");
    return 1;
}
 
toggle_brief()
{
    brief = !brief;
    if (brief)
        write("Brief mode.\n");
    else
        write("Verbose mode.\n");
    return 1;
}
 
add_intoxination(i) {
    if(i < 0)
    {
	if (-i > intoxicated / 10)
		i = -intoxicated / 10;
    }
    intoxicated += i;
    if(intoxicated < 0)
	intoxicated = 0;
}
 
add_stuffed(i)
{
    if(i < 0)
    {
	if (-i > stuffed / 10)
		i = -stuffed / 10;
    }
    stuffed += i;
    if (stuffed < 0)
	stuffed = 0;
}
 
add_soaked(i)
{
    if(i < 0)
    {
	if (-i > soaked / 10)
		i = -soaked / 10;
    }
    soaked += i;
    if (soaked < 0)
	soaked = 0;
}
 
 
second_life() 
{
object death_mark;

    if(name=="guest") return 0;

    if (wiz_level >= APRENTICE) return illegal_patch("second_life");

    make_scar();
    ghost = 1;
    msgin = "drifts around";
    msgout = "blows";
    headache = 0;
    intoxicated = 0;
    stuffed = 0;
    soaked = 0;

    save_me(0);

#ifdef LOG_KILLS

      log_file("KILLS","\n"+ name + "(" + levels[0] + "/" + levels[1] + 
	       "/" + levels[2] + ")" + " killed by " +
  	       (attacker?attacker->short():"unknown") + "(" +
	       (attacker?attacker->query_real_name():"unknown") +
	       "), creator: " + (attacker?creator(attacker):"unknown") + "\n");

     log_file("KILLS","on : "+ ctime(time()) +" in " + 
	      (environment()?file_name(environment()):"unknown") " + "\n");

#endif

    if(attacker)
	tell_object(this_object(),"You recieve a fatal blow from the "+attacker->query_name()+".\n");
		tell_object(this_object(), "\nYou die.\nYou have a strange feeling.\n" +
		"You can see your own dead body from above.\n\n");

	if(!wiz_level)
	{
	  if(random(100)>=90)
   	    {
    		death_mark = clone_object("r1/room/death/death_mark");
    		move_object(death_mark, this_object());
		save_me(0);
   	    } 
	}
    return 1;
}
 
remove_ghost() {
    if (!ghost) return 0;

    tell_object(this_object(),"You feel a very strong force.\n"+
    "You are sucked away...\n"+
    "You reappear in a more solid form.\n");
    say("Some mist disappears.\n"+ cap_name + " appears in a solid form.\n");
    ghost = 0;
    dead = 0;
    msgin = "arrives";
    msgout = "leaves";
    save_me(1);
    return 1;
}
 
static trans(str)
{
    object ob;
    string out;
 
    if (!str)
	return 0;
    ob = find_living(str);
    if (!ob) {
	write("No such living thing.\n");
	return 1;
    }
    tell_object(ob, "You are magically transfered somewhere.\n");
    out = ob->query_mmsgin();
    if (!out)
	out = ob->query_name() + " arrives in a puff of smoke.\n";
    else
	out = ob->query_name() + " " + out + ".\n";
    say(out);
    write(out);
    move_object(ob, environment(this_object()));
    return 1;
}
 
drink_alcohol(strength)
{
    if (strength>0 && intoxicated > levels[0] + 3) {
	write("You fail to reach the drink with your mouth.\n");
	return 0;
    }
    intoxicated += strength;
    if (intoxicated < 0)
	intoxicated = 0;
    if (intoxicated == 0)
	write("You are completely sober.\n");
    if (intoxicated > 0 && headache) {
	headache = 0;
	tell_object(me, "Your headache disappears.\n");
    }
    if (intoxicated > max_headache)
	max_headache = intoxicated;
    if (max_headache > 8)
	max_headache = 8;
    return 1;
}
 
drink_alco(strength)
{
	if (intoxicated + strength > levels[0] * 3)
	{
		write("You fail to reach the drink with your mouth.\n");
		return 0;
	}
 
	intoxicated += strength / 2;
 
	if (intoxicated < 0)
		intoxicated = 0;
 
	if (intoxicated == 0)
		write("You are completely sober.\n");
 
	if (intoxicated > 0 && headache) 
	{
		headache = 0;
		tell_object(me, "Your headache disappears.\n");
	}
 
	if (intoxicated > max_headache)
		max_headache = intoxicated;
 
	if (max_headache > 8)
		max_headache = 8;
 
	return 1;
}

drink_soft(strength)
{
	if (soaked + strength > levels[0] * 8)
	{
		write("You can't possibly drink that much right now!\n" + 
			"You feel crosslegged enough as it is.\n");
		return 0;
	}
 
	soaked += strength * 2;
 
	if (soaked < 0)
		soaked = 0;
 
	if (soaked == 0)
		write("You feel a bit dry in the mouth.\n");
 
	return 1;
}
 
eat_food(strength)
{
	if (stuffed + strength > levels[0] * 8)
	{
		write("This is much too rich for you right now! Perhaps something lighter?\n");
		return 0;
	}
 
	stuffed += strength * 2;
 
	if (stuffed < 0)
		stuffed = 0;
 
	if (stuffed == 0)
		write("Your stomach makes a rumbling sound.\n");
 
	return 1;
}
 
test_can_spell(str,lev,spell)
{
    object ob;
    if (!use_light && test_dark()) return 0;
    if (levels[0] < lev)
      {
        write("If you knew this spell I'm sure you'd caste it well... but you don't.\n");
	return 0;
      }
    if (!str && attacker && present(attacker,environment()))
	ob = attacker;
    else
      if(str) ob = present(lower_case(str), environment(this_player()));
    if (!ob || !living(ob) || !present(ob,environment())) {
	write("At whom ?\n");
	return 0;
    }
    if (ob == me) {
	write("Have a death wish eh?\n");
	return 0;
    }
    if(test_player(ob) && extract(file_name(environment()),0,10)!="r1/room/field/")
    {
      write("You cannot "+spell+" another player.\n");
      return 0;
    }
    return ob;
}

spell_object(str)
{
 object ob;
 string verb;
 int lev,i,v;
 
 verb=({"missile","shock","fireball"});
 for(i=1;i<4;i++) if(query_verb()==verb[i-1]) { lev=5*i; v=i-1; }
 if(!lev) return 0;
 ob=test_can_spell(str,lev,verb[v]);
 if(ob) call_other(this_object(),verb[v]+"_object",ob);
 return 1;
}
 
static zap(str)
{
    object ob;
    if (!str)
	ob = attacker;
    else
	ob = present(lower_case(str), environment(this_player()));
    if (!ob || !living(ob)) {
	write("At whom ?\n");
	return 1;
    }
    if(ob->query_wiz_level()>=wiz_level)
      {
        write("You can only zap those lesser than yourself.\n");
        return 1;
      }
	say("A bolt of lightning drops from the sky and kills "+ob->query_name()+".\n");
	if(!test_player(ob)) write("You kill the "+ob->query_name()+" with a bolt of lightning.\n");
		 else write("You kill "+ob->query_name()+" with a bolt of lightning.\n");
    ob->death();
    return 1;
}
 
give_object(str)
{
    string item, dest,crd_str;
    object item_ob, dest_ob;
    int w;
    int crd;
 
    if (!str) return 0;

    if (!use_light && test_dark()) return 1;

    if (sscanf(str, "%d credits to %s", crd, dest) == 2) item = 0;
        else if(sscanf(str, "credits to %s", dest)==1) crd=credits;
           else if ( sscanf(str, "1 credit to %s", dest) == 1 ||
                     sscanf(str, "one credit to %s", dest) == 1 ||
	             sscanf(str, "a credit to %s", dest)==1) credits = 1;
	      else if (sscanf(str, "%s to %s", item, dest) != 2)
	 	     {
			write("Give what to whom ?\n");
			return 1;
    		     }

    if (item) 
      {
	item = lower_case(item);
	item_ob = present(item, this_player());
	if (!item_ob) 
          {
	    write("There are no " + item + " here.\n");
	    return 1;
	  }

	if (environment(item_ob) == this_object() && itme_ob->drop())
	  {
	    write("You are unable to do that.\n");
	    return 1;
	  }
	  else
            {
	        if (!item_ob->get())
		  {
		     write("You can't get that !\n");
		     return 1;
	          }
	    }
       }

    dest_ob = present(lower_case(dest), environment(this_player()));

    dest=capitalize(dest);

    if (!dest_ob) 
      {
	write("There is no " + dest + " here.\n");
	return 1;
      }

    if (!living(dest_ob)) 
      {
	write("You can't do that.\n");
	return 1;
      }

    if (!item)
      {
	if (crd <= 0) return 0;

	if (credits < crd) 
	  {
	    write("You don't have that many credits.\n");
	    return 1;
	  }

	credits -= crd;

	save_me(1);

	dest_ob->add_money(crd);

        say(cap_name+"gives "+dest+" some credits.\n",dest_ob);

	crd_str=crd==1?"a credit":(crd +" credits");

	tell_object(dest_ob, cap_name + " gives you " + crd_str + ".\n");

	write("You give "+crd_str+" to "+dest+".\n");
	return 1;
    }

    w = item_ob->query_weight();

    if (!dest_ob->add_weight(w)) 
      {
	write(dest + " can't carry any more.\n");
	return 1;
      }

    add_weight(-w);

    move_object(item_ob, dest_ob);

    say(cap_name+" gives "+item+" to "+dest+".\n",dest_ob);
    tell_object(dest_ob,cap_name+"gives you a "+item+".\n");
    write("You give the "+item+" to "+dest+".\n");
    return 1;
}
 
/*
 * Get all items here.
 */

get_all(from,container,items)
{
    object ob;
    int i,fail;
 
    if(items && !present(items,from))
	  {
		if(items[strlen(items)-1]=='s')
		   {
			  items=extract(items,0,strlen(items)-2);
			  if(!present(items,from))
			    {
				  if(items[strlen(items)-1]=='e')
				    {
					  items=extract(items,0,strlen(items)-2);
					  if(!present(items,from)) fail=1;
					}
				  else fail=1;
				}
		    }
		else fail=1;
	  if(fail)	
		 {
		   write("There is no such '"+items+"' to be found here.\n");
		   return 1;
		 }
	 }
    ob = all_inventory(from);
	if(!ob)
	  {
		write("There is nothing in the "+from->short()+" to get.\n");
	    return 1;
	  }
    for(i=0;i<sizeof(ob);i++) {
	if (ob[i]->short() && ob[i]->get()) {
	    string item;
	    int w;
	    if(!ob[i] || (items && !ob[i]->id(items))) continue;
	    item=ob[i]->short();
	    w = ob[i]->query_weight();
	    if (add_weight(w)) {
		write(ob[i]->short() + ": Ok.\n");
		move_object(ob[i], this_object());
                if(item[0]=='a' || item[0]=='A') item=extract(item,2,strlen(item));
                if(!container)
		   say(cap_name + " takes a " + item + ".\n");
  		 else say(cap_name+" take a "+item+" from "+container+".\n");
                 if(container) from->add_weight(-w);
	    } else {
		write(item + ": Too heavy.\n");
	    }
	}
    }
}
 
static force(str)
{
    string who, what;
    object ob;
    if (!str) return 0;
    if (sscanf(str, "%s to %s", who, what) == 2 ||
		sscanf(str, "%s %s", who, what) == 2) 
      {
		ob = find_living(who);
		if (!ob) write("No such living object.\n");
     	  else if(ob->query_wiz_level()>=wiz_level)
	  	    {
			  write("You try to force "+str+" but fail.\n");
        	  tell_object(ob,cap_name+" tried to force you to: "+what+", and failed.\n");
	  	    }
    	  else
      	   {
	     	  tell_object(ob, cap_name + " forces you to: " + what + "\n");
	     	  command(what,ob);
	     	  write("Ok.\n");
           }
	  }
	return 1;
}
 
static clone(str) 
{
    object ob;
    int syss;

    if (!str) {
	write("Clone what object ?\n");
	return 1;
    }
    str=rectify_path(str);
	if(!str) return 1;
    str = valid_read(str, WIZ);
    if(str && file_size("/"+str+".c")<1) str=0; 
    if (!str) {
	write("Invalid file.\n");
	return 1;
    }
    if(!find_object(str)) {sys(str);syss = 1;}
    ob = clone_object(str);
    if(syss) sys(str, 1);
    say(cap_name + " fetches something from another dimension.\n");
    if(ob->get())
      {
        add_weight(ob->query_weight());
        move_object(ob,this_object());
      }
     else move_object(ob, environment());
    write("Ok.\n");
    return 1;
}
 
static destruct_local_object(str)
{
    object ob;
 
    if (!str)
	  {
		write("Destruct what ?\n");
		return 1;
      }
    str=lower_case(str);
    ob = present(str, this_player());
    if (!ob) ob = present(str, environment(this_player()));
    if (!ob) 
	  {
		write("No " + str + " here.\n");
		return 1;
      }
    if(test_player(ob) && wiz_level <ADMIN)
     {
       write("You are not allowed to destruct players!\n");
       return 1;
     }
    if (ob->short())
        say(ob->short() + " is disintegrated by " + cap_name + ".\n");
    destruct(ob);
    write("Ok.\n");
    return 1;
}
 
static load(str)
{
    object env;
    if (!str) {
	write("Load what ?\n");
	return 1;
    }
    if(str[0]!='/') str=rectify_path(str);
	if(!str) return 1;
    str = valid_read(str, WIZ);
    if (!str) {
	write("Invalid file name.\n");
	return 1;
    }
    env = environment();
    /* We just call a non existing function in the object, and that way
     * force it to be loaded.
     */
    if(file_size("/"+str+".c")<1)
     {
        write("No such file to load.\n");
        return 1;
     }
    sys(str);
    call_other(str, "???");
    sys(str, 1);
    write("Ok.\n");
    return 1;
}
 
static snoop_on(str)
{
    object ob;
    int ob_level;
 
    if (!str) {
	snoop();
	return 1;
    }
    ob = find_player(str);
    if (!ob) {
	write("No such player.\n");
	return 1;
    }
    if(ob->query_wiz_level()>=wiz_level) {
	write("You fail.\n");
	return 1;
    }
    snoop(ob);
    return 1;
}
 
static invis(str) 
{
  string invis_name_tmp;

	if(str && my_invis_name(str)) return 1;
	else if(str) return;
	if (is_invis) {
	tell_object(this_object(), "You are already invisible.\n");
	return 1;
    }
    is_invis = 1;
    if(wiz_level>=SENIORE) block_tells=1;
    if(wiz_level>=ADMIN) {
    invis_name_tmp = name + INVIS_NAME;
    set_living_name(invis_name_tmp); }
    tell_object(this_object(), "You are now invisible.\n");
    if(wiz_level>=SENIORE) tell_object(this_object(), "Tells from lower level players & wizards are now blocked.\n");
    say(cap_name + " " + mmsgout + ".\n", this_object());
    cap_name=capitalize(lower_case((invis_name)));
    return 1;
}
 
static vis()
{
    if (!is_invis) {
	tell_object(this_object(), "You are not invisible.\n");
	return 1;
    }
    is_invis = 0;
    if(wiz_level>=SENIORE) block_tells=0;
	cap_name=capitalize(name);
    if(wiz_level>=ADMIN) set_living_name(name);
    if(wiz_level>=SENIORE) tell_object(this_object(), "Your tells are enabled.\n");
    tell_object(this_object(), "You are now visible.\n");
    say(cap_name + " " + mmsgin + ".\n", this_object());
    return 1;
}
 
static home(str) 
{
    if(!str || str == "") str = name;
	if(!file_size("/r1/players/"+name+"/workroom.c")) return;
    if(!is_invis) say(cap_name+" "+msghome+"\n");
    move_object(this_object(),"r1/players/"+str+"/workroom");
    if(!is_invis) say(cap_name+" "+mmsgin+"\n");
    if(brief) glance();
    else look();
    return 1;
}

valid_read(str,lvl) { return "closed/mcp"->valid_read(str,lvl); }

valid_write(str) { return "closed/mcp"->valid_write(str); }

static wiz_score_list(arg) 
{
    if (arg) wizlist(arg);
    else wizlist();
    return 1; 
}
 
static remove_file(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    rm(file);
	return 1;
}
 
static mv_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
	file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    mv(file,file2); return 1; 
}
 
static cp_file(str) 
{
string file, file2;

    if (!str || sscanf(str,"%s %s",file,file2)!=2) return 0;
    file=rectify_path(file);
	if(!file) return 1;
	file2=rectify_path(file2);
	if(!file2) return 1;
    cp(file,file2);
	return 1; 
}
 
static local_commands() { localcmd(); return 1; }
 
save_me(value_items)
{
   if(no_save) return;
    if(environment())
	 {
      saved_where=environment()->player_save_location();
	  if(!saved_where) saved_where=file_name(environment());
	 }
    if(!stringp(saved_where) || strchr(saved_where,'#'))
		 saved_where="r1/room/church";
    if(value_items!=2) save_inv();
    save_object("r1/players/" + user_name);
}
 
illegal_patch(what) 
{
    write("You are struck by a mental bolt from the interior of the game.\n");
    log_file("ILLEGAL", ctime(time()) + ":\n");
    log_file("ILLEGAL",
	     call_other(this_player(), "query_real_name") + " " +
	     what + "\n");
    return 0;
}
 
smart_report(str) 
{
    string who;
    string current_room;
 
    current_room = file_name(environment(this_object()));
    if (sscanf(current_room, "r1/players/%s/", who) != 1)
	return;
    log_file(who + ".rep", current_room + " " + str + "\n");
}
 
query_quests(str) 
{
    int i;
 
	if(!pointerp(quests)) return 0;
    if (!str) return quests;
	for(i=0;i<sizeof(quests);i++)
		if(quests[i]==str) return 1;
}
 
set_quest(q) 
{
    if (!q) return;
    if (query_quests(q)) return 0;
#ifdef LOG_SET_QUEST
    if (previous_object())
	  {
		log_file("QUESTS", name + ": " + q + " from " +
		 		file_name(previous_object()) + "\n");
		if (this_player() && this_player() != this_object() &&
	  		query_ip_number(this_player()))
	    	  log_file("QUESTS", "Done by " + this_player()->query_real_name() + "\n");
      }
#endif /* LOG_SET_QUEST */
    if (!quests) quests=({q});
    else quests+=({q});
    return 1;
}

query_real_name() { return name; }

query_user_name() { return user_name; }

static time_out() {
    write("Time out\n");
    destruct(this_object());
}

who(str)
{
    object list;
    int i;

    if(!str) 
	  {
    	list = users();
    	for(i=0;i<sizeof(list);i++) 
		  {
			string sh;

        	if(list[i] && list[i]->query_real_name()!="logon")
         	  {
	  			 sh = list[i]->short();
	   			 if(list[i] && !list[i]->short() && list[i]->query_wiz_level()<ADMIN)
	    		 write("("+capitalize(list[i]->query_real_name())+")\n");
	   			 else if (sh) write(sh + "\n");
              }
    	  }
    	return 1;
      }
	if(str=="system") {"closed/mcp"->show_who(0);return 1;}
}
 
static cd(str) 
{
    str=rectify_path(str);
	if(!str) return 1;

    if(str=="/") current_path="";
	 else if(valid_read(str)) 
			{
			   int size;

			   size=file_size(str);
			   if(size==-1) write("No such file or directory.\n");
    	       else if(file_size(str)!=-2) write("No such directory.\n");
				 else 
			       {
					  current_path=str;
					  ++current_path;
				   }
			 }
    write("/" + current_path + "\n");
    return 1;
}
 
static grep_file(str)
{
  if(!str) return 0;
  grep(str);
  write("grep output will be appended to the file /r1/log/"+name+".grep\n");
  write("\n	* please allow a few moments for the program to finnish running.\n");
  return 1;
}

static read_log(str)
{
string file;
 
   if(!stringp(str)) return more("/r1/log/"+name);
   if(str[0]=='.') str=name+str;
   file=valid_read("/r1/log/"+str);
   if(!file)
     {
        write("No such file.\n");
        return 1;
     }
   return more("/"+file);
} 
 
static purge_log(str)
{
   if(stringp(str))
	 {
		if(str[0]=='.') str=name+str;
	    return remove_file("/r1/log/"+str);
	 }
    else return remove_file("/r1/log/"+name);
}
 
 
more(path) {
int lines;
   if(this_player()!=this_object()) return 0;
    if (!path) return 0;
	path=rectify_path(path);
	if(!path) return 1;
    if(file_size(path)==-2)
     {
       write("You cannot more a directory.\n");
       if(log_flag)
        {
          log_flag=0;
          finnish2();
        }
       return 1;
     }
    more_file = path;
    more_line = 1;
    if(!(lines=cat(more_file, more_line, chunk))) {
	write("No such file\n");
        if(log_flag)
	 {
           log_flag=0;
	   finnish2();
         }
	return 1;
    }
    input(this_object(),"even_more");
    write("More: line " + (lines) + " (q/u/r/<return>) ");
    return 1;
}
 
static even_more(str) 
{
int lines;

    if (str == "q") 
      {
	write("Ok.\n");
	if(log_flag)
	 {
	   log_flag=0;
	   finnish2();
	 }
	return;
       }
     else if (str == "u") 
            {
	      more_line -= chunk;
	      if (more_line < 1) more_line = 1;
            }
          else if(str=="r") {}
    else more_line+=chunk;
    if(!(lines=cat(more_file, more_line, chunk))) {
	more_file = 0;
        if(log_flag)
         {
            log_flag=0;
            finnish2();
         }
        else write("EOF\n");
	return;
    }
    write("More: line " + (more_line + lines) + " (q/u/r/<return>)");
    input(this_object(),"even_more");
}
 
static pwd() 
{
    write("/" + current_path + "\n");
    return 1;
}
 
static makedir(file) 
{
    if (!file) return 0;
    file=rectify_path(file);
	if(!file) return 1;
    if (mkdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
static removedir(file) 
{
    if (!file) return 0;
	file=rectify_path(file);
	if(!file) return 1;
    if (rmdir(file))
	write("Ok.\n");
    else
	write("Fail.\n");
    return 1;
}
 
query_path() {
     if(wiz_level<PROBATE) return "";
    return current_path;
}
 
check_access_list(top, dir, file) 
{
    string tmp1, tmp2;
 
    if (!access_list)
	return 0;
    if (sscanf(access_list, "%s" + dir + "#%s", tmp1, tmp2) == 2)
	return top + dir + "/" + file;
    return 0;
}
 
set_descript(str)
{
  str = valid_input(str);
  if(str && strlen(str) > 80) str = extract(str, 0, 79);
  descript=str;
  write("Ok.\n");
  return 1;
}
 
remove_scar()
{
  scar=0;
}
 
make_scar() {
    if (levels[0] < 10)
	return;
    scar |= 1 << random(MAX_SCAR);
}
 
show_scar() {
    int i, j, first, old_value;
    string scar_desc;
 
    scar_desc = ({ "left leg", "right leg", "nose", "left arm", "right arm",
		   "left hand", "right hand", "forhead", "left cheek",
		   "right cheek" });
    j = 1;
    first = 1;
    old_value = scar;
    while(i < MAX_SCAR) {
	if (scar & j) {
	    old_value &= ~j;
	    if (first) {
		write(cap_name + " has a scar on " + query_possessive() +
		      " " + scar_desc[i]);
		first = 0;
	    } else if (old_value) {
		write(", " + query_possessive() + " " + scar_desc[i]);
	    } else {
		write(" and " + query_possessive() + " " + scar_desc[i]);
	    }
	}
	j *= 2;
	i += 1;
    }
    if (!first)
	write(".\n");
}
 
add_standard_commands() {
    add_action("church_clock","clock");
    add_action("ghost_escape","escape");
    add_action("toggle_talk", "talk");
    add_action("set_descript","describe");
    add_action("give_object","give");
    add_action("score",({"score","stats"}));
    add_action("save_character","save");
    add_action("quit","quit",2);
    add_action("communicate","say");
    add_action("emote","emote");
    add_action("emote",":",1);
    add_action("communicate",({"'",";"}), 1);
    add_action("shout_to_all","shout");
    add_action("put","put");
    add_action("pick_up",({"get","take"}));
    add_action("drop_thing","drop");
    add_action("inventory",({"inventory","i"}));
    add_action("look","look");
    add_action("glance","glance");
    add_action("examine","examine");
    add_action("examine", "exa", 2);
    add_action("ext_help",({"help","help2"}));
    add_action("tell","tell");
    add_action("whisper","whisper");
    add_action("idea","idea");
    add_action("typo","typo");
    add_action("bug","bug");
    add_action("converse","converse",2);
    add_action("toggle_brief","brief",2);
    add_action("toggle_whimpy","wimpy",2);
    add_action("spell_object",({"missile","shock","fireball"}));
    add_action("who", "who");
    add_action("clock",({"date","time"}));
    add_action("short_mv",({"e","w","n","s","u","d","sw","se","ne","nw"}),2);
}
 
short_mv()
{
  if(query_verb()=="sw") command("southwest");
   else if(query_verb()=="se") command("southeast");
    else if(query_verb()=="nw") command("northwest");
      else if(query_verb()=="ne") command("northeast");
	else if(query_verb()=="w") command("west");
	  else if(query_verb()=="e") command("east");
	    else if(query_verb()=="n") command("north");
	      else if(query_verb()=="s") command("south");
		else if(query_verb()=="u") command("up");
		  else if(query_verb()=="d") command("down");
 return 1;
}

static update_object(str) 
{
object ob;
string temp;
object inv;
int i,s,no_inv;
string void;
 
    if(file_size("/r1/players/"+name+"/void.c")<1) void="r1/room/void";
      else void="r1/players/"+name+"/void";

    if (!str) str="/"+file_name(environment(this_player()));

    if(str[0]!='/') str=rectify_path(str);

    if(!str) return 1;

    if(wiz_level<ADMIN) str = valid_write(str);
	else str= valid_read(str,WIZ);

    if (!str) return 1;

    ob = find_object(str);

    if(!ob)
      {
        write("No such object "+str+".\n");
        return 1;
      }

    inv=all_inventory(ob);

    if(!inv) no_inv=1;
      else for(s=sizeof(inv);i<s;i++) 
	      if(objectp(inv[i])) move_object(inv[i],void);

    destruct(ob);
    write(str + " destructed.\n");

    write("Now attempting to load "+str+"\n");

    call_other(str,"???");

    ob=find_object(str);

    write("Loading of "+str+" was successful.\n");

    if(!no_inv) 
      {
       inv=all_inventory(void);
       for(s=sizeof(inv),i=0;i<s;i++) 
        {
          string item_name;
      
          item_name=inv[i]->query_id(0);

          if(!item_name) item_name=inv[i]->query_name();
          if(!item_name) item_name=inv[i]->query_real_name();

          if(!item_name || present(item_name,ob)) destruct(inv[i]);
            else move_object(inv[i],ob);

        }

      write("Restroration of "+str+" contents complete.\n");
      call_other(void,"reset",1);
    }

  return 1;
}
 
static reset_object(str)
{
object ob;
string temp;
  if(str)
   {
     ob=present(str,this_player());
     if(!ob) ob=present(str,environment(this_player()));
     if(!ob) find_living(str);
   }
  if(!ob)
   {
     if(!str) str=file_name(environment(this_player()));
     else if(str[0]!='/')     str=rectify_path(str);
	 if(!str) return 1;
     ob=find_object(str);
     if(!ob)
      {
        write("Object '"+str+"' not found.\n");
        return 1;
      }
    }
  ob->reset(1);
  write(file_name(ob)+" has been reset.\n");
  return 1;
}
 
goto_castle(str)
{
object castle;
 
     if(!str) str=name;
     str=lower_case(str);
     castle=environment("r1/players/"+str+"/castle");
     if(!castle)
      {
        write("Unable to find "+capitalize(str)+"'s castle.\n");
        return 1;
      }
     this_player()->move_player("X#"+file_name(castle));
     return 1;
}
 
static set_room_names(str)
{
 
  if(str=="off")
   {
     write("You no longer see the room names.\n");
     no_room_names=1;
     return 1;
   }
  write("You see room names.\n");
  no_room_names=0;
  return 1;
}
 
ghost_escape()
{
  int cost;
 
  if(!ghost)
   {
     write("You are not a ghost!!\n");
     return 1;
   }
  if(environment() && file_name(environment())=="r1/room/church")
   {
     write("You are already here!!\n");
     return 1;
   }
  if(environment() && file_name(environment())=="r1/players/man-ing/prison/prison")
    {
	write("You cannot escape from prison\n");
	return 1;
    }

  if(levels[0]==1) cost=200;
   else cost=1000*levels[0];
  write("This will cost you an extra "+cost+" experience to be returned to the church.\nAre you sure? (y/n) ");
  input(this_object(),"question_ghost");
  return 1;
}
 
question_ghost(yesno)
{
 
  if(lower_case(yesno)[0]=='y')
   {
     write("Very well then..  So be it!!\n");
     if(levels[0]==1) exp[0]-=200;
       else exp[0]-=1000*levels[0];
     if(exp[0]<0) exp[0]=0;
     move_player("X#r1/room/church");
     return;
   }
 write("A wise man never waists.\n");
} 
 
finnal_death()
{
  log_file("FINNAL",cap_name+" "+ctime(time())+".\n");
  levels=({0,0,0});
  exp=({0,0,0});
  classes=({0,0,0});
  set_alignment("neutral");
  set_al(0);
  heal_self(100);
  if(query_gender()) set_title("the peasant");
	   else set_title("the utter creature");
  return 1;
}

ext_help(str) 
{
	int lev;
    if(!str) 
	 {
		if(query_verb()=="help2") cat("/r1/doc/help2");
			else cat("/r1/doc/help");
		return 1;
     }
    if(sscanf(str, "level %d", lev) == 1) {
        if(lev < 1 || lev > 413) {
            write("That is not a valid level.\n");
            return 1;
        }
        write("\n");
        write("Level      : "+lev+"\n");
        write("Experience : "+find_exp(lev)+"\n");
        write("Titles -\n");
        write("Male       : "+find_title(lev,1)+"\n");
        write("Female     : "+find_title(lev,2)+"\n");
        write("Creature   : "+find_title(lev,3)+"\n");
        write("\n");
        return 1;
    }
    if(str=="advance") 
     {
		int ex;

		lev=levels[0]+1;
		ex=find_exp(lev)-exp[0];
		if(ex<0) ex=0;
	    write("\n"+ex+" experience points required to advance to level "+lev+".\n\n");
        return 1;
    }
    if(sscanf(str, "quest %d", lev) == 1) {
        this_player()->cat_file("/r1/log/quest/quest"+lev);
        return 1;
    }
    if (str == "wizard" && wiz_level >=APRENTICE)
     {
        write("\nDo 'cat /r1/doc/wizardhelp/<topic>' for more information.\n");
        cat("/r1/doc/wizard/APRENTICE");
        if(wiz_level >=PROBATE) cat("/r1/doc/wizardhelp/PROBATE");
        if(wiz_level >=WIZARD) cat("/r1/doc/wizardhelp/WIZARD");
        if(wiz_level >=JUNOR) cat("/r1/doc/wizardhelp/JUNOR");
        if(wiz_level >=SENIORE) cat("/r1/doc/wizardhelp/SENIORE");
        if(wiz_level >=ELDER) cat("/r1/doc/wizardhelp/ELDAR");
        if(wiz_level >=ADMIN) cat ("/r1/doc/wizardhelp/ADMIN");
	write("\nFor general information read the doc files in the /doc/build dir.\n\n");

		return 1;
     }
    if (str) return cat("/r1/doc/playerhelp/" + str);
}
 
clock()
{
int hour;
string am_pm;
int min,sec;
string time_str,time2;
 
  time_str=allocate(5);
  sscanf(ctime(time()),"%s %s %s %s %s",time_str[0],time_str[1],time_str[2],time_str[3],time_str[4]);
  time2=explode(time_str[3],':');
  if(sizeof(time2)<3)
   {
     sscanf(ctime(time()),"%s %s  %s %s %s",time_str[0],time_str[1],time_str[2],time_str[3],time_str[4]);
     time2=explode(time_str[3],':');
   }
  sscanf(time2[0],"%d",hour);
  if(hour>12) 
   {
     hour-=12;
     am_pm="pm";
   }
   else am_pm="am";
   if(hour==0) hour=12;
  if(query_verb()=="time")
     write("The time is: "+hour+":"+time2[1]+":"+time2[2]+am_pm+".\n");
  if(query_verb()=="date")
     write("The Date is: "+time_str[0]+"  "+time_str[1]+" "+time_str[2]+", "+time_str[4]+"\n");
   return 1;
}
 
church_clock(str) 
{
    if(wiz_level >= WIZARD && str == "off") call_other("closed/clock", "show_off");
    else call_other("closed/clock", "clock");
   return 1;
}
 
toggle_talk(str) 
{
	if(str) return;
	if(talk) {talk = 0;write("No talk echo.\n");return 1;}
	talk = 1;write("Talk echo.\n");return 1;
}
 
valid_input(str)
{
 int count;
 string output;output = "";
 if(str) 
   for(count=0;count<strlen(str);count++)
    if(str[count]<127 && str[count]>31) output+=extract(str,count,count);
 return output;
}
 
wiz_panic() {
    more("/r1/doc/wizardhelp/NEW_WIZ");
    return 1;
}
 
static prison_player(str) 
{
 string prison;
 object player;
  if(query_verb()=="prison") prison="r1/players/man-ing/prison/prison";
    else prison="r1/room/prison";
  player=find_player(lower_case(str));
  if(!player)
     write("sorry no player by that name can be found at this time.\n");
  else if(player->query_level()>=levels[0])
      write("You are unable to imprison that person.\n");
  else {
   move_object(player,prison);
   command("look",player);
   write("You hve imprisoned "+str+".\n"); 
  }
 return 1; 
}

sys(str, flag) 
{
    if(!str || file_size("/"+str+".c") < 15000) return;
    if(!flag) shout("System delay, please hold....");
    else shout("done.\n");
}

set_wiz_level(num) 
{
    object scroll;
    if(!query_ip_number(this_player()) || wiz() < SPONSOR ||
       wiz_level >= wiz()) return;
    if(num>ELDER) return;
    if (num>wiz_level && num == APRENTICE) {
        scroll = clone_object("r1/doc/wizardhelp/init_scroll");
        move_object(scroll, me);
        tell_object(me, "You have been given a scroll containing valuable information, Read it now!\n");
        tell_object(me, "New wizard commands will be available at your next login\n");
    }
    wiz_level = num;
    return num;
}

chunk_set(num) {
	num = numb(num);
	if(num > 40 || num < 1) return;
	chunk = num;
	write("CHUNK set to "+num+".\n");
	return 1;
}

static my_level(num) 
{
	if(wiz_level < APRENTICE || !query_ip_number(this_player()) ||
		(this_player() != this_object())) return;

	if(!numberp(num)) num=atoi(num);

	if(num < 1 || num > 413) return;
	r1/obj/living::set_level(num);set_str(num);
        set_con(num);set_int(num);set_dex(num);

	write("Level and stats set to "+num+".\n");
	return 1;
}

#if 0
my_name(str)
{
	if(!query_ip_number(this_player()) || 
	  (this_player() != this_object() && this_player()->query_wiz_level() < ADMIN))
		return;
	str = valid_input(str);
	if(!str || str == "") {
		write("Name returned to normal.\n");
		temp_name = 0;
		cap_name = capitalize(lower_case(name));
        set_living_name(name);
		return 1;
	}
        str = lower_case(str);
	temp_name = str;
	cap_name = capitalize(temp_name);
        set_living_name(temp_name);
	write("Name changed to "+str+".\n");
	return 1;
}
#endif

my_invis_name(str) 
{
	if(!query_ip_number(this_player()) ||
		(this_player() != this_object() &&
		this_player()->query_wiz_level() < ADMIN)) return;
	str = valid_input(str);
	if(!str || str == "") 
	  {
		write("Invis name returned to normal.\n");
		invis_name = "Someone";
                if(is_invis) cap_name = invis_name;
		return 1;
	  }
	invis_name = str;
    if(is_invis) cap_name = capitalize(lower_case(invis_name));
	write("Invis name changed to "+str+".\n");
	return 1;
}

static set_block(str) 
{
    if(str != "on" && str != "off") 
	  {
		write("Wizblock On or Off?\n");
		return 1; 
	  }
    if(str == "on") 
	  {
		write("Wizblock On.\n");
		is_blocked = 1; 
	  }
    if(str == "off") 
	  {
		write("Wizblock Off.\n");
		is_blocked = 0; 
	  }
   return 1; 
}


static wiz_tell(str) 
{
	object ob;
	int i;

  ob = users();
  if(!str) 
	{
		write("Wiztell what?\n");
		return 1;
	 }
  if(this_player()->query_blocked() == 1) 
	{
		write("You're blocked.\n");
		return 1; 
	}
   str = valid_input(str);
   for(i=0;i<sizeof(ob);i++) 
	{
	  if(!ob[i]) continue;
      if(ob[i]==this_object()) continue;
      if(ob[i]->query_wiz_level() >= PROBATE && ob[i]->query_blocked() == 0) 
		{
            tell_object(ob[i], capitalize(this_player()->query_real_name()) + " <wiz channel> : ");
	   		tell_object(ob[i], str);
	   		tell_object(ob[i], "\n");
	   		if(ob[i]->query_blocked() == 1) 
	        write(capitalize(ob[i]->query_real_name()) + " was blocked.\n"); 
		}
	}
  write("Sent.\n");
  return 1; 
}

review() 
{
    write("min   : "+cap_name+" "+msgin+".\n"+
	  "mout  : "+cap_name+" "+msgout+" <dir>.\n"+
	  "mmin  : "+cap_name+" "+mmsgin+".\n"+
	  "mmout : "+cap_name+" "+mmsgout+".\n"+
	  "home  : "+cap_name+" "+msghome+"\n"+
	  "align : ("+al_title+")\n"+
	  "title : "+cap_name+" "+title+"\n");
    return 1; 
}

save_inv()
{ 
	if(!no_save && !save_inventory(this_object(),"r1/players/"+user_name+".s"))
		write("Error: Inventory not saved!\n");
    if(no_save || !query_ip_number(this_object()))
	  {
		int i;
	    object arr;

		for(i=0,arr=all_inventory(this_object());i<sizeof(arr);i++)
			 if(arr[i])
			   {
				 int c;
				 object arr2;

				 if(first_inventory(arr[i]))
				   for(c=0,arr2=all_inventory(arr[i]);c<sizeof(arr2);c++)
					  if(arr2[c]) destruct(arr2[c]);
				  destruct(arr[i]);
			   }
			     
	  }
}

restore_inv() 
{
  if(user_name=="guest") return;
  write("Restoring inventory, Please wait...\n");
  if(restore_inventory(this_object(),"r1/players/"+user_name+".s"))
    write("Done.\n\n");
}
	
block_save() { return 1;}

setmout(m) { msgout = m; return 1; }
setmin(m) { msgin = m; return 1; }
setmmout(m) { mmsgout = m; return 1; }
setmmin(m) { mmsgin = m; return 1; }
sethome(m) {msghome=m; return 1;}

query_block_shouts() { return block_sh;}
query_block_tells() { return block_tells;}
query_use_light() { return use_light; }
query_title() { return title; }
query_invis() { return is_invis; }
query_msgin() { return msgin; }
query_msgout() { return msgout; }
query_mmsgin() { return mmsgin; }
query_mmsgout() { return mmsgout; }
query_al() { return al_title;}
query_msghome() { return msghome;}
query_new_player() { return new_player; }
query_blocked() {return is_blocked; }
query_wiz_level() {return wiz_level;}
query_talk() {return talk;}
query_descript() { return descript; }
query_intoxination() { return intoxicated; }
query_stuffed() { return stuffed; }
query_soaked() { return soaked; }
query_brief() { return brief; }
