#include <stdio.h>
#include <string.h>
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "config.h"
#include "o_hash.h"
#include "realms.h"

extern void add_message();

struct o_table_entry **o_table;

struct o_table_entry **l_table;

void init_o_tables()
{
   o_table=(struct o_table_entry **)xalloc(sizeof (struct o_table_entry *) * cf.otable);

   memset((char *)o_table,'\0',sizeof (struct o_table_entry *) * cf.otable);

   l_table=(struct o_table_entry **)xalloc(sizeof (struct o_table_entry *) * cf.ltable);

   memset((char *)l_table,'\0',sizeof (struct o_table_entry *) * cf.ltable);
}

int o_table_count,l_table_count;

void add_o_hash(ob, table, hashv,c_flag)
OBJECT			*ob;
struct o_table_entry	**table;
int			hashv;
int			c_flag;
{
	struct o_table_entry	*tmp;

	tmp=(struct o_table_entry *)xalloc(sizeof (struct o_table_entry));
	tmp->ob=ob;
	tmp->next = table[hashv];
	table[hashv] = tmp;
	if(!c_flag) l_table_count++;
	  else o_table_count++;
}

void del_o_hash(ob, table, hashv,c_flag)
OBJECT			*ob;
struct o_table_entry	**table;
int 			hashv;
int			c_flag;
{
   struct o_table_entry *tmp, *prev = 0;

   for (tmp = table[hashv]; tmp; tmp = tmp->next) {
      if (tmp->ob == ob) {
         if (prev)
            prev->next = tmp->next;
         else
            table[hashv] = tmp->next;

         free((char *)tmp);

	 if(!c_flag) l_table_count--;
	   else o_table_count--;

         break;
      }
      prev = tmp;
   }
}

OBJECT *find_o_hash(name, table_size,table,data_toggle)
register char		*name;
int			table_size;
struct o_table_entry	**table;
int			data_toggle;
{
	extern struct object_status *ob_status[];
	extern REALMS *sys_realm;

	register struct o_table_entry	*tmp,*prv;
	int				hashv;

	hashv = hash(name,table_size);

	for(prv = 0, tmp = table[hashv]; tmp; prv = tmp, tmp = tmp->next) 
	  if(!data_toggle)
             {
		if(ob_status[0]->ob->realm!=sys_realm && 
			ob_status[0]->ob->realm!=tmp->ob->realm) continue;
		if(!strcmp(name,tmp->ob->living_name)) return tmp->ob;
             }
           else if(!strcmp(name,tmp->ob->name)) return tmp->ob;
	    
	return 0;
}

struct o_table_entry *find_top_of_table(table,table_size)
struct o_table_entry **table;
int table_size;
{
  int i;
  
  for(i=0;i<table_size;i++)
    if(table[i]) return table[i];
  return 0;
}


void show_o_table_status()
{
  add_message("Object hash table                   (%5d) : %7d (%9d) bytes\n",cf.otable*4,o_table_count,o_table_count*sizeof (struct o_table_entry));
  add_message("Living hash table                   (%5d) : %7d (%9d) bytes\n",cf.ltable*4,l_table_count,l_table_count*sizeof (struct o_table_entry));
}
