#include <string.h>
#include "lint.h"
#include "config.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "p_hash.h"

extern char *make_shared_string PROT((char *));
extern void free_string PROT((char *)),add_message();

extern int sprintf();

extern long nap();

struct p_table_entry **p_table;

void init_p_table()
{
   p_table=(struct p_table_entry **)xalloc(sizeof (struct p_table_entry *) * cf.ptable);

   memset((char *)p_table,'\0',sizeof (struct p_table_entry *) * cf.ptable);
}

int p_table_count;

char *make_hash_name(pr_name,ob_name)
register char *pr_name,*ob_name;
{
	char *hash_name=xalloc(strlen(pr_name)+strlen(ob_name)+2);

	(void)sprintf(hash_name,"%s %s",ob_name,pr_name);

	return hash_name;
}

void add_p_hash(pr)
register struct lnode_def *pr;
{
	register struct p_table_entry	*tmp;
	int hashv;

	hashv=hash(pr->name,cf.ptable);

	tmp=(struct p_table_entry *)xalloc(sizeof (struct p_table_entry));
	tmp->pr=pr;
	tmp->next = p_table[hashv];
	p_table[hashv] = tmp;
	p_table_count++;
}

void del_p_hash(pr_name)
register char *pr_name;
{
   register struct p_table_entry *tmp, *prev = 0;
   int hashv=hash(pr_name,cf.ptable);

   for (tmp = p_table[hashv]; tmp; tmp = tmp->next) {
      if (!strcmp(tmp->pr->name,pr_name)) {
         if (prev)
            prev->next = tmp->next;
         else
            p_table[hashv] = tmp->next;

         free((char *)tmp);

	 p_table_count--;

         break;
      }
      prev = tmp;
   }
}

struct lnode_def *find_p_hash(pr_name,ob_name)
register char		*pr_name,*ob_name;
{
	register struct p_table_entry	*tmp,*prv;
	register char *hash_name=make_hash_name(pr_name,ob_name);
	int hashv=hash(hash_name,cf.ptable);

	for(prv = 0, tmp = p_table[hashv]; tmp; prv = tmp, tmp = tmp->next) 
           if(!strcmp(hash_name,tmp->pr->name)) 
		{
		   free(hash_name);
		   return tmp->pr;
		}
	free(hash_name);    
	return 0;
}

void show_p_table_status()
{
  add_message("Progam blocks in hash table        (%6d) : %7d (%9d) bytes\n",cf.ptable*4,p_table_count,p_table_count*sizeof (struct p_table_entry));
}

void show_prog_hash(str)
register char *str;
{
struct p_table_entry *p;

int d,i,c,len;

  if(str) len=strlen(str);

  add_message("Program hash table listing.\n");
  add_message("---------------------------\n");
  for(c=0,i=0;i<cf.ptable;i++)
   for(d=0,p=p_table[i];p;p=p->next,d++)
     {
	if(str && strncmp(str,p->pr->name,len)) continue;
	add_message("%6d: %9d - %s\n",i,d,p->pr->name);
 	if(!((++c)%50))
#ifdef M_XENIX
           nap(150);  /* we have a long list, prevent buffer overflow */
#else
# ifdef AIX
	   sleep(1);
# else
           usleep(150);
# endif
#endif
     }
}
