#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "config.h"
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "realms.h"
#include "sent.h"
#include "wiz_list.h"
#include "lan_fun.h"
#include "o_hash.h"
#include "s_hash.h"
#include "p_hash.h"
#include "error.h"

#ifdef DRAND48
extern double	drand48 PROT((void));
extern void	srand48 PROT((long));
#endif

extern REALMS *sys_realm;

extern int	file_size PROT((char *)),
		swap PROT((OBJECT *)),
		remove_call_out PROT((OBJECT *,  char *,int)),
		tail PROT((char *)),
		transfer_object PROT((OBJECT *, OBJECT *,int,int));

extern struct svalue *find_value PROT((struct lnode_number *));

extern VALUE    *allocate_array PROT((unsigned short)),
		*query_call_out PROT((OBJECT *,char *)),
		*add_array(),
		*query_load_av(),
		*copy_svalue PROT((struct svalue *)),
		*call_other PROT((VALUE *,char *,VALUE *));

extern OBJECT   *find_object PROT((char *)),
		*find_object2 PROT((char *,int));

extern char     *string_copy(),

		ret_type PROT((int,int));

extern void     assign(),
		assign_svalue(),
		enable_commands PROT((int)),
		load_ob_from_swap PROT((OBJECT *)),
		do_error PROT((char *,char *));

VALUE    *print_expr_list(), *print_function();

void 	free_ob_status();


VALUE		*get_one_expr(),
			*print_expr();

struct object_status *ob_status[2];

VALUE	*switch_arg=0;

LNODE	*case_def=0;


extern struct sentence *last_verb;

extern int	eval_cost;

struct lnode_2  *next_arg_list_to_use;

/*
 * This variable is set to true when return is called inside a function,
 * or when the current object(ob_status[0]->ob) is destructed.
 */

int	stop_function;

/*
 * This is used for 'break' in while-statements.
 */

char		break_flag=0, break_level=0,case_match=0;

int current_line=0;

#define MAX_TRACE	20

struct trace trace_back[MAX_TRACE];

#ifdef AIX
signed char trace_depth = -1;
#else
char trace_depth = -1;
#endif

VALUE		*catch_value,		/* Used to throw an error to a catch */
		    *return_value;		/* Here is a value when "return". */


struct object_status *alloc_ob_status()
{
   register struct object_status *status;
   int size;

   size=sizeof (struct object_status);
   status=(struct object_status *)xalloc(size);
   status->ob=0;
   status->ip=0;
   status->local_names=0;
   status->arg=0;
   return status;
}

void free_ob_status(status)
    register struct object_status *status;
{
    if(status->local_names) free((char *)status->local_names);
    free((char *)status);
}

void free_fun_p(fun_p)
	register struct fun_p *fun_p;
{
   if(!fun_p) return;

   fun_p->fun_p=0;
   fun_p->ip=0;
   free((char *)fun_p);
}

struct simul_efun {
	struct fun_p *fun_p;
	OBJECT *ob;
};

struct simul_efun *find_simul_efun(fun,ob,flag)
	register char *fun;
	register OBJECT *ob;
	int flag;
{
 	OBJECT *sim=0;
	struct fun_p *fun_p;
        char *realm;
        struct simul_efun *simul_efun;

        if(ob->realm!=sys_realm)
	  {
            realm=xalloc(strlen(ob->realm->realm_name)+19);
	    (void)sprintf(realm,"%s/closed/simul_efun",ob->realm->realm_dir);
            sim=find_object2(realm,0);
	    free(realm);

	    if(sim)
             {
               fun_p=find_fun_p(fun,sim,0);

	      if(fun_p) 
               {
                if(flag) { fun_p->ip=0; fun_p->fun_p=0; }
		simul_efun=(struct simul_efun *)xalloc(sizeof (struct simul_efun));
		simul_efun->fun_p=fun_p;
		simul_efun->ob=sim;
	        return simul_efun;
               }
	      sim=0;
	     }
           }
        if(!sim)
	 if((sim=find_object2("closed/simul_efun",0)))
          {
            fun_p=find_fun_p(fun,sim,0);

	    if(fun_p) 
             {
                if(flag) { fun_p->ip=0; fun_p->fun_p=0; }
		simul_efun=(struct simul_efun *)xalloc(sizeof (struct simul_efun));
		simul_efun->fun_p=fun_p;
		simul_efun->ob=sim;
	        return simul_efun;
             }
          }
     return 0;
}
/*
 * find_fun_p(), finds a function in the function hash table.
 *
 * If the function is not found, search in the program pointed to by the
 * inherit pointer.
 *
 * If the function name starts with '::', search in the inherit pointer(s)
 * only.
 *
 * If an object name preceedes '::' then search ONLY that inherit pointer.
 *
 * Function name posibilies are:
 *
 *  fun_name,
 *  ::fun_name,
 *  obj_name::fun_name.
 *
 * ob_status[0] stores all the current object information and pointers.
 * ob_status[1] stores all previous object information and pointers.
 *
 * If the function is not found, return a null pointer which indicates
 * this.
 */

struct fun_p *find_fun_p(fun, ob,flag)
    register char *fun;
    register OBJECT *ob;
    int flag;
{
    int i;
    register char *p,*chk_fun=0,*chk_fun_ob=0;
    struct fun_p *fun_p;
    register struct inherit_list *ip=0;
    register struct lnode_def *pr=0;
	
    if(!ob_status[0]) ob_status[0]=alloc_ob_status();

    p=strchr(fun,':');

    if(p && strlen(p)>=3 && p[1] == ':')
      {
	if(!ob->inherit || (!flag && ob_status[0]->ob != ob)) return 0;

        p+=2;
	chk_fun=xalloc(strlen(p)+1);
	(void)strcpy(chk_fun,p);

	if(fun[0]!=':')
	 {
	    int length=0;

            length = strlen(fun)-strlen(chk_fun)-2;
	    chk_fun_ob=xalloc(length+1);
	    (void)strncpy(chk_fun_ob,fun,length);
	    chk_fun_ob[length]=0;
	 }
       }
     else p=0;

     if (ob->flags & SWAPPED) load_ob_from_swap(ob);

     if(!chk_fun && ob->prog)
       {
          char *root_ob_name=string_copy(ob->prog->name),
	       *find_pound=strchr(root_ob_name,' ');

          find_pound[0]=0;
          pr=find_p_hash(fun,root_ob_name);

          free(root_ob_name);

          if(!pr) 
  	    {
	 	chk_fun=xalloc(strlen(fun)+1);
	 	(void)strcpy(chk_fun,fun);
  	    }
       }

     if(!pr && ob->inherit)
       {
	   struct inherit_list *list=ob->inherit;

	   while(list)
	     {
		register char *new_name,*p;

	        if(chk_fun_ob && strcmp(chk_fun_ob,list->name))
	          {
		    list=list->next;
		    continue;
	          }

	        if(!list) break;

	        new_name=string_copy(list->prog->name);
	        p=strchr(new_name,' ');
	        p[0]=0;
	        pr=find_p_hash(chk_fun,new_name);
	        free(new_name);

	       if(pr)
	         {
		    ip=list;
		    break;
	         }

	       list=list->next;
             }		   
          }

   if(chk_fun_ob) free(chk_fun_ob);
   if(chk_fun) free(chk_fun); 

   /* Static functions may not be called from outside. */

   if(pr)
    {
      if(flag || ((!(pr->flags & L_STATIC) || 
         (pr->flags & L_STATIC && ob_status[0]->ob == ob)))) 
       {

         fun_p=(struct fun_p *)xalloc(sizeof (struct fun_p));
         fun_p->fun_p=pr;
         fun_p->ip=ip;
      
         return fun_p;
       }
    }
   else 
    if(flag && mcp.ob && ob!=mcp.ob && !strstr(ob->name,"closed/simul_efun"))
     {
	struct simul_efun *simul_efun;

        if(!(simul_efun=find_simul_efun(fun,ob,flag))) return 0;

	fun_p=simul_efun->fun_p;
	free((char *)simul_efun);

        return fun_p;
     }

   return 0;
}

/*
 * Apply a fun 'fun' to the program in object 'ob', with the
 * optional argument 'arg'.
 *
 * call find_fun_p() to find the function if it exists.
 *
 * ob_status[0] stores all the current object information and pointers.
 * ob_status[1] stores all previous object information and pointers.
 *
 * If the function is not found, return a null pointer which indicates
 * this. print_function() will never return a null pointer.
 *
 * Note that the object 'ob' can be destructed. This must be handled by
 * the caller of apply().
 */

struct value *apply(fun_p,fun, ob, arg,arg2)
    register struct fun_p *fun_p;
    char *fun;
    register OBJECT *ob;
    VALUE *arg,*arg2;
{
    extern int num_error;
    VALUE *ret;
    OBJECT *alt_ob=0;
    register struct fun_p *pr;
    struct inherit_list *ip=0;
	
#ifdef DEBUG
    /* if you are having problems activate this code. */
    if(!fun && !fun_p) error(ob_status[0]->ob->realm,"Calling NULL function in apply()\n");

    if(!ob) error(ob_status[0]->ob->realm,"No object passed to apply()\n");

    if (!check_object(ob)) error(ob_status[0]->ob->realm,"Executing '%s' in destructed object.\n", fun);
#endif

    if(!ob_status[0]) ob_status[0]=alloc_ob_status();

    if (num_error > 0) return &const0;

    if(!fun_p || (ob_status[0]->ip && fun))
      {
        pr=find_fun_p(fun,ob,0);
	if(!pr)
	  {
	     struct simul_efun *simul_efun=find_simul_efun(fun,ob,0);

	     if(simul_efun)
	      {
		  pr=simul_efun->fun_p;
		  alt_ob=simul_efun->ob;
		  free((char *)simul_efun);
	      }
	   }

	if(pr) ip=pr->ip;
	fun_p=0;
      }
      else 
        {
          pr=fun_p;
	  ip=fun_p->ip;
        }

    if(!pr) 
      {
  	 /*
   	  * We must clear next_arg_list_to_use, so that those arguments won't be
  	  * sent to another function.
          */

          next_arg_list_to_use = 0;
          return 0;
       }

    /*
    * print_function() will clear the value of
    * next_arg_list_to_use
    */

    ret=print_function(pr,alt_ob?alt_ob:ob,ip,arg,arg2);

    if(!fun_p) free_fun_p(pr);

    return ret;
}
/*
 * Print or interpret a function.
 * Set up the long jump context, to enable the 'return' statment.
 * The arguments are passed in one of two ways:
 * Either there is one argument in the variable ob_status[0]->arg. Or there
 * can be a list of (unevaluated) arguments pointed to by next_arg_list_to_use.
 *
 * The reason for this is historical. In the beginning, only one argument
 * could be used, thus only one single pointer to the argument. When
 * the possibility of several arguments was added, this was implemented
 * with an extra info pointer.
 *
 * print_function always returns a value.
 */

VALUE *print_function(p,ob,ip,arg,arg2)
    register struct fun_p *p;
    register OBJECT *ob;
    register struct inherit_list *ip;
    register VALUE *arg,*arg2;
{
    register VALUE *tmp_value;
    char *fun_name=strchr(p->fun_p->name,' ');
#ifdef AIX
    signed char save_trace_depth = trace_depth;
#else
    char save_trace_depth = trace_depth;
#endif
    int old_line=current_line;

    if (trace_depth == MAX_TRACE) 
	error(sys_realm,"To deep recursion.\n");

    if (p->fun_p->fun == f_identifier) 
	  {
		register struct lnode_2 *tmp_arg_list;
		register struct object_status *save_ob_status[2];
	        VALUE **new_local_names;
		int i;

		new_local_names=(VALUE **)xalloc(sizeof (VALUE *) * (p->fun_p->num_arg+p->fun_p->num_var+1));

		i = 0;
		if (arg && p->fun_p->num_arg) 
		  {
	         	new_local_names[0] = arg;
	    	        i = 1;
		  }
		if (arg2 && p->fun_p->num_arg>1) 
		  {
	         	new_local_names[1] = arg2;
	    	        i = 2;
		  }

		/* Initialize all arguments. */

		tmp_arg_list = next_arg_list_to_use;
		for (next_arg_list_to_use = 0;tmp_arg_list; i++) 
		  {
                        if(i < p->fun_p->num_arg)
	        	   new_local_names[i] = print_expr(tmp_arg_list->expr1);
		         else (void)print_expr(tmp_arg_list->expr1);

	        	tmp_arg_list = (struct lnode_2 *)tmp_arg_list->expr2;
		  }

		/* The remaining arguments and local variables are now initialized. */
	
		for (; i < p->fun_p->num_var + p->fun_p->num_arg; i++) new_local_names[i] = &const0;

    		save_ob_status[0]=ob_status[0];
    		save_ob_status[1]=ob_status[1];

    		if(ob!=ob_status[0]->ob)
    			ob_status[1]=ob_status[0];

		ob_status[0]=alloc_ob_status();
		ob_status[0]->ob=ob;
		ob_status[0]->ip=ip;
    		ob_status[0]->arg=arg;
		ob_status[0]->local_names=new_local_names;

		return_value = &const0;

		trace_back[++trace_depth].function_name = ++fun_name;
		trace_back[trace_depth].object_name = ob_status[0]->ob?ob_status[0]->ob->name:0;
		trace_back[trace_depth].command_name = command_giver?command_giver->name:0;
		trace_back[trace_depth].prog_name=ip?ip->name:ob->name;
		trace_back[trace_depth].line =0;

		(void)print_expr(p->fun_p->block);

		free_ob_status(ob_status[0]);

    		ob_status[0]=save_ob_status[0];
    		ob_status[1]=save_ob_status[1];

		stop_function = 0;
		trace_depth = save_trace_depth;
		current_line=old_line;

		/*
	 	 * Now clear the return value pointer, so that we won't return
		 * it again somewhere else.
	 	 */

		tmp_value = return_value;
		return_value = &const0;

		/* now free the fun_p pointer as it's no longer needed. */

		if(!tmp_value) return &const0;

		return tmp_value;
     }
   fatal("Illegal function type.\n");
}

VALUE *print_expr_list(p)
    register LNODE *p;
{
    if (!p) return 0;
#ifdef DEBUG
    if (p->fun != f_cons) fatal("Bad type to print_expr_list()\n");
#endif
    return print_expr(p->a1);
}

VALUE *get_one_expr(pp, from)
    register LNODE **pp;
    char *from;
{
    register VALUE *v;

    if (!*pp)
      if (!from) return 0;
         else error(ob_status[0]->ob->realm,"Wrong number of arguments to %s\n", from);

    v = print_expr((*pp)->a1);
    *pp = (*pp)->a2;
    return v;
}

/*
 * Evaluate an expression. It is guaranteed that print_expr() never
 * returns a null pointer.
 */

VALUE *print_expr(p)
    register LNODE *p;
{
    register VALUE *ret;

    if(!p) return &const0;

#ifdef DEBUG
	/* if the system is crashing use this code to test the constants */
    if (const1.u.n_int != 1) fatal("Change in constant 1\n");
    if (const0.u.n_int != 0) fatal("Change in constant 0\n");
#endif

    if (check_object(ob_status[0]->ob))
		ob_status[0]->ob->wl->cost++;

    current_line= p->line & ~L_MASK;
    trace_back[trace_depth].line=current_line;

    if (break_flag) return &const0;

    if (++eval_cost > cf.max_cost) 
     {
	debug_message(ob_status[0]->ob->realm,"eval_cost to big %d\n", eval_cost);
	error(ob_status[0]->ob->realm,"To long evaluation. Execution aborted.\n");
     }

    if(switch_arg)
     {
	if(!case_match)
		if(p->fun!=f_case && p->fun!=f_block) return &const0;

        if(case_match==2 && p->fun!=f_block && p->fun!=f_default)
		return &const0;
    }

    if(!(ret=p->fun(p)) || 
       (ret->type==T_OBJECT && !check_object(ret->u.ob))) return &const0;

    return ret;
}

VALUE *f_block(p)
	register LNODE *p;
{
	register char *block;
	register struct lnode_block *lb;
	int i;

	lb = (struct lnode_block *)p;
	block = lb->block;

	for (i=0; i < lb->num_nodes && !stop_function && !break_flag; i++) 
	  {
	    if (!check_object(ob_status[0]->ob) &&
 	      ((struct lnode *)block)->fun != f_return) 
		{
			stop_function = 1;
			return_value = &const0;
			break;
   	        }

	    if(switch_arg && ((struct lnode *)block)->fun==f_default)
		case_def=p;

	    (void)print_expr((struct lnode *)block);

	    block += lnode_size[((struct lnode *)block)->line >> L_SHIFT];
	  }
	return &const0;
}

VALUE *f_cons(p)
   register LNODE *p;			 /* Linked list of statements. */
{
	while(p && !stop_function && !break_flag) 
	  {
    		if (!check_object(ob_status[0]->ob) && p->a1->fun != f_return) 
		  {
			return_value = &const0;
			stop_function = 1;
			break;
   	          }

		(void)print_expr(p->a1);
		p = p->a2;
	  }
        return &const0;
}

VALUE *f_comma(p)
	register LNODE *p;
{
    register VALUE *ret= &const0;

	while(p && !stop_function && !break_flag) 
	 {
	    if (!check_object(ob_status[0]->ob) && p->a1->fun != f_return) 
		  {
			return_value = &const0;
			stop_function = 1;
			break;
	   	  }

		ret = print_expr(p->a1);
		p = p->a2;
	}

   return ret;
}

VALUE *f_land(p)
	register LNODE *p;
{
	register VALUE *arg;

	arg = print_expr(p->a1);

	if(!arg || (arg->type==T_INT && !arg->u.n_int) || 
	   (arg->type==T_FLOAT && !arg->u.n_float)) return &const0;

	arg = print_expr(p->a2);

	if(!arg || (arg->type==T_INT && !arg->u.n_int) ||
	   (arg->type==T_FLOAT && !arg->u.n_float)) return &const0;

	return &const1;
}

VALUE *f_lor(p)
	register LNODE *p;
{
	register VALUE *ret;

	ret = print_expr(p->a1);

	if(ret && (numchk(ret,T_NUMBER) || (ret->type==T_INT && ret->u.n_int)
	   || (ret->type==T_FLOAT && ret->u.n_float))) 
			return ret;

	ret = print_expr(p->a2);

	if(ret && (numchk(ret,T_NUMBER) || (ret->type==T_INT && ret->u.n_int)
          || (ret->type==T_FLOAT && ret->u.n_float))) 
		return ret;

	return &const0;
}

VALUE *f_gt(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	if (!strchk(arg1,0) && !strchk(arg2,0)) 
	  {
		if (strcmp(arg1->u.string, arg2->u.string) > 0) return &const1;
	        return &const0;
	  } 
	if(numchk(arg1,T_NUMBER)) do_error("1st","'>'");
	if(numchk(arg2,T_NUMBER)) do_error("2nd","'>'");

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
   			  {
			     if(arg1->u.n_int > arg2->u.n_int)
			        return &const1;
			  }
		        else if((double)arg1->u.n_int > arg2->u.n_float) 
				  return &const1;

	                return &const0;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
	  		   {
			      if(arg1->u.n_float > arg2->u.n_float)
		                     return &const1; 
		           }
			 else if(arg1->u.n_float > (double)arg2->u.n_int)
				 return &const1;
	 }

     return &const0;
}

VALUE *f_ge(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret= &const0;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	if (!strchk(arg1,0) && !strchk(arg2,0)) 
	  {
   		if (strcmp(arg1->u.string, arg2->u.string) >= 0) ret = &const1;
	 		else ret = &const0;
   		return ret;
	  }

    if(numchk(arg1,T_NUMBER)) do_error("1st","'>='");
	if(numchk(arg2,T_NUMBER)) do_error("2nd","'>='");

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
	   		{	if(arg1->u.n_int >= arg2->u.n_int) ret= &const1; }
			else if((double)arg1->u.n_int >= arg2->u.n_float) ret= &const1;
			 break;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
			{	if(arg1->u.n_float >= arg2->u.n_float) ret= &const1; }
			else if(arg1->u.n_float >= (double)arg2->u.n_int) ret= &const1;
	 }
	return ret;
}

VALUE *f_lt(p)
	register LNODE *p;
{
	register VALUE *ret= &const0,*arg1,*arg2;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	if (!strchk(arg1,0) && !strchk(arg2,0)) 
	  {
	    if (strcmp(arg1->u.string, arg2->u.string) < 0) ret = &const1;
		return ret;
	  }
	if(numchk(arg1,T_NUMBER)) do_error("1st","'<'");
	if(numchk(arg2,T_NUMBER)) do_error("2nd","'<'");

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
   				{ if(arg1->u.n_int < arg2->u.n_int) ret= &const1; }
			else if((double)arg1->u.n_int < arg2->u.n_float) ret= &const1;
			 break;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
			{	if(arg1->u.n_float < arg2->u.n_float) ret= &const1; }
			else if(arg1->u.n_float < (double)arg2->u.n_int) ret= &const1;
	 }
	return ret;
}

VALUE *f_le(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret= &const0;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	if (!strchk(arg1,0) && !strchk(arg2,0)) 
	  {
	    if (strcmp(arg1->u.string, arg2->u.string) <= 0) ret = &const1;
		return ret; 
	  } 

	if(numchk(arg1,T_NUMBER)) do_error("1st","'<='");
   	if(numchk(arg2,T_NUMBER)) do_error("2nd","'<='");

	switch(arg1->type)
	  {
		case T_INT:
			if(arg2->type==T_INT)
	   		{	if(arg1->u.n_int <= arg2->u.n_int) ret= &const1; }
			else if((double)arg1->u.n_int <= arg2->u.n_float) ret= &const1;
			 break;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
			{	if(arg1->u.n_float <= arg2->u.n_float) ret= &const1; }
			else if(arg1->u.n_float <= (double)arg2->u.n_int) ret= &const1;
	 }
	return ret;
}

VALUE *f_eq(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	ret = alloc_value();
	ret->type = T_INT;

    if(!numchk(arg1,T_NUMBER) && !numchk(arg2,T_NUMBER))
		switch(arg1->type)
		 {
			case T_INT:
				if(arg2->type==T_INT)
	   			{	if(arg1->u.n_int == arg2->u.n_int) ret= &const1; }
				else if((double)arg1->u.n_int == arg2->u.n_float) ret= &const1;
				 break;

			case T_FLOAT:
				 if(arg2->type==T_FLOAT)
				{	if(arg1->u.n_float == arg2->u.n_float) ret= &const1; }
				else if(arg1->u.n_float == (double)arg2->u.n_int) ret= &const1;
		 }
  	   else if (!pointchk(arg1) && !pointchk(arg2))
	   			ret->u.n_int = arg1->u.vec == arg2->u.vec;
	 		else if (arg1->type==T_STRING && arg2->type==T_STRING) 
	   			 ret->u.n_int = !strcmp(arg1->u.string, arg2->u.string);
					 else if (!objchk(arg1) && !objchk(arg2))
					    ret->u.n_int = arg1->u.ob == arg2->u.ob;
							 else ret->u.n_int = 0;
	return ret;
}

VALUE *f_ne(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret;

	arg1 = print_expr(p->a1);
	arg2 = print_expr(p->a2);

	ret = alloc_value();
	ret->type = T_INT;

	if (!numchk(arg1,T_NUMBER) && !numchk(arg2,T_NUMBER))
		switch(arg1->type)
		 {
			case T_INT:
				if(arg2->type==T_INT)
	   			{	if(arg1->u.n_int != arg2->u.n_int) ret= &const1; }
				else if((double)arg1->u.n_int != arg2->u.n_float) ret= &const1;
				 break;

			case T_FLOAT:
				 if(arg2->type==T_FLOAT)
				{	if(arg1->u.n_float != arg2->u.n_float) ret= &const1; }
				else if(arg1->u.n_float != (double)arg2->u.n_int) ret= &const1;
		 }
	   else if (arg1->type==T_STRING && arg2->type==T_STRING) 
  			    ret->u.n_int = strcmp(arg1->u.string, arg2->u.string);
				  else if (!pointchk(arg1) && !pointchk(arg2)) 
				    ret->u.n_int = arg1->u.vec != arg2->u.vec;
					  else if (!objchk(arg1) && !objchk(arg2))
						 ret->u.n_int = arg1->u.ob != arg2->u.ob;
					        else ret->u.n_int = 1;
	return ret;
}

VALUE *f_if(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);
	if (arg && (numchk(arg,T_NUMBER) || (arg->type==T_INT && arg->u.n_int)
	    || (arg->type==T_FLOAT && arg->u.n_float)))
			 ret=print_expr(p->a2);
	   else if (p->a3) ret=print_expr(p->a3);
	return ret;
}

VALUE *f_argument(p)
	register LNODE *p;
{
	if (!ob_status[0]) return &const0;
	return ob_status[0]->arg;
}

VALUE *f_identifier(p)
	register LNODE *p;
{
	return copy_svalue(find_value((struct lnode_number *)p));
}

VALUE *f_return(p)
	register LNODE *p;
{
	if (p->a1) return_value = print_expr(p->a1);
		else return_value = &const0;

	stop_function = 1;
	return &const0;
}

VALUE *f_break(p)
	LNODE *p;
{
	if (!break_level) error(ob_status[0]->ob->realm,"Illegal break statement!\n");
	break_flag = 1;
    return &const0;
}

VALUE *f_continue(p)
	LNODE *p;
{
	if (!break_level || switch_arg) error(ob_status[0]->ob->realm,"Illegal continue statement!\n");

	break_flag=2;
	return &const0;
}

VALUE *f_const0(p)
	LNODE *p;
{
	return &const0;
}

VALUE *f_const1(p)
	LNODE *p;
{
	return &const1;
}

VALUE *f_int(p)
	register LNODE *p;
{
	return make_number(((struct lnode_number *)p)->number,0.0,0);
}

VALUE *f_float(p)
	register LNODE *p;
{
	return make_number(0,((struct lnode_number *)p)->n_float,1);
}

VALUE *f_assign(p)
	register LNODE *p;
{
	register VALUE *ret;

	ret = print_expr(p->a2);
	assign(p->a1, ret);
	return ret;
}

VALUE *f_function(p)
	register LNODE *p;
{
	register struct lnode_funcall *f = (struct lnode_funcall *)p;

    /*
     * Set the linked list of arguments in a global pointer.
     * prinf_function() will find it there.
     * Not a pretty solution, but a simple way of send more than
     * one argument to functions.
     */

    next_arg_list_to_use = (struct lnode_2 *)p->a1;

    if(!f->fun_p->fun_p) return apply(0,f->name,ob_status[0]->ob,0,0);

    return apply(f->fun_p, f->name,ob_status[0]->ob,0,0);
}

VALUE *f_aggregate(p)
	register LNODE *p;
{
	/* This is where and how we make an array from a text array.
   	   ie. ({1,1,1,1}) is taken and an array is returned with 4 elelments
   	   each with the value of 1.
 	*/

	VALUE *ret;
	register LNODE *l;
	unsigned short num;

	for (num = 0, l = p->a1; l; l = l->a2) num++;

	ret = allocate_array(num);

	for (num = 0, l = p->a1; l; num++, l = l->a2)
        	assign_svalue(&ret->u.vec->item[num], print_expr(l->a1),0);

	return ret;
}

VALUE *f_not(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);

	if (!arg || (arg->type==T_INT && !arg->u.n_int) ||
		(arg->type==T_FLOAT && !arg->u.n_float))
		 ret = &const1;
    return ret;
}

VALUE *f_compl(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);

	if (numchk(arg,T_INT)) error(ob_status[0]->ob->realm,"Bad argument to '~'\n");
		ret = make_number(~ arg->u.n_int,0.0,0);
	return ret;
}

VALUE *f_negate(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);

	if (numchk(arg,T_NUMBER)) error(ob_status[0]->ob->realm,"Bad argument to unary '-'\n");

	if(arg->type==T_INT) ret = make_number(- arg->u.n_int,0.0,0);
	  else ret=make_number(0,- arg->u.n_float,1);

	return ret;
}

VALUE *f_inc(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);

	if (numchk(arg,T_NUMBER) && strchk(arg,0)) 
		error(ob_status[0]->ob->realm,"Bad argument to '++' (pre)\n");

   	if(!numchk(arg,T_NUMBER))
  	  {
		if(arg->type==T_INT) ret = make_number(arg->u.n_int+1,0.0,0);
			else ret=make_number(0,arg->u.n_float+1,1);

		assign(p->a1,ret);
	  }
 	else
	  { 
		if(!arg->u.string) error(ob_status[0]->ob->realm,"bad call to '++' (pre) on string.\n");

		ret=make_string(&arg->u.string[1]);
		assign(p->a1,ret);
      }
	return ret;
}

VALUE *f_dec(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr(p->a1);

	if (numchk(arg,T_NUMBER)) error(ob_status[0]->ob->realm,"Bad argument to '--' (pre)\n");

  	if(arg->type==T_INT) ret = make_number(arg->u.n_int-1,0.0,0);
		else ret=make_number(0,arg->u.n_float-1,1);

	assign(p->a1,ret);
	return ret;
}

VALUE *f_post_inc(p)
	register LNODE *p;
{
	register VALUE *arg,*ret = print_expr(p->a1);

	if (numchk(ret,T_NUMBER) && strchk(ret,0))
	 	error(ob_status[0]->ob->realm,"Bad argument to '++' (post)\n");
	if(!numchk(ret,T_NUMBER))
	  {
		if(ret->type==T_INT) arg = make_number(ret->u.n_int+1,0.0,0);
			else arg=make_number(0,ret->u.n_float+1,1);

		assign(p->a1,arg);
	  }
	else
 	  { 
		if(!ret->u.string) error(ob_status[0]->ob->realm,"Bad call to '++' (post) on string.\n");

		arg=make_string(&ret->u.string[1]);
   		assign(p->a1,arg);
	  }
	return ret;
}

VALUE *f_post_dec(p)
	register LNODE *p;
{
	register VALUE *arg,*ret = print_expr(p->a1);

	if (numchk(ret,T_NUMBER)) error(ob_status[0]->ob->realm,"Bad argument to '--' (post)\n");

	if(ret->type==T_INT) arg = make_number(ret->u.n_int-1,0.0,0);
		else arg=make_number(0,ret->u.n_float-1,0);

	assign(p->a1,arg);
	return ret;
}

VALUE *f_call_other(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret;
	LNODE *l=p->a1;

 	arg1 = get_one_expr(&l, "call_other");
 	if(!numchk(arg1,T_NUMBER)) do_error("1st","call_other");

 	arg2 = get_one_expr(&l, "call_other");
 	if(!numchk(arg2,T_NUMBER)) do_error("2nd","call_other");

    /*
     * Send the rest of the arguments in the linked list,
     * unevaluated. It is thus possible to send more than one
     * argument.
     */

 	next_arg_list_to_use = (struct lnode_2 *)l;

 	if(pointchk(arg1) && pointchk(arg2))
		return call_other(arg1, arg2->u.string,0);

	if(!pointchk(arg1))
	  {
	    int i;

	    ret=allocate_array(arg1->u.vec->size);

	    for(i=0;i<arg1->u.vec->size;i++)
	     {
		VALUE v;

		if(arg1->u.vec->item[i].type!=T_STRING && 
		   arg1->u.vec->item[i].type!=T_OBJECT)
	          { 
		   debug_message(ob_status[0]->ob->realm,"call_other: arg1 - Bad data type in array, must be an object or string.\n");
		   continue;
		  }

		v.type=arg1->u.vec->item[i].type;
		v.u.ob=arg1->u.vec->item[i].u.ob;
		v.u.string=arg1->u.vec->item[i].u.string;

		if(!pointchk(arg2))
		  {
		    int c;

		    assign_svalue(&ret->u.vec->item[i],allocate_array(arg2->u.vec->size),0);
		    for(c=0;c<arg2->u.vec->size;c++) 
		     {
			if(arg2->u.vec->item[c].type!=T_STRING)
			{
			   debug_message(ob_status[0]->ob->realm,"call_other: arg2 - Bad data type in array, must be a string.\n");
		    	   continue;
			}
			assign_svalue(&ret->u.vec->item[i].u.vec->item[c],
				      call_other(&v,arg2->u.vec->item[c].u.string,0),0);
		     }
		  }
		else assign_svalue(&ret->u.vec->item[i],call_other(&v,arg2->u.string,0),0);
	       }
            }
	  else 
	    {
	       int c;

	       ret=allocate_array(arg2->u.vec->size);

	       for(c=0;c<arg2->u.vec->size;c++) 
		  assign_svalue(&ret->u.vec->item[c],call_other(arg1,arg2->u.vec->item[c].u.string,0),0);
	     }
      return ret;
}

VALUE *f_numberp(p)
	register LNODE *p;
{
	register VALUE *arg;
#ifdef AIX
	signed char res;
#else
	char res;
#endif
 
	arg = print_expr_list(p->a1);

	switch(arg->type)
	  {
		case T_INT:
			res=1;
			break;

		case T_FLOAT:
			res=2;
			break;

		default:
			res=0;
	   }
	return make_number(res,0.0,0);
}

VALUE *f_stringp(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr_list(p->a1);
	if(!strchk(arg,0)) ret= &const1;
    return ret;
}

VALUE *f_objectp(p)
	register LNODE *p;
{
	register VALUE *arg, *ret= &const0;

	arg = print_expr_list(p->a1);
	if (!objchk(arg)) ret = &const1;
    return ret;
}

VALUE *f_pointerp(p)
	register LNODE *p;
{
	register VALUE *arg,*ret= &const0;

	arg = print_expr_list(p->a1);
	if (!pointchk(arg)) ret = &const1;
	return ret;
}

VALUE *f_add(p)
	LNODE *p;
{
	return f_add_eq(p);
}

VALUE *f_add_eq(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret= &const0;
	int len,len2;
	char buff[20],*temp1,*temp2,cmd[5];
		
	if(p->fun==f_add) (void)strcpy(cmd,"'+'");
		else (void)strcpy(cmd,"'+='");

	arg1=print_expr(p->a1);
	arg2=print_expr(p->a2);

	if(!strchk(arg1,0) || !strchk(arg2,0))
	  {
		extern char *save_array PROT((VECTOR *,int));

		if(!strchk(arg1,0))
			temp1=string_copy(arg1->u.string);
		  else if(!objchk(arg1))
			temp1=string_copy(arg1->u.ob->name);
			else if(!pointchk(arg1))
			  temp1=save_array(arg1->u.vec,1);
			 else if(!numchk(arg1,T_NUMBER))
				{
				   if(arg1->type==T_FLOAT) 
						(void)sprintf(buff,"%lf",arg1->u.n_float);
					  else (void)sprintf(buff,"%d",arg1->u.n_int);
				   temp1=string_copy(buff);
				}
			  else do_error("1st",cmd);

		len=strlen(temp1);

		if(!strchk(arg2,0)) temp2=string_copy(arg2->u.string);
		  else if(!objchk(arg2))
			temp2=string_copy(arg2->u.ob->name);
			  else if(!pointchk(arg2))
				temp2=save_array(arg2->u.vec,1);
			 	 else if(!numchk(arg2,T_NUMBER))
				  {
					if(arg2->type==T_INT) (void)sprintf(buff,"%d",arg2->u.n_int);
						else (void)sprintf(buff,"%lf",arg2->u.n_float);
					temp2=string_copy(buff);
				 }
			 else {free(temp1); do_error("2nd",cmd);}

		len2=strlen(temp2);

	        temp1 =(char *) realloc(temp1,len+len2+1);
	        (void)strcat(temp1, temp2);

	        ret=make_string(temp1);

		free(temp1);
		free(temp2);

		if(p->fun==f_add_eq) assign(p->a1,ret);
	    return ret;
	   }
	  if (!numchk(arg1,T_INT) && !numchk(arg2,T_INT)) {
	    ret=make_number(arg1->u.n_int + arg2->u.n_int,0.0,0);
		if(p->fun==f_add_eq) assign(p->a1,ret);
	    return ret;
	  }
	 if(!numchk(arg1,T_NUMBER) && !numchk(arg2,T_NUMBER)) {
		double i;
	
		if(arg1->type==T_INT) i=(double)arg1->u.n_int;
			else i=arg1->u.n_float;
		if(arg2->type==T_INT) i+=(double)arg2->u.n_int;
			else i+=arg2->u.n_float;
		ret=make_number(0,i,1);
	    if(p->fun==f_add_eq) assign(p->a1,ret);
		return ret;
	   }
	  if (!pointchk(arg1) && !pointchk(arg2)) {
	    ret=add_array(arg1,arg2);
		if(p->fun==f_add_eq) assign(p->a1,ret);
	    return ret;
	   } 
    error(ob_status[0]->ob->realm,"Bad type of arg to %s\n",cmd);
}

VALUE *f_subtract(p)
	register LNODE *p;
{
	return f_sub_eq(p);
}

VALUE *f_sub_eq(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret= &const0;
	char cmd[5];

	if(p->fun==f_sub_eq) (void)strcpy(cmd,"'-='");
		else (void)strcpy(cmd,"'-'");

	arg1 = print_expr(p->a1);

	if (numchk(arg1,T_NUMBER)) do_error("1st",cmd);

	arg2 = print_expr(p->a2);

	if (numchk(arg2,T_NUMBER)) do_error("2nd",cmd);

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
   				ret = make_number(arg1->u.n_int - arg2->u.n_int,0.0,0);
			  else ret=make_number(0,(double)arg1->u.n_int - arg2->u.n_float,1);
			 break;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
				ret=make_number(0,arg1->u.n_float - arg2->u.n_float,1);
			  else ret=make_number(0,arg1->u.n_float - (double)arg2->u.n_int,1);
	 }
	if(p->fun==f_sub_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_multiply(p)
	register LNODE *p;
{
	return f_mult_eq(p);
}

VALUE *f_mult_eq(p)
	register LNODE *p;
{
	register VALUE *arg1,*arg2,*ret= &const0;
	char cmd[5];

	if(p->fun==f_mult_eq) (void)strcpy(cmd,"'*='");
		else (void)strcpy(cmd,"'*'");

	arg1 = print_expr(p->a1);
	if (numchk(arg1,T_NUMBER)) do_error("1st",cmd);

	arg2 = print_expr(p->a2);
	if (numchk(arg2,T_NUMBER)) do_error("2nd",cmd);

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
   				ret = make_number(arg1->u.n_int * arg2->u.n_int,0.0,0);
			else ret=make_number(0,(double)arg1->u.n_int * arg2->u.n_float,1);
			 break;

		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
				ret=make_number(0,arg1->u.n_float * arg2->u.n_float,1);
			else ret=make_number(0,arg1->u.n_float * (double)arg2->u.n_int,1);
	 }
	if(p->fun==f_mult_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_and(p)
	register LNODE *p;
{
	return f_and_eq(p);
}

VALUE *f_and_eq(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*ret= &const0;
	char cmd[5];

	if(p->fun==f_and) (void)strcpy(cmd,"'&'");
		else (void)strcpy(cmd,"'&='");

	arg = print_expr(p->a1);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1 = print_expr(p->a2);
	if (numchk(arg1,T_INT)) do_error("2nd",cmd);

	ret = make_number(arg->u.n_int & arg1->u.n_int,0.0,0);
	if(p->fun==f_and_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_or(p)
	register LNODE *p;
{
	return f_or_eq(p);
}

VALUE *f_or_eq(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*ret= &const0;
	char cmd[5];

	if(p->fun==f_or) (void)strcpy(cmd,"'|'");
		else (void)strcpy(cmd,"'|='");

	arg = print_expr(p->a1);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1 = print_expr(p->a2);
	if (numchk(arg1,T_INT)) do_error("2nd",cmd);

	ret = make_number(arg->u.n_int | arg1->u.n_int,0.0,0);
	if(p->fun==f_or_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_xor(p)
	register LNODE *p;
{
	return f_xor_eq(p);
}

VALUE *f_xor_eq(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*ret= &const0;
	char cmd[5];

	if(p->fun==f_xor) (void)strcpy(cmd,"'^'");
		else (void)strcpy(cmd,"'^='");

	arg = print_expr(p->a1);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1= print_expr(p->a2);
	if (numchk(arg1,T_INT)) do_error("2nd",cmd);

	ret = make_number(arg->u.n_int ^ arg1->u.n_int,0.0,0);
	if(p->fun==f_xor_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_lsh(p)
	register LNODE *p;
{
	return f_lsh_eq(p);
}

VALUE *f_lsh_eq(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*ret= &const0;
	char cmd[6];

	if(p->fun==f_lsh) (void)strcpy(cmd,"'<<'");
		else (void)strcpy(cmd,"'<<='");

	arg = print_expr(p->a1);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1 = print_expr(p->a2);
	if (numchk(arg1,T_INT)) do_error("2nd",cmd);

	ret = make_number(arg->u.n_int << arg1->u.n_int,0.0,0);
	if(p->fun==f_lsh_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_rsh(p)
	register LNODE *p;
{
	return f_rsh_eq(p);
}

VALUE *f_rsh_eq(p)
	register LNODE *p;
{
	register VALUE *arg,*arg1,*ret= &const0;
	char cmd[6];

	if(p->fun==f_rsh) (void)strcpy(cmd,"'>>'");
		else (void)strcpy(cmd,"'>>='");

	arg = print_expr(p->a1);
	if (numchk(arg,T_INT)) do_error("1st",cmd);

	arg1 = print_expr(p->a2);
	if (numchk(arg1,T_INT)) do_error("2nd",cmd);

	ret = make_number(arg->u.n_int >> arg1->u.n_int,0.0,0);
	if(p->fun==f_rsh_eq) assign(p->a1, ret);
	return ret;
}

VALUE *f_local_name(p)
	LNODE *p;
{
	return ob_status[0]->local_names[(int)p->a1];
}

VALUE *f_divide(p)
	LNODE *p;
{
	return f_div_eq(p);
}

VALUE *f_div_eq(p)
	LNODE *p;
{
	VALUE *arg1,*arg2,*ret= &const0;
	char cmd[5];

	if(p->fun==f_div_eq) (void)strcpy(cmd,"'/='");
		else (void)strcpy(cmd,"'/'");

	arg1 = print_expr(p->a1);
	if (numchk(arg1,T_NUMBER)) do_error("1st",cmd);

	arg2 = print_expr(p->a2);
	if (numchk(arg2,T_NUMBER)) error("2nd",cmd);

	 if ((arg2->type==T_INT && !arg2->u.n_int) ||
		 (arg2->type==T_FLOAT && !arg2->u.n_float))
			 error(ob_status[0]->ob->realm,"Division by zero.");

	switch(arg1->type)
	 {
		case T_INT:
			if(arg2->type==T_INT)
   				ret = make_number(arg1->u.n_int / arg2->u.n_int,0.0,0);
			else ret=make_number(0,(double)arg1->u.n_int / arg2->u.n_float,1);
			 break;
		case T_FLOAT:
			 if(arg2->type==T_FLOAT)
				ret=make_number(0,arg1->u.n_float / arg2->u.n_float,0);
			else ret=make_number(0,arg1->u.n_float / (double)arg2->u.n_int,1);
	}
  if(p->fun==f_div_eq) assign(p->a1, ret);
  return ret;
}

VALUE *f_mod(p)
	LNODE *p;
{
	return f_mod_eq(p);
}
