#include <memory.h>
#include "lint.h"
#include "lnode.h"
#include "object.h"
#include "lint2.h"
#include "lang.h"
#include "sort.h"

/*  Sort was developed with the asssistance of Rust from TMI-II.  
    Without his imput I think this would have taken a long time to write,
    being my first jaunt into sorting routines.

    Also, I think the result would have been slower as well.
*/

extern void assign_svalue();
extern int abs();

extern VALUE *copy_svalue PROT((struct svalue *));
extern VALUE *allocate_array PROT((unsigned short));

void trans_svalue(s,s2)
	register struct svalue *s,*s2;
{
	memcpy((char *)s,(char *)s2,sizeof (struct svalue));
}

struct sort_list *set_element(new,from,step,size,pos,top,ob,fun)
	struct sort_list *new,*from;
	int step,size,pos;
	struct sort_list *top;
	struct object *ob;
	struct fun_p *fun;
{
	struct sort_list *test;
	int i,s;
	VALUE *ret;

     

#if 0
  if(step>0) for(test=from,i=0;i<step && test ;i++)
     { 
       from=test; 
       test=from->next; 
       pos++;
     }
    else for(test=from,i=step;i<0 && test ;i++)
     { 
	from=test;
	test=from->prev;
	pos--;
     }
printf("Size: %4d  Pos: %3d  Step:%3d - %s %s\n",size,pos,step,new->v.u.string,from->v.u.string);
#else
 if(step>0)
   {
      for(test=from,i=step;i>0;)
	{
	   if(i>=16) {from=F15(test);test=F1(from);i-=16;pos+=16;}
	     else if(i>=8) {from=F7(test);test=F1(from);i-=8;pos+=8;}
	       else if(i>=4) {from=F3(test);test=F1(from);i-=4;pos+=4;}
	         else if(i>=2) {from=F1(test);test=F1(from);i-=2;pos+=2;}
	           else {from=test;test=F1(from);i--;pos++;}
        }
   }
 else
   {
      for(test=from,i=step;i<0;)
        {
	   if(i<= -16) {from=B15(test);test=B1(from);i+=16;pos-=16;}
	     else if(i<= -8) {from=B7(test);test=B1(from);i+=8;pos-=8;}
	       else if(i<= -4) {from=B3(test);test=B1(from);i+=4;pos-=4;}
	         else if(i<= -2) {from=B1(test);test=B1(from);i+=2;pos-=2;}
	           else {from=test;test=B1(from);i++;pos--;}
        }
   }

#endif

  if(!test) 
    {
	if(step>0) pos--;
	  else pos++;
	test=from;
    }

  ret=apply(fun,0,ob,copy_svalue(&new->v),copy_svalue(&test->v));
  if(numchk(ret,T_INT)) ret= &const0;
		
  if(ret->u.n_int<1)
	if(!test->prev || step==1 || !ret->u.n_int)
	  {
	    if(test==top) top=new;
	    new->next=test;
	    new->prev=test->prev;
	    test->prev=new;
	    if(new->prev) new->prev->next=new;
	  }
        else
	  {
	    if(step<0) s=step/2;
		else s=step/-2;

            if(step%2) s--;

	    if(!s) s= -1;

	    top=set_element(new,test,s,size,pos,top,ob,fun);
	  }
   else if(!test->next || step== -1)
	   {
	     new->next=test->next;
	     new->prev=test;
	     if(new->next) new->next->prev=new;
	     test->next=new;
	   }
	else 
	 { 
	  if(step>0) s=step/2;
		else s=step/-2;

          if(step%2) s++;

	  if(!s) s=1;

	  top=set_element(new,test,s,size,pos,top,ob,fun);
	}	

  return top;
}

void sort_array(vec, ob, fun, dir)
	VECTOR *vec;
	OBJECT *ob;
	struct fun_p *fun;
	int dir;
{
  int c,size=2,pos=2;
  struct sort_list *top,*mid;
  char *BLOCK,*FREE_BLOCK;
  struct svalue *h;
  VALUE *ret;

  ret=apply(fun,0,ob,copy_svalue(&vec->item[0]),copy_svalue(&vec->item[1]));

  if(vec->size>2)
   {
	FREE_BLOCK=BLOCK=xalloc((sizeof (struct sort_list))*vec->size);

	mid=(struct sort_list *)BLOCK;
	BLOCK+=sizeof(struct sort_list);

	top=(struct sort_list *)BLOCK;
	BLOCK+=sizeof(struct sort_list);

	top->next=mid;
	top->prev=0;
	mid->next=0;
	mid->prev=top;
   }

  if(!numchk(ret,T_INT) && ret->u.n_int>0)
    {
	if(vec->size==2)
	  {
	     struct svalue p;

	     trans_svalue(&p,&vec->item[0]);
	     trans_svalue(&vec->item[0],&vec->item[1]);
	     trans_svalue(&vec->item[1],&p);
	
	     return;
	  }

	trans_svalue(&top->v,&vec->item[1]);
	trans_svalue(&mid->v,&vec->item[0]);
    }
   else
    {
	if(vec->size==2) return;

	trans_svalue(&top->v,&vec->item[0]);
	trans_svalue(&mid->v,&vec->item[1]);
    }
	
  for(c=2;c<vec->size;c++)
   {
       int step;
       struct sort_list *new;

       ret=apply(fun,0,ob,copy_svalue(&vec->item[c]),copy_svalue(&mid->v));

       step=size/4;
       if(!step) step=1;

       if(numchk(ret,T_INT) || ret->u.n_int<1) step*= -1;

       new=(struct sort_list *)BLOCK;
       new->next=0;
       new->prev=0;
       trans_svalue(&new->v,&vec->item[c]);

       BLOCK+=sizeof (struct sort_list);


       if(c==2 && step>0)
	{
           mid->next=new;
	   new->prev=mid;
	   size++;
           continue;
        }

       top=set_element(new,mid,step,size,(size/2),top,ob,fun);

       if(c==2) { mid=mid->prev;size++; }
         else if((++size)%2 && step>0) mid=mid->next;
           else if(!(size%2) && step<1) mid=mid->prev;
   }

  if(!dir) for(c=0;c<vec->size;top=top->next,c++)
     trans_svalue(&vec->item[c],&top->v);
       else for(c=vec->size;c>0;top=top->next,c--)
         trans_svalue(&vec->item[c],&top->v);

  vec->sorted=1;

  free(FREE_BLOCK);
}

int bsearch_array(arr,dat,ob,fun)
	register VECTOR *arr;
	register VALUE *dat;
	register OBJECT *ob;
	register struct fun_p *fun;
{
	int s=arr->size,i=s/2,c,ret2=1,step=i;
	
	while(1)
	 {
	    VALUE *ret=apply(fun,0,ob,dat,copy_svalue(&arr->item[i]));	

	    if(numchk(ret,T_INT) || !ret->u.n_int) return i;

	    if(ret->u.n_int<0)
		   if(ret2>0) step=step/-2;
			else step=step/2;
		else if(ret2<0) step=step/-2;
			else step=step/2;

	    if(abs(step)!=1 && step%2) if(step<0) step--;
			 else step++;

	    ret2=ret->u.n_int;
	    i+=step;

	    if((i<=0 && ret2<0) || i>=s) return -1;
         }
}

VALUE *do_insert(arr,dat,pos)
	register VECTOR *arr;
	register VALUE *dat;
	int pos;
{
	VALUE *new=allocate_array((unsigned short)(arr->size+1));
	int c,i;

	for(i=0,c=0;i<new->u.vec->size;i++)
	   if(i!=pos) assign_svalue(&new->u.vec->item[i],0,&arr->item[c++]);
	     else assign_svalue(&new->u.vec->item[i],dat,0);
	   
	return new;
}

VALUE *add_sort(arr,dat,ob,fun)
	register VECTOR *arr;
	register VALUE *dat;
	register OBJECT *ob;
	register struct fun_p *fun;
{
	int s=arr->size,i=s/2,c,ret2=1,step=i,step2=step;
	
	while(1)
	 {
	    VALUE *ret=apply(fun,0,ob,dat,copy_svalue(&arr->item[i]));	

	    if(numchk(ret,T_INT) || !ret->u.n_int) 
		   return do_insert(arr,dat,i);

	    step2=step;

	    if(ret->u.n_int<0)
		   if(ret2>0)
		       if(step==1) 
			     return do_insert(arr,dat,i);
		         else step=step/-2;
		      else step=step/2;
	          	else if(ret2<0)
				if(step== -1)
				     return do_insert(arr,dat,i+1);
				 else step=step/-2;
			       else step=step/2;

	    if(abs(step)!=1 && step2%2) if(step<0) step--;
			 else step++;

	    ret2=ret->u.n_int;
	    i+=step;

	    if(i<=0 && ret2<0)
		return do_insert(arr,dat,0);
	    if(i>=s)
		return do_insert(arr,dat,s);
         }
}
